package com.gx.obe.evaluation;

public class LinkedList {
	//链表节点的个数
    private int initsize;
	
	//链表节点的个数
    private int size;
    
	//头节点
    private Node head;
    
    public LinkedList( int initsize){
    	this.initsize = initsize;
        size = 0;
        head = null;
    }
    
    //链表的每个节点类
    private class Node{
		//每个节点的数据
        private Object data;
		
		//每个节点指向下一个节点的连接
        private Node next;
        
        public Node(Object data){
            this.data = data;
        }
    }
    
    //在链表头添加元素
    public Object addHead(Object obj){
        Node newHead = new Node(obj);
        if(size == 0){
            head = newHead;
        }else{
            newHead.next = head;
            head = newHead;
        }
        size++;
        initsize--;
        return obj;
    }
    
     public Object deleteHead(){
        Object obj = head.data;
        head = head.next;
        size--;
        return obj;
    }
    
     public Node find(Object obj){
        Node current = head;
        int tempSize = size;
        while(tempSize > 0){
            if(obj.equals(current.data)){
                return current;
            }else{
                current = current.next;
            }
            tempSize--;
        }
        return null;
    }
    
     public boolean delete(Object value){
        if(size == 0){
            return false;
        }
        Node current = head;
        Node previous = head;
        while(current.data != value){
            if(current.next == null){
                return false;
            }else{
                previous = current;
                current = current.next;
            }
        }
         if(current == head){
            head = current.next;
            size--;
        }else{
             previous.next = current.next;
            size--;
        }
        return true;
    }
    
     public boolean isEmpty(){
        return (size == 0  && initsize == 0);
    }
    
     public void display(){
        if(size >0){
            Node node = head;
            int tempSize = size;
            //当前链表只有一个节点
            if(tempSize == 1){
                System.out.println(node.data);
                return;
            }
            while(tempSize>0){
                if(node.equals(head)){
                    System.out.print(node.data);
                    System.out.print('\t');
                }else if(node.next == null){
                    System.out.print(node.data);
                    System.out.print('\t');
                }else{
                    System.out.print(node.data);
                    System.out.print('\t');
                }
                node = node.next;
                tempSize--;
            }
            System.out.println();
        }else{//如果链表一个节点都没有，直接打印[]
            System.out.println("[]");
        }
        
    }
    
    public static void main(String[] args) {
    	LinkedList linkedList = new LinkedList(5);
    	linkedList.addHead("A");
    	linkedList.addHead("B");
    	linkedList.addHead("C");
    	linkedList.addHead("D");
    	linkedList.addHead("E");
    	//获取所有链表数据
    	linkedList.display();
    	
    	//删除C这个数据
    	linkedList.delete("C");
    	
    	//获取所有链表数据
    	linkedList.display();
    	
    	System.out.println(linkedList.isEmpty());
         //查找
    	System.out.println(linkedList.find("B").data);
    	System.out.println(linkedList.size);

	}

}
