package com.gx.obe.evaluation.action;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.common.composite.BrowseBidFileComposite;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.ExpertEnum;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.expert.ExpertService;

/**
 * @Description: 浏览招标文件
 * @author guoyr
 */
public class BrowseBiddingFileAction extends Action{
	private ExpertService expertService;
	@Override
	public void run() {
		ActionListener listener = this.getListener();
		TenderProjectEntity tenderProject = this.getTenderProject();
		if(null == expertService){
			expertService = new ExpertService();
		}
		Expert expert = expertService.getExpert(tenderProject.getId(), Constants.USER.getId());
		if(null != expert){
			if(ObjectUtils.equals(expert.getSignType(), ExpertEnum.SIGN)){
				listener.onLoad(this);
				Composite parent = listener.getParentComposite();
				parent.setData("tenderProjectEntity", tenderProject);
				parent.setData("menu", this.getMenu());
				listener.loadComposite(this, new BrowseBidFileComposite(parent, SWT.NONE));
			}else if(ObjectUtils.equals(expert.getSignType(), ExpertEnum.AVOID)){
				MessageDialog.openWarning(this.getListener().getParentComposite().getShell(), "您已经回避！");
			}else {
				MessageDialog.openWarning(this.getListener().getParentComposite().getShell(), "您未签到，请您点击“评标-->签到”");
			}
		}
	}

}
