package com.gx.obe.evaluation.action;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.EvaluationStepEnum;
import com.gx.obe.evaluation.step.composite.FactorEvaluationComposite;
import com.gx.obe.evaluation.step.composite.struct.AiEvaluationComposite;
import com.gx.obe.evaluation.step.composite.struct.EvaluationView;
import com.gx.obe.evaluation.step.listener.ExpertEvaluationListener;
import com.gx.obe.evaluation.step.shell.SelectEvaluationViewShell;
import com.gx.obe.evaluation.step.shell.SelectEvaluationViewShell.SelectEvaluationViewListener;

/** 
 * @Description: 评审视图
 * @author chenxw 
 */
public class EvaluationViewAction extends Action implements SelectEvaluationViewListener {

	private ActionListener listener;
	private Composite composite;

	public void run() {
		listener = this.getListener();
		if(null == listener){
			return;
		}
		
		composite = listener.getParentComposite();
		if(null == composite){
			return;
		}
		
		SelectEvaluationViewShell dialog = new SelectEvaluationViewShell(composite.getShell());
		dialog.addSelectEvaluationViewListener(this);
		dialog.open();
	}

	/** 
	 * @Description: 选择评审视图事件
	 * @author chenxw
	 * @param viewType 
	 */
	public void selectEvaluationView(String viewType) {
		if (null == viewType) {
			return;
		}
		
		listener.onLoad(this);
		composite.setData("tenderProjectEntity", this.getData("tenderProjectEntity"));
		composite.setData("evaluationStep", this.getData("evaluationStep"));
		composite.setData(Constants.CUR_EXPERT, this.getData(Constants.CUR_EXPERT));
		
		EvaluationView evaluationView = null;
		if (viewType.equals(EvaluationStepEnum.EVALUATION_TYPE_COLLECT)) {
			evaluationView = new FactorEvaluationComposite(composite, SWT.NONE);
		} else if (viewType.equals(EvaluationStepEnum.EVALUATION_TYPE_AI)) {
			evaluationView = new AiEvaluationComposite(composite, SWT.NONE);
		}
		
		evaluationView.addExpertEvaluationListener((ExpertEvaluationListener) this.getData("expertEvaluationListener"));
		listener.loadComposite(this, evaluationView);
	}

}
