package com.gx.obe.evaluation.action;

import java.io.File;

import org.eclipse.swt.core.MessageDialog;

import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.evaluation.composite.OpenDocumentComposite;

/**
 * @Description: 进入评标纪律事件
 * @author guoyr
 */
public class NewViewEvaluationLawAction extends Action{

	@Override
	public void run() {
		ActionListener actionListener = this.getListener();
		if(null != actionListener){
			String reviewDisciplineFilePath = FileConstants.PRODUCT_ROOT + File.separator + FileConstants.RESOURCE_FOLDER + File.separator + FileConstants.REVIEW_DISCIPLINE_FILE;
			File reviewDisciplineFile = null;
			if(new File(reviewDisciplineFilePath+FileConstants.DOC).exists()){
				reviewDisciplineFile = new File(reviewDisciplineFilePath+FileConstants.DOC);
			}else if(new File(reviewDisciplineFilePath+FileConstants.DOCX).exists()){
				reviewDisciplineFile = new File(reviewDisciplineFilePath+FileConstants.DOCX);
			}else if(new File(reviewDisciplineFilePath+FileConstants.PDF).exists()){
				reviewDisciplineFile = new File(reviewDisciplineFilePath+FileConstants.PDF);
			}
			if(null != reviewDisciplineFile && reviewDisciplineFile.exists()){
				actionListener.onLoad(this);
				OpenDocumentComposite openDocumentComposite = new OpenDocumentComposite(actionListener.getParentComposite(),reviewDisciplineFile, false, true);
				openDocumentComposite.init();
				actionListener.loadComposite(this, openDocumentComposite);
			}else {
				MessageDialog.openWarning(actionListener.getParentComposite().getShell(), "未找到评审纪律文件！");
			}
		}
	}

}
