package com.gx.obe.evaluation.composite;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.File;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.answer.composite.OtherTenderProjectInfoComposite;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.entity.TorrentFile;
import com.gx.obe.business.enumeration.MenuEnum;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.business.enumeration.UserEnum;
import com.gx.obe.common.composite.BrowseBidFileComposite;
import com.gx.obe.common.composite.ExpertEvlauationProgressComposite;
import com.gx.obe.common.file.dialog.DownloadDecBidFileDialog;
import com.gx.obe.common.file.dialog.DownloadServiceBidFileDialog;
import com.gx.obe.common.file.entity.BidFile;
import com.gx.obe.common.file.entity.BiddingFile;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.shell.MeetingRoomOpenShell;
import com.gx.obe.common.widget.button.RoomOperatorButton;
import com.gx.obe.common.widget.listener.SelectionTenderPackListener;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.thread.SyncThread;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.ExpertEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.InputStreamUtil;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.evaluation.electionExpertLeader.ElectionExpertLeaderComposite;
import com.gx.obe.evaluation.listener.ExpertEvaluationRoomListener;
import com.gx.obe.evaluation.listener.SelectNetWorkListener;
import com.gx.obe.evaluation.shell.ChooseNetWorkToDownLoadShell;
import com.gx.obe.evaluation.shell.SelectShell;
import com.gx.obe.im.dialog.ClientDialog;
import com.gx.obe.listener.EvaluationRoomListener;
import com.gx.obe.meeting.utils.VideoMeetingUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.thread.SyncThreadSet;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.MenuService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.TorrentFileService;
import com.gx.obe.web.service.UserService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.service.expert.ExpertService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import im.IMClientAdapter;
import im.listener.MessageNoticeListener;
import im.listener.NoticeListener;

/**
 * @Description: 
 * @author guoyr
 */
public class ExpertEvalautionRoomHomeComposite extends Composite implements ActionListener{
	
//	private ExpertService expertService = ServiceFactory.getInstance("expertService", ExpertService.class);
//	private UserService userService = ServiceFactory.getInstance("userService", UserService.class);
//	private TenderProjectService tenderProjectService = ServiceFactory.getInstance("tenderProjectService", TenderProjectService.class);
	
	private TenderProjectEntity tenderProject;
	private ExpertEvaluationRoomListener meetingRoomListener;
	private Composite myTenderPackComposite;
	private Composite progressComposite;
	private Composite myEvaluationComposite;
	private StackLayout stackLayout = new StackLayout();
	private boolean isRefreshExpert = false;
	private Composite loadComposite;
	private EvaluationRoomListener myTenderPackPage;
	private EvaluationRoomListener progressPage;
	private EvaluationRoomListener myEvaluationStep;
	private EvaluationRoomListener curPageListener;
	private Composite packageComposite;
	private StyledText packName;
	private Composite topLoadComposite;
	private SelectionTenderPackListener selectionTenderPackListener;
	private UserService userService;
	private ExpertService expertService;
	private MenuService menuService;
	private Menu menu;
	private TenderProjectService tenderProjectService;
	private EvaluationStepService evaluationStepService;
	private MenuFunctionUtils menuFunctionUtils;
	private RoomOperatorButton messageBtn;
	private MessageNoticeListener messageNoticeListener;
	private NoticeListener noticeListener;
	private boolean isShowNoticeImage = false;
	private ClientDialog clientDialog;
	
	{
		LogUtils.logClass(ExpertEvalautionRoomHomeComposite.class);
	}
	
	/**
	 * Create the progressComposite.
	 * @param parent
	 * @param style
	 */
	public ExpertEvalautionRoomHomeComposite(Composite parent, int style) {
		super(parent, SWT.NONE);
		this.tenderProject = (TenderProjectEntity)parent.getData("tenderProjectEntity");
		this.meetingRoomListener = (ExpertEvaluationRoomListener)parent.getData("meetingRoomListener");
		this.menu = (Menu)parent.getData("menu");
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.horizontalSpacing = 0;
		gridLayout.verticalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				IMClientAdapter.getInstance().removeMessageNoticeListener(messageNoticeListener);
				IMClientAdapter.getInstance().removeNoticeListener(noticeListener);
				if(null != clientDialog){
					clientDialog.close();
					clientDialog = null;
				}
			}
		});
		packageComposite = new Composite(this, SWT.NONE);
		packageComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_packageComposite = new GridLayout(1, false);
		gl_packageComposite.marginHeight = 0;
		gl_packageComposite.marginWidth = 0;
		packageComposite.setLayout(gl_packageComposite);
		
		Composite composite = new Composite(packageComposite, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.marginTop = 5;
		gl_composite.marginHeight = 0;
		composite.setLayout(gl_composite);
		
		packName = new StyledText(composite, SWT.READ_ONLY | SWT.CENTER);
		packName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		packName.setAlignment(SWT.CENTER);
		packName.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		packName.setForeground(SWTResourceManager.getColor(100, 100, 100));
		packName.setText("包件名称");
		packName.setToolTipText("包件名称");
		
		topLoadComposite = new Composite(this, SWT.NONE);
		topLoadComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		topLoadComposite.setLayout(stackLayout);
		
		myTenderPackComposite = new Composite(topLoadComposite, SWT.NONE);
		myTenderPackComposite.setLayout(new FillLayout());
		
		progressComposite = new Composite(topLoadComposite, SWT.NONE);
		progressComposite.setLayout(new FillLayout());
		
		myEvaluationComposite = new Composite(topLoadComposite, SWT.NONE);
		myEvaluationComposite.setLayout(new FillLayout());
		
		loadComposite = new Composite(topLoadComposite, SWT.NONE);
		loadComposite.setLayout(new FillLayout());
		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init(){
		menuFunctionUtils = new MenuFunctionUtils();
		if(null == userService){
			userService = new UserService();
		}
		if(null == expertService ){
			expertService = new ExpertService();
		}
		if(null == menuService){
			menuService = new MenuService();
		}
		menu = menuService.getMenutByMenuCode(MenuEnum.EVALUATION_HALL);
		tenderProjectService = new TenderProjectService();
		evaluationStepService = new EvaluationStepService();
		WidgetUtils.setControlVisible(packageComposite, false);
		selectionTenderPackListener = new SelectionTenderPackListener() {
 
			@Override
			public void selectPack(final TenderProjectEntity tenderPack) {
				new SyncThread(new SyncThread.Runnable() {
					public void run() {
						TenderProjectEntity tenderPackTemp = tenderProjectService.getTenderProjectInfo(tenderPack.getId());
						if(null != tenderPackTemp ){
							tenderProject = tenderPackTemp;
						}
						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								loadCurTenderProject(tenderProject);
							} 
						});	
 					}
				}).start();
			}
		};

	
		if(null != tenderProject.getIsPack() && tenderProject.getIsPack().equals(CommonEnum.YES)){
			loadMyTenderPack();
			((GridData)packageComposite.getLayoutData()).exclude = true;
			packageComposite.setVisible(false);
			layout();
		}else {
			
			SyncThreadSet myThreadSet = new SyncThreadSet(new SyncThreadSet.Runnable() {
				public void run() {
					TenderProjectEntity tenderPackTemp = tenderProjectService.getTenderProjectInfo(tenderProject.getId());
					if(null != tenderPackTemp ){
						tenderProject = tenderPackTemp;
					}
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							loadCurTenderProject(tenderProject);
						} 
					});	
				}
			});
			myThreadSet.start();
		}
	
		
		meetingRoomListener.refreshMeetingTitle(tenderProject.getTenderName());
		layout();
		
		addMessageListener();

	}
	private void addMessageListener(){

		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("MY_MESSAGE"))){
			final Image messageImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/message_24.png");
			final Image messageNoticeImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_blue.png");
			// 显示消息提示
			final Runnable showNoticeRunnable = new Runnable() {
				public void run() {
					if(null != messageBtn && !messageBtn.isDisposed()){
						if(isShowNoticeImage){
							messageBtn.setImage(messageNoticeImage);
//						 messageBtn.setForeground(ColorConstants.SKIN_ACTIVE_BG);
							messageBtn.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
							messageBtn.setBackgroundColor(ColorConstants.SKIN_ACTIVE_BG);
						}else {
							messageBtn.setImage(messageImage);
							messageBtn.setBackgroundColor(null);
							messageBtn.setForeground(null);
//						 messageBtn.setForeground(null);
						}
					}
				}
			};
			messageNoticeListener = new MessageNoticeListener(){
				@Override
				public void newMessageNotice(List<String> msgList, List<String> groupMsgList) {
					if(msgList.size() + groupMsgList.size() > 0){
						isShowNoticeImage = !isShowNoticeImage;
						Display.getDefault().syncExec(showNoticeRunnable);
					}else if(isShowNoticeImage){
						isShowNoticeImage = false;
						Display.getDefault().syncExec(showNoticeRunnable);
					}
				}
			};
			
			IMClientAdapter.getInstance().addMessageNoticeListener(messageNoticeListener);
			
		}
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("MY_TASK"))){
			noticeListener = new NoticeListener(CommonEnum.NOTICE_TASK) {
				public void refreshNotice(String notice) {
					System.out.println(notice);
				}
			};
			IMClientAdapter.getInstance().addNoticeListener(noticeListener);
		}
		
	}
	private void clear(){
		for(Control control : loadComposite.getChildren()){
			control.dispose();
		}
	}
	
	/**
	 * @Description: 刷新项目
	 * @author guoyr
	 * @param tenderProjectEntity 
	 */
	public void loadCurTenderProject(TenderProjectEntity tenderProject){
		this.tenderProject = tenderProject;
		loadMyEvaluation();
		if(packageComposite.isDisposed()){
			return ;
		}
		if(null != tenderProject.getParentId() && !packageComposite.getVisible()){
			packName.setText("["+tenderProject.getTenderNo() + "]" + tenderProject.getTenderName());
			packName.setToolTipText("["+tenderProject.getTenderNo() + "]" + tenderProject.getTenderName());
			((GridData)packageComposite.getLayoutData()).exclude = false;
			packageComposite.setVisible(true);
			layout();
		}
		
		progressPage = null;
		myEvaluationStep = null;
		addOperatorBtn(false);
		refreshExpert();
	}
	
	public void refreshAction(){
		if(null != curPageListener){
			curPageListener.refresh(tenderProject);
		}
	}
	
	/**
	 * @Description: 加载包件
	 * @author guoyr 
	 */
	public void loadMyTenderPack(){
		isRefreshExpert = false;
		addOperatorBtn(true);
		if(null == myTenderPackPage){
			for(Control control : myTenderPackComposite.getChildren()){
				control.dispose();
			}
			
			myTenderPackComposite.setData("tenderProjectEntity", tenderProject);
			myTenderPackComposite.setData("meetingRoomListener", meetingRoomListener);
			MyTenderPackageListComposite myTenderPackageListComposite = new MyTenderPackageListComposite(myTenderPackComposite, tenderProject, selectionTenderPackListener, SWT.NONE);
			myTenderPackPage = myTenderPackageListComposite;
			myTenderPackComposite.layout();
		}
		curPageListener = myTenderPackPage;
		stackLayout.topControl = myTenderPackComposite;
		topLoadComposite.layout();
		((GridData)packageComposite.getLayoutData()).exclude = true;
		packageComposite.setVisible(false);
		layout();
		meetingRoomListener.refreshChairsCount(7, null, false, false);
	}
	
	/**
	 * @Description: 推荐组长
	 * @author guoyr
	 * @param curTender 
	 */
	private void recommonedExpertLeader(){
		MeetingRoomOpenShell myEvaluationShell = new MeetingRoomOpenShell(getShell(), tenderProject);

		Expert expert = expertService.getExpert(tenderProject.getId(), Constants.USER.getId());
		if(null == expert){
			expert = new Expert();
		}
		new ElectionExpertLeaderComposite(myEvaluationShell.getParentComposite(), tenderProject, expert);
		
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); // 取得当前屏幕属性
		double w = d.width * 0.8; // 获取屏幕宽度
		double h = d.height * 0.7; // 获取屏幕高度
		myEvaluationShell.setSize((int)w, (int)h);
		SwtUtils.setCenter(myEvaluationShell);
		myEvaluationShell.open();
	}
	/**
	 * @Description: 查看招标文件
	 * @author guoyr
	 * @param curTender 
	 */
	private void viewBidddingFile(){
		Expert expert = expertService.getExpert(tenderProject.getId(), Constants.USER.getId());
		if (null != expert) {
			if (ExpertEnum.AVOID.equals(expert.getSignType())) {
				MessageDialog.openWarning(getShell(), "您已经回避！");
				BidFile.deleteBidFileAction(tenderProject.getId());
				BiddingFile.deleteBidddingFileAction(tenderProject.getId());
				return;
			} else if (!ExpertEnum.SIGN.equals(expert.getSignType())) {
				MessageDialog.openWarning(getShell(), "您未签到，请您点击“评标-->签到”");
				return;
			}
		}

		MeetingRoomOpenShell myEvaluationShell = new MeetingRoomOpenShell(getShell(), tenderProject);
		Composite parent = myEvaluationShell.getParentComposite();
		parent.setData("tenderProjectEntity", tenderProject);
		new OtherTenderProjectInfoComposite(parent,null, SWT.NONE);
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); // 取得当前屏幕属性
		double w = d.width * 0.8; // 获取屏幕宽度
		double h = d.height * 0.7; // 获取屏幕高度
		myEvaluationShell.setSize((int)w, (int)h);
		SwtUtils.setCenter(myEvaluationShell);
		myEvaluationShell.open();
		
	
	}
	/**
	 * @Description: 查看投标文件
	 * @author guoyr
	 * @param actionBtn 
	 * @param curTender 
	 */
	private void viewBidFile(RoomOperatorButton actionBtn) {
		Expert expert = expertService.getExpert(tenderProject.getId(), Constants.USER.getId());
		if (null != expert) {
			if (ObjectUtils.equals(expert.getSignType(), ExpertEnum.AVOID)) {
				MessageDialog.openWarning(getShell(), "您已经回避！");
				BidFile.deleteBidFileAction(tenderProject.getId());
				BiddingFile.deleteBidddingFileAction(tenderProject.getId());
				return;
			} else if (!ExpertEnum.SIGN.equals(expert.getSignType())) {
				MessageDialog.openWarning(getShell(), "您未签到，请您点击“评标-->签到”");
				return;
			}
		}
		if (evaluationStepService.isSealed(tenderProject)) {
			SelectShell shell = new SelectShell(new Shell());
			shell.addItem("明标文件", BidFile.PUBLIC_BID_FILE, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/left_menu/bid_file.png"));
			shell.addItem("暗标文件", BidFile.PRIVATE_BID_FILE, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/left_menu/bid_file.png"));
			shell.pack();
			shell.addSelectListener(new SelectShell.SelectListener() {
				public void selectAction(String type) {
					openBrowseBidFileAction(type);
				}
			});
			Point loacatoin = Display.getDefault().map((Control) actionBtn, getShell(), 0, 0);
			shell.setLocation(loacatoin.x, loacatoin.y - shell.getBounds().height);
			shell.open();
		} else {
			openBrowseBidFileAction(BidFile.PUBLIC_BID_FILE);
		}
	}
	
	public void openBrowseBidFileAction(String bidFileType) {
		MeetingRoomOpenShell myEvaluationShell = new MeetingRoomOpenShell(getShell(), tenderProject);
		Composite parent = myEvaluationShell.getParentComposite();
		parent.setData("tenderProjectEntity", tenderProject);
		parent.setData("bidFileType", bidFileType);
		parent.setData("menu", menu);
		new BrowseBidFileComposite(parent, SWT.NONE);
//		myEvaluationShell.setMaximized(true);
		parent.layout();
		myEvaluationShell.open();
	}

	/**
	 * @Description: 加载所有的进度
	 * @author guoyr
	 * @param curTender 
	 */
	private void loadAllProgress(){
		if(null == progressPage){
			for(Control control : progressComposite.getChildren()){
				control.dispose();
			}
			progressComposite.setData("tenderProjectEntity", tenderProject);
			progressComposite.setData("meetingRoomListener", meetingRoomListener);
			progressPage = new ExpertEvlauationProgressComposite(progressComposite, SWT.NONE);
			progressComposite.layout();
		}else {
			progressPage.refresh(tenderProject);
		}
		curPageListener = progressPage;
		stackLayout.topControl = progressComposite;
		topLoadComposite.layout();
	}
	
	/**
	 * @Description: 加载我的评审
	 * @author guoyr
	 * @param curTender 
	 */
	private void loadMyEvaluation(){
		if(myEvaluationComposite.isDisposed()){
			return ;
		}
		if(null == myEvaluationStep){
			for(Control control : myEvaluationComposite.getChildren()){
				control.dispose();
			}
			myEvaluationComposite.setData("tenderProjectEntity", tenderProject);
			myEvaluationComposite.setData("meetingRoomListener", meetingRoomListener);
		myEvaluationStep = new MyEvaluationStepComposite(myEvaluationComposite, tenderProject, this,menu, SWT.NONE);
		myEvaluationComposite.layout();
		}else {
			myEvaluationStep.refresh(tenderProject);
		}
		curPageListener = myEvaluationStep;
		stackLayout.topControl = myEvaluationComposite;
		topLoadComposite.layout();
	}
	
	public void refreshExpert(){
		isRefreshExpert = false;
		if(stackLayout.topControl == myTenderPackComposite){
			meetingRoomListener.refreshChairsCount(7, null, false, false);
		}else {
			new Thread(new Runnable(){
				public void run(){
					AuthUser managerUser = userService.findById(tenderProject.getUserId());
					final boolean managerIsFemale = null != managerUser && UserEnum.FEMALE.equals(managerUser.getGender());
					List<Expert> expertList = expertService.findExpertByTenderIdBatch(tenderProject.getId(), null);
					isRefreshExpert = true;
					while(isRefreshExpert){
						if(null != expertList && expertList.size() > 0){
							meetingRoomListener.refreshChairsCount(expertList.size(), tenderProject.getManagerName(), managerIsFemale, false);
							List<Expert> tempExpertList = new ArrayList<Expert>();
							int signExpertCount = 0;
							for(Expert expert : expertList){
								if(null != expert.getSignType() && expert.getSignType().equals(ExpertEnum.SIGN)){
									tempExpertList.add(expert);
									signExpertCount ++;
								}else {
									tempExpertList.add(null);
								}
							}
							meetingRoomListener.refreshExpert(tempExpertList);
							if(signExpertCount == expertList.size()){
								isRefreshExpert = false;
							}
						}else {
							meetingRoomListener.refreshChairsCount(7, tenderProject.getManagerName(), managerIsFemale, false);
						}
						try {
							Thread.sleep(3000);
						} catch (InterruptedException e) {
						}
						expertList = expertService.findExpertByTenderIdBatch(tenderProject.getId(), null);
					}
				
				}
			}).start();
			
		}
	}
	
	/**
	 * @Description: 添加操作按钮
	 * @author guoyr 
	 */
	private void addOperatorBtn(boolean myPacks){
		
	    Composite operatorParent = meetingRoomListener.getOperatorParent();

	    for (Control control : operatorParent.getChildren()) {
	        control.dispose();
        }
	    
		Composite operatorComposite = new Composite(operatorParent, SWT.NONE);
		operatorComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		RowLayout gl_composite = new RowLayout();
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
//		gl_composite.marginTop = 10;
		gl_composite.fill = true;
		operatorComposite.setLayout(gl_composite);
		operatorComposite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, false, 1, 1));
//		SwtUtils.setCircleRegion(bottomContent, 12);
		if(myPacks){
			RoomOperatorButton actionBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
			actionBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/switch.png"));
			actionBtn.setText(MessageFormat.format(Messages.Button_changeFormat, com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProject.getTenderType())));
			actionBtn.addMouseListener(new MouseAdapter() {
				public void mouseUp(MouseEvent e) {
					loadMyTenderPack();
				}
			});
		}else {
			if(null != tenderProject.getParentId()){
				RoomOperatorButton actionBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
				actionBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/switch.png"));
				actionBtn.setText(MessageFormat.format(Messages.Button_changeFormat, com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProject.getTenderType())));
				actionBtn.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent e) {
						loadMyTenderPack();
					}
				});
				
			}
			 
			RoomOperatorButton actionBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
			actionBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/law.png"));
			actionBtn.setText(Messages.Button_discipline);
			actionBtn.addMouseListener(new MouseAdapter() {
				public void mouseUp(MouseEvent e) {
//					clear();
					File reviewDisciplineFile = FileConstants.getResourceFile(FileConstants.REVIEW_DISCIPLINE_FILE+ FileConstants.PDF);
					if (!reviewDisciplineFile.exists()) {
						reviewDisciplineFile = FileConstants.getResourceFile(FileConstants.REVIEW_DISCIPLINE_FILE+ FileConstants.DOCX);
					}
					if (null != reviewDisciplineFile && reviewDisciplineFile.exists()) {
						RuntimeUtils.openFIle(reviewDisciplineFile);
//						OpenDocumentComposite openDocumentComposite = new OpenDocumentComposite(loadComposite, reviewDisciplineFile, false, true);
//						openDocumentComposite.init();
//						loadComposite.layout();
//						stackLayout.topControl = loadComposite;
//						topLoadComposite.layout();
					} else {
						MessageDialog.openWarning(getShell(), Messages.Evaluation_notFindDisciplineTips);
					}
//					moreConfigAction();
				}
			});
			menuFunctionUtils.addFunction(actionBtn, "EVALUATION_BUTTON_DISCIPLINE");
			
//			RoomOperatorButton adobeCaptivateBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
//			adobeCaptivateBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/left_menu/law.png"));
//			adobeCaptivateBtn.setText(Messages.Button_adobeCaptivate);
//			adobeCaptivateBtn.addMouseListener(new MouseAdapter() {
//				public void mouseUp(MouseEvent e) {
//					AdobeCaptivateDialog.getInstance(1).open(null != tenderProject.getParentId() ? tenderProject.getParentId() : tenderProject.getId(),tenderProject.getTenderName());
//				}
//			});
//			menuFunctionUtils.addFunction(adobeCaptivateBtn, "ADOBE_CAPTIVATE");
			
  			{
				final RoomOperatorButton downloadBidFileBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
				downloadBidFileBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/download.png"));
//				actionBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
				downloadBidFileBtn.setText(Messages.Button_downloadBidFile);
				downloadBidFileBtn.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent e) {
						TenderProjectEntity tenderProjectEntity = tenderProjectService.getById(tenderProject.getId());
						if(CommonEnum.COMPLETE.equals(tenderProjectEntity.getComplateStatus())) {//|| tenderProjectService.isEvaluationComplate(tenderProject.getId())) {
							MessageDialog.openWarning(getShell(), Messages.Tips_evaluationCompleted);
							return;
						}
						
						int count = 0;
						String type = "";
						Map<String, String> menuFunctionMap = menuService.getMenuFunctionMap(menu.getId());
						String functionStatus1 = menuFunctionMap.get("FTP_DOWNLOAD");
						String functionStatus2 = menuFunctionMap.get("BT_DOWNLOAD");
						String functionStatus3 = menuFunctionMap.get("HTTP_DOWNLOAD");
						if(MenuFunction.SHOW.equals(functionStatus1)){
							count++;
							type = "FTP_DOWNLOAD";
						}
						if(MenuFunction.SHOW.equals(functionStatus2)) {
							count++;
							type = "BT_DOWNLOAD";
						}
						if(MenuFunction.SHOW.equals(functionStatus3)) {
							count++;
							type = "HTTP_DOWNLOAD";
						}
						
						if(count == 1) {
							if("FTP_DOWNLOAD".equals(type)) {
								DownloadDecBidFileDialog dialog = new DownloadDecBidFileDialog(getShell(), tenderProject, true);
								dialog.open();
							}else if("BT_DOWNLOAD".equals(type)) {
								TorrentFileService torrentFileService = new TorrentFileService();
								TorrentFile torrentFile = torrentFileService.getTorrentFileByTenderId(tenderProject.getId());
								if(null != torrentFile && null != torrentFile.getId()){
									String tempFilePath = FileConstants.TEMP_FOLDER + "torrent" + File.separator + torrentFile.getTenderId() + File.separator + torrentFile.getFileName();
									InputStreamUtil.writeFile(torrentFile.getFileBite(), tempFilePath);
									File templateFile = new File(tempFilePath);
									if(templateFile.exists()){
										RuntimeUtils.openFIle(templateFile, FileConstants.getUtorrentRoot());		
									}
								}
							}else if("HTTP_DOWNLOAD".equals(type)) {
								if(TenderProjectEnum.LOCAL.equals(tenderProject.getRemoteStatus())) {
									DownloadServiceBidFileDialog downloadServiceBidFileDialog = new DownloadServiceBidFileDialog(getShell(), tenderProject);
									downloadServiceBidFileDialog.open();
								}else {
									DownloadDecBidFileDialog dialog = new DownloadDecBidFileDialog(getShell(), tenderProject, false);
									dialog.open();
								}
							}
						}else {
							ChooseNetWorkToDownLoadShell shell = new ChooseNetWorkToDownLoadShell(new Shell(),menu, tenderProject, new SelectNetWorkListener() {
								public void selectOnline() {
									if(TenderProjectEnum.REMOTE.equals(tenderProject.getRemoteStatus())) {
										DownloadDecBidFileDialog dialog = new DownloadDecBidFileDialog(getShell(), tenderProject, false);
										dialog.open();
									}else {
										DownloadServiceBidFileDialog downloadServiceBidFileDialog = new DownloadServiceBidFileDialog(getShell(), tenderProject);
										downloadServiceBidFileDialog.open();
									}
								}
								public void selectLAN() {
									DownloadDecBidFileDialog dialog = new DownloadDecBidFileDialog(getShell(), tenderProject, true);
									dialog.open();
								}
								public void selectTorrent(TorrentFile torrentFile) {
									if(null != torrentFile && null != torrentFile.getId()){
										String tempFilePath = FileConstants.TEMP_FOLDER + "torrent" + File.separator + torrentFile.getTenderId() + File.separator + torrentFile.getFileName();
										InputStreamUtil.writeFile(torrentFile.getFileBite(), tempFilePath);
										File templateFile = new File(tempFilePath);
										if(templateFile.exists()){
											RuntimeUtils.openFIle(templateFile, FileConstants.getUtorrentRoot());		
										}
									}
								}
								@Override
								public void selectService() {
									
								}
							});
							Point loacatoin = Display.getDefault().map((Control)downloadBidFileBtn, getShell(), 0,0);
							shell.setLocation(loacatoin.x, loacatoin.y - shell.getBounds().height);
							shell.open();
						}
					}
				});
				menuFunctionUtils.addFunction(downloadBidFileBtn, "EVALUATION_BUTTON_DOWNLOADBIDFILE");
 			}
  			if(!UserEnum.ROLE_TYPE_EVALUATOIN_WORKER.equals(Constants.USER.getUserType())){
				RoomOperatorButton recommonedLeaderBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
				recommonedLeaderBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/hand.png"));
				recommonedLeaderBtn.setText(Messages.Button_recommonedLeader);
				recommonedLeaderBtn.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent e) {
						recommonedExpertLeader();
					}
				});
				menuFunctionUtils.addFunction(recommonedLeaderBtn, "EVALUATION_BUTTON_RECOMMONEDLEADER");
//
 			}
 			{
				RoomOperatorButton biddingFileBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
				biddingFileBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/pdf.png"));
				biddingFileBtn.setText(Messages.Button_viewBiddingFile);
				biddingFileBtn.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent e) {
						viewBidddingFile();
					}
				});
				menuFunctionUtils.addFunction(biddingFileBtn, "EVALUATION_BUTTON_BIDDINGFILE");
 			}
 			{
				final RoomOperatorButton veiwBidFileBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
				veiwBidFileBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/pdf.png"));
				veiwBidFileBtn.setText(Messages.Button_veiwBidFile);
				veiwBidFileBtn.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent e) {
						viewBidFile(veiwBidFileBtn);
					}
				});
				menuFunctionUtils.addFunction(veiwBidFileBtn, "EVALUATION_BUTTON_BIDFILE");
 			}
 			{
				RoomOperatorButton progressBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
				progressBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/hourglass.png"));
				progressBtn.setText(Messages.Button_viewProgress);
				progressBtn.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent e) {
						loadAllProgress();
					}
				});
				menuFunctionUtils.addFunction(progressBtn, "EVALUATION_BUTTON_PROGRESS");
 
 			}
 			{
				RoomOperatorButton evaluationBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
				evaluationBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/evaluation.png"));
				evaluationBtn.setText(Messages.Button_myEvaluation);
				evaluationBtn.addMouseListener(new MouseAdapter() {
					@Override
					public void mouseUp(MouseEvent e) {
						loadMyEvaluation();
					}
				});
 			}
 			
 			//视频会议按钮
//			boolean useVideoMetting = PropertiesUtils.getProperty(ConfigConstants.USE_VIDEO_MEETING, "00").equals("01");
			{
				final RoomOperatorButton actionRoomBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
				actionRoomBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/video.png"));
				actionRoomBtn.setText(Messages.VideoMeeting);
				actionRoomBtn.addMouseListener(new MouseAdapter() {
					public void mouseUp(MouseEvent e) {
						videoMeetingAction(actionRoomBtn);
					}
				});
				menuFunctionUtils.addFunction(actionRoomBtn, MenuFunctionEnum.SHOW_MEETING_VIDEO);
			}
 		}
 		
 		{
			RoomOperatorButton refreshBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
			refreshBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/refresh.png"));
			refreshBtn.setText(Messages.Button_refresh);
			refreshBtn.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(MouseEvent e) {
					refreshAction();
				}
			});
		}
 		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("EVALUATION_BUTTON_MESSAGE"))){
 			messageBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
			messageBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/message.png"));
			messageBtn.setText(Messages.Button_myMessage);
			messageBtn.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(MouseEvent e) {
					openChatGroupAction();
				}
			});
			menuFunctionUtils.addFunction(messageBtn, "EVALUATION_BUTTON_MESSAGE");
			
		}	
		menuFunctionUtils.initFunctionAuthority(menu);
		meetingRoomListener.refreshOperator();
	}
	
	/**
	 * @Description: 打开聊天窗口
	 * @author guoyr 
	 */
	private void openChatGroupAction(){
		if(IMClientAdapter.getInstance().hasNewMessage()){
			IMClientAdapter.getInstance().showNewMessage();
			return;
		}
        if (IMClientAdapter.getInstance().hasNewGroupMessage() ){
        	IMClientAdapter.getInstance().showNewGroupMessage();
            return;
        }
        if(null == clientDialog || clientDialog.isDisposed()){
        	clientDialog = new ClientDialog(tenderProject);
        
        }
        clientDialog.open();
	}
	
	
	public void onLoad(Action action) {
		for(Control control : loadComposite.getChildren()){
			control.dispose();
		}
		loadComposite.layout();
		stackLayout.topControl = loadComposite;
		layout();
	}
	public void loadComposite(Action action, Composite content) {
		
		loadComposite.layout();
	}
	public Composite getParentComposite() {
		return loadComposite;
	}
	

	protected void checkSubclass() {
	}

	/**
	 * 启动视频会议
	 */
	private void videoMeetingAction(RoomOperatorButton startMeetingBtn){
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if(!startMeetingBtn.isDisposed()) {
							startMeetingBtn.setEnabled(true);
						}
					}
				});
			}
			
		});
		new Thread(new Runnable(){
			public void run() {
				VideoMeetingUtils.enterMeeting(tenderProject, Constants.USER, VideoMeetingUtils.ROLE_EXPERT, false, messageProgress);
			}
		}).start();
		messageProgress.setTitle("正在启动视频会议");
		messageProgress.open();
	}
}
