package com.gx.obe.evaluation.composite;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.action.utils.ActionUtil;
import com.gx.obe.business.entity.ExpertEvaluationStep;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuEnum;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.business.enumeration.UserEnum;
import com.gx.obe.common.dialog.AssignEvalGroupDialog;
import com.gx.obe.common.file.entity.BidFile;
import com.gx.obe.common.file.entity.BiddingFile;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.Loading;
import com.gx.obe.common.widget.button.StepButton;
import com.gx.obe.common.widget.thread.SyncThread;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.components.core.enumeration.EvaluationStepEnum;
import com.gx.obe.components.core.enumeration.ExpertEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.evaluation.dialog.EvaluationGroupDialog;
import com.gx.obe.evaluation.dialog.MyAuditDialog;
import com.gx.obe.evaluation.shell.MeetingRoomOpenShell;
import com.gx.obe.evaluation.step.composite.AiEvalLeftButton;
import com.gx.obe.evaluation.step.form.WasteBidStepDialog;
import com.gx.obe.evaluation.step.listener.ExpertEvaluationListener;
import com.gx.obe.evaluation.step.resutl.action.BusinessEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.BusinessVetoEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.ClearTenderEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.ComplianceEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.CreditEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.EditPriceResultAction;
import com.gx.obe.evaluation.step.resutl.action.ExpertSignResutlAction;
import com.gx.obe.evaluation.step.resutl.action.FeatureCodeCheckResultAction;
import com.gx.obe.evaluation.step.resutl.action.LimitPriceEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.MultiWheelPriceEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.PreEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.PriceEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.RecommendRankEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.RecommonedEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.ScoreEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.TotalPriceEvaluationResultAction;
import com.gx.obe.evaluation.step.resutl.action.VetoBidEvaluationResultAction;
import com.gx.obe.evaluation.step.review.action.AbandonEvalutionAction;
import com.gx.obe.evaluation.step.review.action.BusinessEvaluationAction;
import com.gx.obe.evaluation.step.review.action.BusinessVetoEvaluationAction;
import com.gx.obe.evaluation.step.review.action.ClearTenderEvaluationAction;
import com.gx.obe.evaluation.step.review.action.CreditEvaluationAction;
import com.gx.obe.evaluation.step.review.action.EditPriceAction;
import com.gx.obe.evaluation.step.review.action.ExpertSignEvaluationAction;
import com.gx.obe.evaluation.step.review.action.FactorEvaluationAction;
import com.gx.obe.evaluation.step.review.action.FeatureCodeCheckEvaluationAction;
import com.gx.obe.evaluation.step.review.action.LimitPriceEvaluationAction;
import com.gx.obe.evaluation.step.review.action.MultiWheelPriceEvaluationAction;
import com.gx.obe.evaluation.step.review.action.PreEvaluationAction;
import com.gx.obe.evaluation.step.review.action.PriceEvaluationAction;
import com.gx.obe.evaluation.step.review.action.RecommendRankEvaluationAction;
import com.gx.obe.evaluation.step.review.action.RecommonedEvaluationAction;
import com.gx.obe.evaluation.step.review.action.TianYanCheckEvaluationAction;
import com.gx.obe.evaluation.step.review.action.TianYanCheckResultAction;
import com.gx.obe.evaluation.step.review.action.TotalPriceEvaluationAction;
import com.gx.obe.evaluation.step.review.action.VetoBidEvaluationAction;
import com.gx.obe.listener.EvaluationRoomListener;
import com.gx.obe.message.Messages;
import com.gx.obe.report.composite.EvaluationReportComposite;
import com.gx.obe.report.dialog.EvaluationReportDialog;
import com.gx.obe.thread.SyncThreadSet;
import com.gx.obe.util.utils.CollectionUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.MenuService;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.evaluation.EvaluationGroupService;
import com.gx.obe.web.service.evaluation.EvaluationStepExpertService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.service.expert.ExpertEvaluationStepService;
import com.gx.obe.web.service.expert.ExpertService;
import com.gx.security.CertValidator;
import com.gx.security.CertificateException;
import com.gx.security.SecurityRuntimeException;
import com.gx.tools.ole.signature.CircleSignatureDialog;
import com.gx.tools.utils.SignaturePdfUtils;
import com.gx.utils.NowTimeUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class MyEvaluationStepComposite extends Composite implements ActionListener, EvaluationRoomListener {
	
	private final Image caImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/signature.png");
    private final Image handImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/pen.png");
    private final Image saomaImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/sweepCode.png");	
	
	private TenderProjectEntity tenderProject;
	private TenderProjectRuleEntity projectRule;
	private Expert expert;
	private Composite evaluation_load_content;
//	private Composite evaluationStepComposite;
	private ImageResolver imageResolver = new ImageResolver();
	private MeetingRoomOpenShell myEvaluationShell;
	private List<EvaluationStep> evaluationStepList;
	private ExpertEvaluationListener expertEvaluationListener;
	private Composite topComposite;
	private Composite tipsComposite;
	private Label myEvaluationTips;
	private Logger LOG = Logger.getLogger(MyEvaluationStepComposite.class);
	private boolean existOperatorEvaluation = false;// 是否存在项目经理操作评标步骤
	private boolean evalByEvalGroup = false;// 是否存在按评审要素单元评审
	private ActionListener evaluationMainActionListener;
	private ELink signature_btn;
	private ELink report_btn;
	private Composite toolsComposite;
	private ScrolledComposite scrolledComposite;
	private Composite stepComposite;
	private List<Expert> expertList;
	private ELink wasteBiddding_btn;
	private ELink assignEvalGroup_btn;
	private ELink myAuditLink;
	private ELink preEvalLink;
	private ELink setWorkerButton;
 	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	private ExpertService expertService;
	private MenuService menuService;
	private TenderProjectService tenderProjectService;
	private ProjectRuleService projectRuleService;
	private EvaluationGroupService evaluationGroupService;
	private ExpertEvaluationStepService expertEvaluationStepService;
	private EvaluationStepExpertService evaluationStepExpertService;
	private EvaluationStepService evaluationStepService;
	private Menu menu;
	private Menu resultMenu;
	// private StepButton curStep;
	{
		LogUtils.logClass(MyEvaluationStepComposite.class);
	}
	
	/**
	 * @param parent
	 * @param style
	 */
	public MyEvaluationStepComposite(Composite parent, TenderProjectEntity tenderProject, ActionListener evaluationMainActionListener,Menu menu, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		this.menu = menu;
		gridLayout.marginWidth = 0;
		gridLayout.marginHeight = 0;
		gridLayout.horizontalSpacing = 0;
		setLayout(gridLayout);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				imageResolver.disposite();
				if (null != evaluationStepList) {
					evaluationStepList.clear();
				}
			}
		});
		this.tenderProject = tenderProject;
		this.evaluationMainActionListener = evaluationMainActionListener;
		
		evaluation_load_content = new Composite(this, SWT.NONE);
		GridLayout gl_evalMainComposite = new GridLayout(1, false);
		gl_evalMainComposite.horizontalSpacing = 0;
		gl_evalMainComposite.marginHeight = 0;
		gl_evalMainComposite.marginWidth = 0;
		gl_evalMainComposite.verticalSpacing = 0;
		evaluation_load_content.setLayout(gl_evalMainComposite);
		evaluation_load_content.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		topComposite = new Composite(evaluation_load_content, SWT.NONE);
		GridLayout gl_composite_5 = new GridLayout(2, false);
		gl_composite_5.marginTop = 0;
		gl_composite_5.marginHeight = 0;
		gl_composite_5.marginWidth = 0;
		topComposite.setLayout(gl_composite_5);
		topComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		tipsComposite = new Composite(topComposite, SWT.NONE);
		tipsComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		tipsComposite.setLayout(new GridLayout(2, false));
		
		CLabel tipsIco = new CLabel(tipsComposite, SWT.NONE);
		tipsIco.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_blue.png"));
		
		myEvaluationTips = new Label(tipsComposite, SWT.WRAP);
		myEvaluationTips.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		myEvaluationTips.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		myEvaluationTips.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		myEvaluationTips.setForeground(SWTResourceManager.getColor(60, 138, 226));
		myEvaluationTips.setText(Messages.Evaluation_myEvaluationTips);
		
		
		ELink refreshLink = new ELink(topComposite, SWT.NONE);
		refreshLink.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		refreshLink.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		refreshLink.setForeground(SWTResourceManager.getColor(60, 138, 226));
		refreshLink.setText(Messages.Button_refresh);
		refreshLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/refresh.png"));
		refreshLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				refreshAction();
			}
		});
		
		scrolledComposite = new ScrolledComposite(evaluation_load_content, SWT.H_SCROLL | SWT.V_SCROLL);
		GridData gd_scrolledComposite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_scrolledComposite.widthHint = 500;
		scrolledComposite.setLayoutData(gd_scrolledComposite);
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		stepComposite = new Composite(scrolledComposite, SWT.NONE);
		GridLayout gl_stepComposite = new GridLayout(1, false);
		gl_stepComposite.marginHeight = 0;
		gl_stepComposite.marginWidth = 0;
		stepComposite.setLayout(gl_stepComposite);
		
		scrolledComposite.setContent(stepComposite);
		scrolledComposite.setMinSize(stepComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
//		ESepator toosSep = new ESepator(evaluation_load_content, SWT.NONE);
//		toosSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
//		toosSep.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		toolsComposite = new Composite(evaluation_load_content, SWT.NONE);
//		toolsComposite.setBackground(SWTResourceManager.getColor(240, 240, 240));
//		toolsComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		toolsComposite.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, true, false, 1, 1));
		toolsComposite.setLayout(new RowLayout(SWT.HORIZONTAL));
		
		
		assignEvalGroup_btn = new ELink(toolsComposite, SWT.NONE);
		assignEvalGroup_btn.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		assignEvalGroup_btn.setForeground(SWTResourceManager.getColor(60, 138, 226));
		assignEvalGroup_btn.setText(Messages.Button_assignEvalGroup);
		assignEvalGroup_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/config.png"));
		assignEvalGroup_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				assignEvalGroupAction();
			}
		});
		menuFunctionUtils.addFunction(assignEvalGroup_btn, "EVALUATION_ASSIGNEVALGROUP");
		
		
		
		setWorkerButton = new ELink(toolsComposite, SWT.NONE);
		setWorkerButton.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				setWorkerAction();
			}
		});
		setWorkerButton.setText(Messages.Button_assignWorker);
		setWorkerButton.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		setWorkerButton.setForeground(SWTResourceManager.getColor(60, 138, 226));
		setWorkerButton.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/link.png"));
		menuFunctionUtils.addFunction(setWorkerButton, "EVALUATION_SETWORKER");
		
		
		myAuditLink = new ELink(toolsComposite, SWT.NONE);
		myAuditLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				myAuditAction();
			}
		});
		myAuditLink.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		myAuditLink.setForeground(SWTResourceManager.getColor(60, 138, 226));
		myAuditLink.setText(Messages.Button_myReview);
		myAuditLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/signature.png"));
		menuFunctionUtils.addFunction(myAuditLink, "EVALUATION_MYAUDIT");
		
		
		
		preEvalLink = new ELink(toolsComposite, SWT.NONE);
		preEvalLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				viewPreEvalResultAction();
			}
		});
		preEvalLink.setText(MessageFormat.format(Messages.Title_view, Messages.BidFileComments));
		preEvalLink.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		preEvalLink.setForeground(SWTResourceManager.getColor(60, 138, 226));
		preEvalLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/signature.png"));
		menuFunctionUtils.addFunction(preEvalLink, "EVALUATION_PREEVAL");
		//如果需要屏蔽，直接注释掉该行
		new AiEvalLeftButton(toolsComposite, SWT.NONE, tenderProject, "标书查重");
		
		signature_btn = new ELink(toolsComposite, SWT.NONE);
		signature_btn.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		signature_btn.setForeground(SWTResourceManager.getColor(60, 138, 226));
		menuFunctionUtils.addFunction(signature_btn, "EVALUATION_SIGNATURE");
		
		wasteBiddding_btn = new ELink(toolsComposite, SWT.NONE);
		wasteBiddding_btn.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		wasteBiddding_btn.setForeground(SWTResourceManager.getColor(60, 138, 226));
		wasteBiddding_btn.setText(Messages.Button_wasteBidding);
		wasteBiddding_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
		wasteBiddding_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				wasteBidddingAction();
			}
		});
		menuFunctionUtils.addFunction(wasteBiddding_btn, "EVALUATION_WASTEBIDDING");
		
		report_btn = new ELink(toolsComposite, SWT.NONE);
		report_btn.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		report_btn.setForeground(SWTResourceManager.getColor(60, 138, 226));
		report_btn.setText(Messages.Button_generateReport);
		report_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/excel.png"));
		report_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				createReportAction();
			}
		});
		menuFunctionUtils.addFunction(report_btn, "EVALUATION_REPORT");
		init();
	}
	
	/**
	 * @Description: 初始化界面数据
	 * @author guoyr
	 */
	private void init() {
		expertService = new ExpertService ();
		menuService = new MenuService();
		tenderProjectService = new TenderProjectService ();
		projectRuleService = new ProjectRuleService() ;
		evaluationGroupService= new EvaluationGroupService();
		expertEvaluationStepService = new ExpertEvaluationStepService();
		evaluationStepExpertService = new EvaluationStepExpertService ();
		evaluationStepService = new EvaluationStepService();
		/**
		 * 第二层验证
		 * **/
		try {
			CertValidator.getInstance().validateAuthorization();
		} catch (CertificateException e) {
			throw new SecurityRuntimeException(e);
		}
		
		expertEvaluationListener = new ExpertEvaluationListener() {
			public void complete() {
				if (null != myEvaluationShell && !myEvaluationShell.isDisposed()) {
					myEvaluationShell.close();
					refreshAction();
				}
			}
			public void refresh() {
				refreshAction();
			}
		};
		toolsComposite.setVisible(false);
		menuFunctionUtils.initFunctionAuthority(menu);
		refreshSignatureBtn();
		refreshAction();
		
//		myThreadSet.addSyncExec(new SyncThread(new SyncThread.Runnable() {
//			public void run() {
//				menu = menuService.getUserEvaluationResourceList(Constants.USER.getId(), "EVALUATION");
//			}
//		}));
		
	}

	/**
	 * @Description: 刷新签章按钮
	 * @author chenxw 
	 */
	private void refreshSignatureBtn() {
		final Map<String, String> signaturePdfMap = SignaturePdfUtils.getSignaturePdfMap();
		
		if (signaturePdfMap.isEmpty()) {
			WidgetUtils.setControlVisible(signature_btn, false);
			return;
		}
		if (signaturePdfMap.size() == 1) {
			final String signaturePdfKey = signaturePdfMap.keySet().iterator().next();
			initSignature_btn(signaturePdfKey, signaturePdfMap.get(signaturePdfKey));
			return;
		}
		signature_btn.setText(Messages.Button_elecSignature);
		signature_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/pen.png"));
		signature_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				EMenu supplierOp = new EMenu(getShell());
				supplierOp.setForeground(ColorConstants.FONT_BLACK_COLOR);
				supplierOp.setAlpha(220);
				supplierOp.setAutoClickOnlyOneItem(true);
				supplierOp.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
				for (String signaturePdfKey : signaturePdfMap.keySet()) {
					if (SignaturePdfUtils.CA.equals(signaturePdfKey)) {
						supplierOp.addMenuItem(Messages.Button_caSignature, caImage, true, new EMenu.ClickListener() {
							public void click() {
								openSignatureDialog(Messages.Button_caSignature, signaturePdfKey, signaturePdfMap.get(signaturePdfKey));
							}
						});
					} else if (SignaturePdfUtils.HAND.equals(signaturePdfKey)) {
						supplierOp.addMenuItem(Messages.Button_handSignature, handImage, true, new EMenu.ClickListener() {
							public void click() {
								openSignatureDialog(Messages.Button_handSignature, signaturePdfKey, signaturePdfMap.get(signaturePdfKey));
							}
						});
					} else if (SignaturePdfUtils.SAOMA.equals(signaturePdfKey)) {
						supplierOp.addMenuItem(Messages.Button_scanSignatrue, saomaImage, true, new EMenu.ClickListener() {
							public void click() {
								openSignatureDialog(Messages.Button_scanSignatrue, signaturePdfKey, signaturePdfMap.get(signaturePdfKey));
							}
						});
					}
				}
				supplierOp.open(signature_btn);
			}
		});
	}
	
	/**
     * @Description: 
     * @author chenxw
     * @param signaturePdfKey
     * @param signaturePdfvalue 
     */
    private void initSignature_btn(final String signaturePdfKey, final String signaturePdfvalue) {
        if (SignaturePdfUtils.CA.equals(signaturePdfKey)) {
            signature_btn.setText(Messages.Button_caSignature);
            signature_btn.setImage(caImage);
        } else if (SignaturePdfUtils.HAND.equals(signaturePdfKey)) {
            signature_btn.setText(Messages.Button_handSignature);
            signature_btn.setImage(handImage);
        } else if (SignaturePdfUtils.SAOMA.equals(signaturePdfKey)) {
            signature_btn.setText(Messages.Button_scanSignatrue);
            signature_btn.setImage(saomaImage);
        }
        MouseAdapter mouseAdapter = new MouseAdapter() {
            public void mouseUp(MouseEvent e) {
            	openSignatureDialog(signature_btn.getText(), signaturePdfKey, signaturePdfvalue);
            }
        };
        signature_btn.addMouseListener(mouseAdapter);
    }
    
	private void openSignatureDialog(String title, String signaturePdfKey, String signaturePdfType) {
		CircleSignatureDialog signatureDialog = new CircleSignatureDialog(getShell(), tenderProject, Constants.USER, signaturePdfKey, signaturePdfType);
		signatureDialog.setTitle(title);
    	signatureDialog.open();
	}
	
	
	
	/**
	 * @Description:点击刷新按钮
	 * @author guoyr
	 */
	private void refreshAction() {
	    expert = expertService.getExpert(tenderProject.getId(), Constants.USER.getId());
        if (null == expert) {
            expert = new Expert();
            LOG.error("未获取取当前专家！");
        }
        projectRule = projectRuleService.getProjectRule(tenderProject.getId());
        if (null == projectRule) {
            projectRule = new TenderProjectRuleEntity();
        }
		refreshTenderInfo();
		cleanComplateComposite();
		refreshEvaluationStepList();
	}
	
	/**
	 * @Description: 刷新项目信息
	 * @author guoyr
	 */
	private void refreshTenderInfo() {
		SyncThreadSet myThreadSet = new SyncThreadSet(new SyncThreadSet.Runnable() {
			public void run() {
				resultMenu = menuService.getMenutByMenuCode(MenuEnum.EVALUATION_RESULT);
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!toolsComposite.isDisposed()){
							if (!ObjectUtils.equals(expert.getIsLeader(), ExpertEnum.LEADER_YES)) {
								WidgetUtils.setControlVisible(report_btn, false);
								WidgetUtils.setControlVisible(wasteBiddding_btn, false);
							}
							toolsComposite.layout();
							evaluation_load_content.layout();
						}
					} 
				});
			}
		});
		
		if (MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority(MenuFunctionEnum.EXPERT_COUNT_FILTER))) {
			myThreadSet.addSyncExec(new SyncThread(new SyncThread.Runnable(){
				public void run() {
					String [] strCoulmns ={Expert.EXPERT_TYPE,Expert.TENDER_ID, Expert.EXPERT_ID};
					expertList = expertService.finCoulmnsByTenderId(tenderProject.getId(),strCoulmns);
				}
			}));
		}
		myThreadSet.addSyncExec(new SyncThread(new SyncThread.Runnable(){
			public void run() {
				tenderProject = tenderProjectService.getTenderProjectInfo(tenderProject.getId());
			}
		}));
		myThreadSet.start();
	}
	
	/**
	 * @Description: 刷新评标步骤
	 * @author guoyr
	 * @param curEvaluationStep
	 */
	private void refreshEvaluationStepList() {
		if (null != evaluationStepList) {
			evaluationStepList.clear();      
		}
		
		for (Control control : stepComposite.getChildren()) {
			control.dispose();
		}
		
		CLabel label = new Loading(stepComposite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		
		SyncThread syncThread = new SyncThread(new SyncThread.Runnable(){
			public void run() {
				
				// 获得所有的评标步骤
				evaluationStepList = evaluationStepService.getEvaluationStepList(tenderProject.getId());

				// 如果没有评标步骤，则创建默认评标步骤
				if (null == evaluationStepList) {
			 		evaluationStepList = new ArrayList<EvaluationStep>();
				}
				
				Map<String, ExpertEvaluationStep> expertStepMap = new HashMap<String, ExpertEvaluationStep>();
				
				// 获得当前专家的评标步骤(专家每评完一个评标步骤，则会生成专家对当前评标步骤的评标结果)
		 		List<ExpertEvaluationStep> expertEvaluationStepList =  expertEvaluationStepService.getExpertEvaluationStepList(tenderProject.getId(), Constants.USER.getId());
				if (null != expertEvaluationStepList && expertEvaluationStepList.size() > 0) {
					for (ExpertEvaluationStep expertStep : expertEvaluationStepList) {
						expertStepMap.put(expertStep.getStepId(), expertStep);
					}
				}
				showExpertExpert(expertStepMap);
			}
		});
		syncThread.start();
		
	}
	public void showExpertExpert(final Map<String, ExpertEvaluationStep> expertStepMap){		
		final boolean isFreeProgress = EvaluationStepEnum.ORDER_SELF_FREE.equals(projectRule.getOrderReview());
		// 如果评标进度是授项目经理控制
		boolean oreratorControl = EvaluationStepEnum.ORDER_OPERATOR.equals(projectRule.getOrderReview());
		
		existOperatorEvaluation = false;
		Display.getDefault().syncExec(new Runnable() {
			public void run() {
				if (!stepComposite.isDisposed()) {
					for (Control control : stepComposite.getChildren()) {
						control.dispose();
					}
					Composite evaluationStepComposite = new Composite(stepComposite, SWT.NONE);
					GridData gd_evaluationStepComposite = new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1);
					
					evaluationStepComposite.setLayoutData(gd_evaluationStepComposite);
					RowLayout evaluationStepRowLayout = new RowLayout(SWT.HORIZONTAL);
					evaluationStepRowLayout.fill = true;
					evaluationStepRowLayout.marginHeight = 0;
					evaluationStepComposite.setLayout(evaluationStepRowLayout);
					if (evaluationStepList.size() <= 3) {
						evaluationStepRowLayout.spacing = 30;
					} else if (evaluationStepList.size() > 3 && evaluationStepList.size() <= 5) {
						evaluationStepRowLayout.spacing = 10;
					} else {
						evaluationStepRowLayout.spacing = 0;
					}
					int stepCount = 0;
					int isComplateCount = 0;
					if (null != evaluationStepList && evaluationStepList.size() > 0) {
						// 默认评标步骤的大小为64
						int surroundMargin = 10;
						if (evaluationStepList.size() > 6) {
							surroundMargin = 8;
						}
						EvaluationStep preEvaluationStep = null;
						
						// 获得当前专家指定评审的评标步骤
						List<String> customStepList = null;
						List<String> evalGroupStepList = null;
						
						
						evalByEvalGroup = false;
						ImageButton nextSepBtn = null;
						
						for (int stepIndex = 0; stepIndex < evaluationStepList.size(); stepIndex++) {
							EvaluationStep evaluationStep = evaluationStepList.get(stepIndex);

							// 如果当前评标步骤节点是专家组长评审
							if (EvaluationStepEnum.EXPERT_LEADER.equals(evaluationStep.getRoleType())) {
								if (!ObjectUtils.equals(expert.getIsLeader(), ExpertEnum.LEADER_YES)) {
									continue;
								}
							} else if (EvaluationStepEnum.OPERATOR.equals(evaluationStep.getRoleType())) {
								// 如果当前评标步骤节点是由项目经理操作
								existOperatorEvaluation = true;
								continue;
							} else if (EvaluationStepEnum.CUSTOM.equals(evaluationStep.getRoleType())) {
								if (null == customStepList) {
								 	customStepList = evaluationStepExpertService.finStepIdByTenderIdAndUserId(tenderProject.getId(),Constants.USER.getId());
								}
								
								// 如果该专家没有指定评标步骤或，在当前评标步骤没有指定给该专家
								if (null == customStepList || !customStepList.contains(evaluationStep.getId())) {
									continue;
								}
							} else if (EvaluationStepEnum.EVAL_BID_TYPE.equals(evaluationStep.getRoleType())) {
								// 如果是按评标类型进行评审
								if (EvaluationFactorEnum.EVAL_BID_BUS.equals(evaluationStep.getEvalBidType())) {
									if ((expert.getEvalBidTypeNotNull() & ExpertEnum.EXPERT_BUS) == 0) {
										continue;
									}
								} else if (EvaluationFactorEnum.EVAL_BID_TEC.equals(evaluationStep.getEvalBidType())) {
									if ((expert.getEvalBidTypeNotNull() & ExpertEnum.EXPERT_TEC) == 0) {
										continue;
									}
								} else if (EvaluationFactorEnum.EVAL_BID_DETAIL.equals(evaluationStep.getEvalBidType())) {
									if ((expert.getEvalBidTypeNotNull() & (ExpertEnum.EXPERT_BUS | ExpertEnum.EXPERT_TEC)) == 0) {
										continue;
									}
								}
							} else if (ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.EVAL_GROUP)) {
								// 按评审要素分组评审
								evalByEvalGroup = true;
								if (null == expert.getEvalGroup()) {
									continue;
								}
								if (null == evalGroupStepList) {
				 					evalGroupStepList = evaluationStepService.getEvalGroupEvalStepList(tenderProject.getId(), expert.getEvalGroup());
								}
								if (null == evalGroupStepList || !evalGroupStepList.contains(evaluationStep.getId())) {
									continue;
								}
							}
							if (EvaluationStepEnum.PRE_EVALUATION.equals(evaluationStep.getStepType())) {
	 							if (!evaluationGroupService.isHasEvaluationGroupByUserId(tenderProject.getId(), Constants.USER.getId(), evaluationStep.getId())) {
									continue;
								}
							} else {
								if (UserEnum.ROLE_TYPE_EVALUATOIN_WORKER.equals(Constants.USER.getUserType())) {
									continue;
								}
							}
						
							
							final StepButton evaluationStepButton = new StepButton(evaluationStepComposite, SWT.NONE);
							evaluationStepButton.setLayoutData(new RowData(80, SWT.DEFAULT));
							evaluationStepButton.setSurroundMargin(surroundMargin);
							evaluationStepButton.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
							evaluationStepButton.setEvaluationStep(evaluationStep);
							evaluationStepButton.setData("evaluationStep", evaluationStep);
							Image image = imageResolver.loadImage(IconsActivator.PLUGIN_ID, EvaluationStepEnum.getEvaluationStepIco(evaluationStep.getStepType()));
							evaluationStepButton.setImage(image);
							evaluationStepButton.setText(evaluationStep.getStepName());
							evaluationStepButton.addMouseListener(new MouseAdapter() {
								public void mouseUp(MouseEvent e) {
									evaluateAction(evaluationStepButton);
								}
							});
							
							
							nextSepBtn = new ImageButton(evaluationStepComposite, SWT.NONE);
							nextSepBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/evaluaton_step/next.png"));
							nextSepBtn.setSurroundColor(SWTResourceManager.getColor(77, 163, 19));
							nextSepBtn.setEnabled(false);
							nextSepBtn.setSurroundMargin(10);
							nextSepBtn.setLayoutData(new RowData(SWT.DEFAULT, 80));
							nextSepBtn.setText("");
							
							// 获得当前评标专家的评标步骤
							ExpertEvaluationStep expertEvaluateStep = expertStepMap.get(evaluationStep.getId());
							
							// 专家是否已经评标完成
							boolean isComplate = false;
							boolean isInAudit = false;
							// 如果当前专家已完成该评标步骤节点
							if (null != expertEvaluateStep && CommonEnum.COMPLETE.equals(expertEvaluateStep.getStepStatus())) {
								isComplate = true;
							} else {
								// 如果当前节点是签到节点，且专家已签到
								if (EvaluationStepEnum.SIGIN.equals(evaluationStep.getStepType())) {
									if(ExpertEnum.SIGN.equals(expert.getSignType())){
										isComplate = true;
									}
								}else if(EvaluationStepEnum.PRE_EVALUATION.equals(evaluationStep.getStepType())) {
									// 如果当前步骤未完成，但状态是审核中，则也设置为已完成，且标记为审核中
									if (null != expertEvaluateStep && (CommonEnum.IN_EXPERT_REVIEW.equals(expertEvaluateStep.getStepStatus()) || CommonEnum.IN_MANAGER_REVIEW.equals(expertEvaluateStep.getStepStatus()))) {
										isComplate = true;
										isInAudit = true;
									}
								}
							}
							// 如果当前评标步骤已经完成
							if (isComplate) {
								// 已完成的图标用绿色表示
								isComplateCount ++;
								evaluationStepButton.setSurroundColor(SWTResourceManager.getColor(77, 163, 19));
								
								evaluationStepButton.setSubTextSurroundColor(SWTResourceManager.getColor(77, 163, 19));
								evaluationStepButton.setSubText(Messages.Progress_complate);
								
								evaluationStepButton.setEnabled(true);
								nextSepBtn.setEnabled(true);
								evaluationStepButton.setComplate(true);
								evaluationStepButton.setData("complate", "1");
								if(isInAudit){
//									evaluationStepButton.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/signature_allow.png"));
									evaluationStepButton.setSubText(Messages.Progress_pendingAudit);
								}
								// 如果是手动控制评标进度，则要先验证下一评标步骤是否允许评标
								if (oreratorControl && !MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority(MenuFunctionEnum.ALLOW_EVALUATION_BEFORE_START_NEXT))) {
									if (evaluationStepList.size() > (stepIndex + 1)) {
										EvaluationStep nextNode = evaluationStepList.get(stepIndex + 1);
										// 如果下一评标步骤还示允许评标，则还可以修改当前评标结果
										if (!CommonEnum.START.equals(nextNode.getControlStatus())) {
											evaluationStepButton.setComplate(false);
											evaluationStepButton.setData("complate", null);
											isComplate = false;
										}
									}
								}
							} else {
								// 如果当前评标步骤未评审完成
								boolean allowEvaluation = false;
								// 如果是第一个评标步骤，则允许评审
								if (stepCount == 0 || EvaluationStepEnum.PRE_EVALUATION.equals(evaluationStep.getStepType())) {
									allowEvaluation = true;
									evaluationStepButton.setEnabled(true);
								} else if (null != preEvaluationStep) {
									// 如果不是第一个节点，则根据 当前专家的上一步评标步骤判断，是否可以进行评标
									ExpertEvaluationStep memberPreNode = expertStepMap.get(preEvaluationStep.getId());
									// 如果当前专家的前一个评标步骤评审完成，则也点亮该节点
									if (null != memberPreNode && CommonEnum.COMPLETE.equals(memberPreNode.getStepStatus())) {
										allowEvaluation = true;
									} else {
										// 如果前一节点未完成，且是签到节点
										if (EvaluationStepEnum.SIGIN.equals(preEvaluationStep.getStepType())) {
											// 如果前一签到节点已经完成，或者该专家已经完成了签到，则允许操
											if (CommonEnum.COMPLETE.equals(preEvaluationStep.getStepStatus()) || ExpertEnum.SIGN.equals(expert.getSignType())) {
												allowEvaluation = true;
											}
										}
									} 
									
									// 如果是个人自由不控制进度，则只要上一步评审过，就可以进入下一步评审
									if (!allowEvaluation && isFreeProgress) {
										if (null != memberPreNode && CommonEnum.IN_PROGRESS.equals(memberPreNode.getStepStatus())) {
											allowEvaluation = true;
										}
									}
								}
								evaluationStepButton.setEnabled(allowEvaluation);
								
								if(allowEvaluation) {
									evaluationStepButton.setSubTextSurroundColor(SWTResourceManager.getColor(60, 138, 226));
									evaluationStepButton.setSubText(Messages.Progress_inProgress);
								}else {
									evaluationStepButton.setSubTextSurroundColor(SWTResourceManager.getColor(SWT.COLOR_DARK_GRAY));
									evaluationStepButton.setSubText(Messages.Progress_noStart);
								}
							}
							if (EvaluationStepEnum.PRE_EVALUATION.equals(evaluationStep.getStepType())) {
//								evaluationStep.getStepType().equals(EvaluationStepEnum.FEATURE_CHECK) 
//								|| evaluationStep.getStepType().equals(EvaluationStepEnum.CLEAN_TENDER)
								// 如果是清标标节点或者特征码检查节点，则不受上一节点的限制
//								preEvaluationStep = evaluationStep;
							} else {
								preEvaluationStep = evaluationStep;
							}
							stepCount++;
						}
						
						if (null != nextSepBtn && !nextSepBtn.isDisposed()) {
							nextSepBtn.dispose();
						}
					} else {
						ImageButton createDefaultLabel = new ImageButton(evaluationStepComposite, SWT.BOTTOM);
						createDefaultLabel.setImage(imageResolver.loadImage(IconsActivator.PLUGIN_ID, "icons/warning_48.png"));
						createDefaultLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
						createDefaultLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
						createDefaultLabel.setText("无评标步骤");
					}
					
					evaluationStepComposite.pack();
					gd_evaluationStepComposite.widthHint = Math.min(stepComposite.getBounds().width - 20, evaluationStepComposite.getBounds().width);
					stepComposite.layout();
					scrolledComposite.setMinSize(stepComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
					
					EvaluationStep preEvaluationStep = CollectionUtils.get(evaluationStepList, t -> EvaluationStepEnum.PRE_EVALUATION.equals(t.getStepType()));
					
					// 如果是工作人员，则将除查看评议外的功能全部隐藏
					if(UserEnum.ROLE_TYPE_EVALUATOIN_WORKER.equals(Constants.USER.getUserType())){
						for(Control control : toolsComposite.getChildren()){
							if(!control.equals(preEvalLink)){
								WidgetUtils.setControlVisible(control, false);
							}
						}
					}
					if (null != preEvaluationStep) {
						// 如果是清标评审，且不是组长，则将分配工作人员和审核功能隐藏
						if (!ExpertEnum.LEADER_YES.equals(expert.getIsLeader())) {
							WidgetUtils.setControlVisible(setWorkerButton, false);
							WidgetUtils.setControlVisible(myAuditLink, false);
						}
					}
					if(ExpertEnum.LEADER_YES.equals(expert.getIsLeader())){
						WidgetUtils.setControlVisible(assignEvalGroup_btn, evalByEvalGroup);
					}else {
						WidgetUtils.setControlVisible(assignEvalGroup_btn, false);
					}
					toolsComposite.setVisible(true);
					toolsComposite.layout();
					evaluation_load_content.layout();
					
					tipsComposite.layout();
					topComposite.layout();
					
					deleteBidFile(isComplateCount, stepCount);
				}
			}
		});
	}
	
	// 评标结束后删除标书文件
	private void deleteBidFile(int isComplateCount, int stepCount) {
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority(MenuFunctionEnum.DELETE_BID_FILE_BY_EVALUATION_FINISH))) {
			if(CommonEnum.COMPLETE.equals(tenderProject.getComplateStatus()) || isComplateCount >= stepCount && stepCount > 0){
				new Thread(new Runnable() {
					public void run() {
						BidFile.deleteBidFileAction(tenderProject.getId());
						BiddingFile.deleteBidddingFileAction(tenderProject.getId());
					}
				}).start();
			}
		}
	}
	
	/**
	 * @Description: 是否允许评标
	 * @author guoyr
	 * @param evaluationStep
	 * @return
	 */
	private String checkAllowEvaluation(EvaluationStep evaluationStep) {
		tenderProject = tenderProjectService.getTenderProjectInfo(tenderProject.getId());
		// 如果未到评标时间，则不允许评审（签到除外）
		if (!EvaluationStepEnum.SIGIN.equals(evaluationStep.getStepType())) {
			if (null != projectRule.getBidEvaluationStartTime() && NowTimeUtils.getNowDate().before(projectRule.getBidEvaluationStartTime())) {
				return Messages.Evaluation_noStartTimeTips;
			}
		}
		// 回避后不能进行任何操作
		if (ExpertEnum.AVOID.equals(expert.getSignType())) {
			return Messages.Evaluation_avoidTips;
		}
		// 如果没有设置不需要组长
		if(!MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority(MenuFunctionEnum.NEED_EXPERT_LEADER))) {
			// 判断有没有产生组长
			if (!EvaluationStepEnum.SIGIN.equals(evaluationStep.getStepType())) {
//			if (!EvaluationStepEnum.SIGIN.equals(evaluationStep.getStepType()) && !EvaluationStepEnum.PRE_EVALUATION.equals(evaluationStep.getStepType())) {
				if (!expertService.isExistExpertLeader(tenderProject.getId())) {
					return Messages.Tips_noRecommonedLeader;
				}
			}
		}
		
		// 如果是两步开标且是经济标评审，则必须开完经济标才能操作
		if (TenderProjectEnum.BID_OPENING_TWO_STAGE.equals(projectRule.getBidOpeningStage()) && ObjectUtils.equals(evaluationStep.getEvalBidType(), EvaluationFactorEnum.EVAL_BID_PRICE)) {
			if (null == tenderProject.getPriceBidStatus() || !tenderProject.getPriceBidStatus().equals(CommonEnum.COMPLETE)) {
				return Messages.Evaluation_noOpeningTips;
			}
		}
		
		// 验证专家人数
		if (MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority(MenuFunctionEnum.EXPERT_COUNT_FILTER)) && null != expertList && expertList.size() > 0) {
			if (StringUtils.equals(TenderProjectEnum.TENDER_YTPE_GCJS, tenderProject.getTenderType())) {
				
				if (expertList.size() < 7 || expertList.size() % 2 == 0) {
					return MessageFormat.format(Messages.Evaluation_limitCountTips, new Object[]{7});
				}
			} else {
				
				if (expertList.size() < 5 || expertList.size() % 2 == 0) {
					return MessageFormat.format(Messages.Evaluation_limitCountTips, new Object[]{5});
				}
			}
			double biddingManagerCount = 0;
			for (Expert expert : expertList) {
				if (ObjectUtils.equals(expert.getExpertType(), ExpertEnum.BIDDING)) {
					biddingManagerCount++;
				}
			}
			if (biddingManagerCount > 0) {
				if (biddingManagerCount / expertList.size() > 1.0 / 3) {
					return Messages.Evaluation_moreBiddingManagerTips;
				}
//				return "商务、技术专家人数少于评标委员会成员人数的三分之二！";
			}
		}
		
		// 如果项目已经废标，则废标步骤后的步骤不能操作
		if (TenderProjectEnum.EFFECTIVE_NO.equals(tenderProject.getEffectiveType())) {
			List<EvaluationStep> evaluationStepWasteList = evaluationStepService.getEvaluationStepListByType(tenderProject.getId(), EvaluationStepEnum.WASTE_BID);
			if (null != evaluationStepWasteList && evaluationStepWasteList.size() > 0) {
				if (evaluationStep.getSortNo() > evaluationStepWasteList.get(0).getSortNo()) {
					return Messages.Evaluation_wasteTips;
				} 
			}else {
				return Messages.Evaluation_wasteTips;
			}
		}
		// 如果是手动控制评标进度
		if (EvaluationStepEnum.ORDER_OPERATOR.equals(projectRule.getOrderReview())) {
			if (!CommonEnum.START.equals(evaluationStep.getControlStatus())) {
				return MessageFormat.format(Messages.Tips_notAllowEvaluation, evaluationStep.getStepName());
			}
		}
		// 按整体进度，所有专家评标结束后才能进行下一步评标
		else if (EvaluationStepEnum.ORDER_REVIEW_YES.equals(projectRule.getOrderReview()) && evaluationStep.getSortNo() > 1) {
			// 标书清标（暂不受进度控制）
			if (EvaluationStepEnum.PRE_EVALUATION.equals(evaluationStep.getStepType())) return null;
			// 获得当前评标步骤之前且未完成的评标步骤
	 		EvaluationStep noStartPreEvaluationStep = evaluationStepService.getPreNoStarEvaluationStep(tenderProject.getId(), evaluationStep.getSortNo());
			if (null != noStartPreEvaluationStep) {
				return MessageFormat.format(Messages.Tips_preStepNotCompleted, noStartPreEvaluationStep.getStepName());
			}
		}
		// if(ObjectUtils.equals(tenderProjectEntity.getTenderType(),
		// TenderProjectEnum.TENDER_YTPE_ZFCG)){
		// SupplierService supplierService = new SupplierService();
		// List<Supplier> supplierList = supplierService.getEvaluationStepSupplierList(tenderProjectEntity.getId(), evaluationStep);
		// if(null == supplierList || supplierList.size() < 3){
		// return com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType())+"已不足三家， 请进行废标处理！";
		// }
		// }
		return null;
	}
	
	/**
	 * @Description: 点击评标步骤事件
	 * @author guoyr
	 */
	private void evaluateAction(final StepButton stepButton) {
		if (!stepButton.getEnabled()) {
			return;
		}
		EvaluationStep evaluationStep = stepButton.getEvaluationStep();
		if (!stepButton.isComplate()) {
			String message = checkAllowEvaluation(evaluationStep);
			if (null != message) {
				MessageDialog.openWarning(getShell(), message);
				return;
			}
		}
		
		if(null == resultMenu) {
			resultMenu = menu;
		}
		// 每次点击刷新新的步骤
		evaluationStep = evaluationStepService.getById(evaluationStep.getId());
		stepButton.setEvaluationStep(evaluationStep);
		stepButton.setData("evaluationStep", evaluationStep);
		Action action = null;
		if (EvaluationStepEnum.SIGIN.equals(evaluationStep.getStepType())) {
			if (stepButton.isComplate() || ExpertEnum.SIGN.equals(expert.getSignType())) {
				action = (Action) ActionUtil.getAction(ExpertSignResutlAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(ExpertSignEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.FEATURE_CHECK.equals(evaluationStep.getStepType())) {// 特征码检查
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(FeatureCodeCheckResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(FeatureCodeCheckEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		}  else if (evaluationStep.getStepType().equals(EvaluationStepEnum.ASSOCIATION_QUERY)) {// 关联关系评审
			// 如果未完成
			if (null == stepButton.getData("complate")) {
				action = (Action) ActionUtil.getAction(TianYanCheckEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			} else {
				action = (Action) ActionUtil.getAction(TianYanCheckResultAction.class.getName());
			}
		} else if (evaluationStep.getStepType().equals(EvaluationStepEnum.CLEAN_TENDER)) {// 清标
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(ClearTenderEvaluationResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(ClearTenderEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (evaluationStep.getStepType().equals(EvaluationStepEnum.BUSINESS_VETO)) {
            if (stepButton.isComplate()) {
            	action = ActionUtil.getAction(BusinessVetoEvaluationResultAction.class.getName());
			} else {
				action = ActionUtil.getAction(BusinessVetoEvaluationAction.class.getName());
                action.setData("expertEvaluationListener", expertEvaluationListener);
                action.addActionListener(evaluationMainActionListener);
			}
		} else if (evaluationStep.getStepType().equals(EvaluationStepEnum.BILL)) {// 清单
			if (stepButton.isComplate()) {
				action = ActionUtil.getAction(BusinessEvaluationResultAction.class.getName());
			} else {
				action = ActionUtil.getAction(BusinessEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.TOTAL_PRICE.equals(evaluationStep.getStepType())) {
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(TotalPriceEvaluationResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(TotalPriceEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.MULTI_ROUNDS_PRICE.equals(evaluationStep.getStepType())) {
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(MultiWheelPriceEvaluationResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(MultiWheelPriceEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
			
		} else if (EvaluationStepEnum.BID_PRICE_LIMIT.equals(evaluationStep.getStepType())) {// 限价
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(LimitPriceEvaluationResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(LimitPriceEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.RECOMMONED_RANK.equals(evaluationStep.getStepType())) {// 推荐排名
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(RecommendRankEvaluationResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(RecommendRankEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.VETO_BID.equals(evaluationStep.getStepType())) {// 否决投标
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(VetoBidEvaluationResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(VetoBidEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.CREDIT.equals(evaluationStep.getStepType())) {// 信用得分
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(CreditEvaluationResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(CreditEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.PRE_EVALUATION.equals(evaluationStep.getStepType())) {
			if (stepButton.isComplate()) {
				action = ActionUtil.getAction(PreEvaluationResultAction.class.getName());
			} else {
				action = ActionUtil.getAction(PreEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.setData("curUser", Constants.USER);
			}
		} else if (EvaluationStepEnum.COMPLIANCE.equals(evaluationStep.getStepType())) {
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(ComplianceEvaluationResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(FactorEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.setData("showEvaluationView", "true");
			}
		} else if (EvaluationStepEnum.DETAIL.equals(evaluationStep.getStepType()) || EvaluationStepEnum.FIXED_FACTOR.equals(evaluationStep.getStepType())) {
			if (stepButton.isComplate()) {
				if (EvaluationStepEnum.SUMMARY_SCORE_BY_QUALIFIED.equals(evaluationStep.getSummaryType())) {
					action = (Action) ActionUtil.getAction(ComplianceEvaluationResultAction.class.getName());
				} else {
					action = (Action) ActionUtil.getAction(ScoreEvaluationResultAction.class.getName());
				}
			} else {
				action = (Action) ActionUtil.getAction(FactorEvaluationAction.class.getName());
				action.setData("showEvaluationView", "true");
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.EDIT_PRICE.equals(evaluationStep.getStepType())) {
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(EditPriceResultAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(EditPriceAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.PRICE.equals(evaluationStep.getStepType())) {
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(PriceEvaluationResultAction.class.getName());
				action.addActionListener(this);
			}else {
				// 如果存在项目经理评审操作，在推荐时重新查询所有的评标步骤，以验证是否全已经评标完成，避免需要手动刷新才能操作
				if (existOperatorEvaluation && null != evaluationStepList) {
					evaluationStepList.clear();
					evaluationStepList = evaluationStepService.getEvaluationStepList(tenderProject.getId());
				}
				action = (Action) ActionUtil.getAction(PriceEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
			
		} else if (EvaluationStepEnum.RECOMMONED.equals(evaluationStep.getStepType())) {
			// 如果专家未完成当前操作
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(RecommonedEvaluationResultAction.class.getName());
				List<EvaluationStep> recommonedRankList = evaluationStepService.getEvaluationStepListByType(tenderProject.getId(), EvaluationStepEnum.RECOMMONED_RANK);
				if (null != recommonedRankList && recommonedRankList.size() > 0) {
					action.setData(EvaluationStepEnum.RECOMMONED_RANK, recommonedRankList.get(0));
				}
			}else {
				// 如果存在项目经理评审操作，在推荐时重新查询所有的评标步骤，以验证是否全已经评标完成，避免需要手动刷新才能操作
				if (existOperatorEvaluation && null != evaluationStepList) {
					evaluationStepList.clear();
					evaluationStepList = evaluationStepService.getEvaluationStepList(tenderProject.getId());
				}
				action = (Action) ActionUtil.getAction(RecommonedEvaluationAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		} else if (EvaluationStepEnum.WASTE_BID.equals(evaluationStep.getStepType())) {// 废标
			if (stepButton.isComplate()) {
				action = (Action) ActionUtil.getAction(AbandonEvalutionAction.class.getName());
			} else {
				action = (Action) ActionUtil.getAction(AbandonEvalutionAction.class.getName());
				action.setData("expertEvaluationListener", expertEvaluationListener);
				action.addActionListener(evaluationMainActionListener);
			}
		}
		if (null != action) {
			if (null != tenderProject.getParentId()) {
				action.setData("tenderPackageName", "[" + tenderProject.getTenderNo() + "]" + tenderProject.getTenderName() + "");
			}
			action.setData("evaluationStep", evaluationStep);
			action.setData("tenderProjectRuleEntity", projectRule);
			if(stepButton.isComplate()) {
				action.setMenu(resultMenu);
			}else {
				action.setMenu(menu);
			}
			action.setData(Constants.CUR_EXPERT, expert);
			action.setData(Constants.OPERATOR_USERID, Constants.USER.getId());
			getShell().setData("evaluationStep", evaluationStep);
			getShell().setData(Constants.CUR_EXPERT, expert);
			getShell().setData("expertEvaluationListener", expertEvaluationListener);
			action.addActionListener(this);
			action.setTenderProject(tenderProject);
			action.setTenderProjectRule(projectRule);
			action.setEvaluationStep(evaluationStep);
			action.run();
		}
	}
	
	/**
	 * @Description:分配评审要素单元
	 * @author wangxiang
	 */
	private void assignEvalGroupAction() {
		AssignEvalGroupDialog assignEvalGroupDialog = new AssignEvalGroupDialog(getShell(), tenderProject, new CallBack() {
			public void callBack() {
				expert = expertService.getExpert(tenderProject.getId(), Constants.USER.getId());
				if (null == expert) {
					expert = new Expert();
					LOG.error("未获取取当前专家！");
				}
				refreshEvaluationStepList();
			}
		});
		assignEvalGroupDialog.setTitle(Messages.Button_assignEvalGroup);
		assignEvalGroupDialog.open();
	}
	
	/**
	 * @Description: 设置工作人员
	 * @author chenxw
	 */
	private void setWorkerAction() {
		EvaluationGroupDialog dialog = new EvaluationGroupDialog(getShell(), tenderProject);
		dialog.setTitle(setWorkerButton.getText());
		dialog.open();
	}
	
	/**
	 * @Description: 我的审核
	 * @author chenxw 
	 * @param isAudit 
	 */
	private void myAuditAction() {
		MyAuditDialog auditDialog = new MyAuditDialog(getShell(), tenderProject, CommonEnum.IN_EXPERT_REVIEW);
		auditDialog.open();
	}
	
	/**
	 * @Description: 查看清标结果
	 * @author chenxw 
	 */
	private void viewPreEvalResultAction() {
		Action action = ActionUtil.getAction(PreEvaluationResultAction.class.getName());
		action.setTenderProject(tenderProject);
		action.setTenderProjectRule(projectRule);
		action.setData(Constants.CUR_EXPERT, expert);
		action.setData(Constants.OPERATOR_USERID, Constants.USER.getId());
		getShell().setData(Constants.CUR_EXPERT, expert);
		getShell().setData("expertEvaluationListener", expertEvaluationListener);
		action.addActionListener(this);
		action.run();
	}
	
	private void wasteBidddingAction() {
		if (!ObjectUtils.equals(expert.getSignType(), ExpertEnum.SIGN)) {
			MessageDialog.openInformation(getShell(), Messages.Tips_signInFirst);
			return;
		}
		List<EvaluationStep> evaluationStepList = evaluationStepService.getEvaluationStepListByType(tenderProject.getId(), EvaluationStepEnum.WASTE_BID);
		if (null != evaluationStepList && evaluationStepList.size() > 0) {
			MessageDialog.openInformation(getShell(), Messages.Tips_alreadyWaste);
			return;
		}
		final WasteBidStepDialog abandonStepDialog = new WasteBidStepDialog(getShell(), tenderProject, null);
		abandonStepDialog.setCallBack(new CallBack() {
			public void callBackObject(Object obj) {
				abandonStepDialog.close();
				refreshEvaluationStepList();
			}
		});
		abandonStepDialog.setTitle(Messages.Step_wasteBidding);
		abandonStepDialog.open();
	}
	
	/**
	 * @Description: 生成报表
	 * @author guoyr
	 */
	private void createReportAction() {
		EvaluationReportDialog dialog = new EvaluationReportDialog(getShell(), tenderProject, /** TemplateFileEnum.EVALUATION_REPORT **/
		null, EvaluationReportComposite.REPORT_EVAL_EXPERT);
		dialog.setTitle(Messages.Button_generateReport);
		// 最大化和关闭
		dialog.setOperator(SWT.MAX | SWT.CLOSE);
		dialog.open();
	}
	
	/**
	 * @Description: 清空完成区域
	 * @author guoyr
	 */
	private void cleanComplateComposite() {}
	
	protected void checkSubclass() {

	}
	
	public void addEvaluationActionListener(ActionListener evaluationActionListener) {
		this.evaluationMainActionListener = evaluationActionListener;
	}
	
	public void onLoad(Action action) {
		action.setData("tenderProjectEntity", tenderProject);
		action.setData(Constants.CUR_EXPERT, expert);
//		for (Control control : complateComposite.getChildren()) {
//			control.dispose();
//		}
		
		myEvaluationShell = new MeetingRoomOpenShell(getShell(), tenderProject, null != action.getData("showEvaluationView"));
		myEvaluationShell.setMaximized(false);
		myEvaluationShell.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
//				refreshAction();
			}
		});
		myEvaluationShell.open();
	}
	
	public void loadComposite(Action action, Composite composite) {
		myEvaluationShell.getParentComposite().layout();
	}
	
	public Composite getParentComposite() {
		return myEvaluationShell.getParentComposite();
	}

	@Override
	public void refresh(TenderProjectEntity tenderProject) {
		this.tenderProject = tenderProject;
		refreshAction();	
	}
//	private void FileDelete(File file){
//		if(file.exists() && file.isFile()){
//			file.delete();
//		}else if(file.exists() && file.isDirectory()){
//			for(File childrenFile : file.listFiles()){
//				FileDelete(childrenFile);
//			}
//		}
//	}
}
