package com.gx.obe.evaluation.composite;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.tools.ole.DocumentFactory;
import com.gx.tools.ole.DocumentLoader;

/**
 * @Description: 打开文档面板
 * @author guoyr
 */
public class OpenDocumentComposite extends Composite {
	private File documentFile;
	private boolean readOnly = false;
	private boolean showMenu = true;
	private Composite composite;

	/**
	 * @param parent
	 * @param documentFile
	 */
	public OpenDocumentComposite(Composite parent, File documentFile) {
		this(parent, documentFile, false);
	}

	/**
	 * @wbp.parser.constructor
	 */
	public OpenDocumentComposite(Composite parent, File documentFile, boolean readOnly) {
		this(parent, documentFile, true, readOnly);
	}
	public OpenDocumentComposite(Composite parent, File documentFile, boolean showMenu, boolean readOnly) {
		this(parent, SWT.NONE);
		this.documentFile = documentFile;
		this.readOnly = readOnly;
		this.showMenu = showMenu;
	}
	
	public OpenDocumentComposite(Composite parent, int style) {
		super(parent, style);
		setLayout(new GridLayout(1, false));
		
		composite = new Composite(this, SWT.NONE);
		composite.setLayout(new FillLayout(SWT.HORIZONTAL));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
	}

	public void init(){
		DocumentLoader documentLoader = DocumentFactory.getDocumentLoader(null != documentFile&& documentFile.exists()?documentFile.getAbsolutePath():null, PropertiesUtils.getProperty(ConfigConstants.PDF_ACTIVE_TYPE, DocumentFactory.DEFAULT_PDF_TYPE));
		if(!showMenu){
			documentLoader.setShowMenu(showMenu);
		}
		documentLoader.openDocument(composite, readOnly);
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
