package com.gx.obe.evaluation.composite;

import java.text.MessageFormat;
import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.listener.KeyEnterListener;
import org.eclipse.swt.core.listener.TextHintListener;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.Loading;
import com.gx.obe.common.widget.composite.PageFoodComposite;
import com.gx.obe.common.widget.composite.PageFoodComposite.PageListener;
import com.gx.obe.common.widget.thread.SyncThread;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.evaluation.listener.ExpertEvaluationRoomListener;
import com.gx.obe.evaluation.shell.EvaluationRoomShell;
import com.gx.obe.evaluation.shell.EvaluationRoomWideShell;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Page;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderProjectVo;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 评标项目
 * @author guoyr
 */
public class TenderProjectListComposite extends Composite implements ActionListener{
	
	private final String searchTip = Messages.TenderProjectListComposite_searchProject;
	private ScrolledComposite scrolledComposite;
	private Composite contentComposite;
	public static int PAGE_SIZE = 0;
	public static int CUR_PAGE_NO = 1;
	private PageFoodComposite pageFoodComposite;
	private CLabel label_1;
	private ProjectEvaluateListener projectOpListener;
	private Composite topComposite;
	private Text search_key_text;
	private CLabel search_btn;
	private Composite useTypeComposite;
	public static String complateStatus = null;
	public static Date startTime;
	public static Date endTime;
	public static String searchKey;
	private Label selectStatusLabel;
	private CLabel selectUseStatusIco;
	private Composite timeComposite;
	private Label selectTimeLabel;
	public static String SELECT_TIME_TYPE = Messages.Date_thisWeek;
	private CLabel selectTimeIco;
	private Composite queryComposite;
	private Menu menu;
	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	private TenderProjectService tenderProjectService;
	private GridLayout gl_contentComposite;
	
	{
		LogUtils.logClass(TenderProjectListComposite.class);
	}
	
	/**
	 * @param parent
	 * @param style
	 */
	public TenderProjectListComposite(Composite parent, Menu menu, int style) {
		super(parent, style);
		topComposite = parent;
		this.menu = menu;
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
			}
		});
		GridLayout gl_this = new GridLayout(1, false);
		gl_this.verticalSpacing = 0;
		gl_this.marginHeight = 0;
		gl_this.marginWidth = 0;
		setLayout(gl_this);
		
		Composite operateGroup = new Composite(this, SWT.NONE);
		operateGroup.setBackgroundMode(SWT.INHERIT_FORCE);
		operateGroup.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));

		GridData gd_groupOperate = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		operateGroup.setLayoutData(gd_groupOperate);
		GridLayout gl_operateGroup = new GridLayout(2, false);
		gl_operateGroup.marginHeight = 10;
		operateGroup.setLayout(gl_operateGroup);
		operateGroup.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		label_1 = new CLabel(operateGroup, SWT.NONE);
		GridData gd_label_1 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		label_1.setLayoutData(gd_label_1);
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		label_1.setText(Messages.TenderProjectListComposite_myProject);
		label_1.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		queryComposite = new Composite(operateGroup, SWT.TOOL);
		queryComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		queryComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		queryComposite.setBackground(ColorConstants.SKIN_BG);
		GridLayout gl_queryComposite = new GridLayout(6, false);
		gl_queryComposite.horizontalSpacing = 0;
		gl_queryComposite.marginWidth = 1;
		gl_queryComposite.marginHeight = 1;
		queryComposite.setLayout(gl_queryComposite);
		
		timeComposite = new Composite(queryComposite, SWT.NONE);
		GridData gd_timeComposite = new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1);
		gd_timeComposite.minimumWidth = 100;
		timeComposite.setLayoutData(gd_timeComposite);
		timeComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_timeComposite = new GridLayout(2, false);
		gl_timeComposite.marginLeft = 2;
		gl_timeComposite.horizontalSpacing = 0;
		gl_timeComposite.marginWidth = 10;
		timeComposite.setLayout(gl_timeComposite);
		
		selectTimeLabel = new Label(timeComposite, SWT.CENTER);
		selectTimeLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		selectTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		selectTimeLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		selectTimeLabel.setText(Messages.Date_today);
		
		selectTimeIco = new CLabel(timeComposite, SWT.NONE);
		selectTimeIco.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/data.png"));
		
		ESepator timeSep = new ESepator(queryComposite, SWT.VERTICAL);
		timeSep.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 1));
		timeSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		useTypeComposite = new Composite(queryComposite, SWT.NONE);
		useTypeComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		useTypeComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_useTypeComposite = new GridLayout(2, false);
		gl_useTypeComposite.marginLeft = 5;
		gl_useTypeComposite.horizontalSpacing = 0;
		gl_useTypeComposite.marginWidth = 0;
		useTypeComposite.setLayout(gl_useTypeComposite);
		
		selectStatusLabel = new Label(useTypeComposite, SWT.NONE);
		selectStatusLabel.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, true, 1, 1));
		selectStatusLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		selectStatusLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		selectStatusLabel.setText(Messages.TenderProjectListComposite_allProject);
		selectUseStatusIco = new CLabel(useTypeComposite, SWT.NONE);
		selectUseStatusIco.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/arrow_down.png"));
		
		ESepator querySep = new ESepator(queryComposite, SWT.VERTICAL);
		querySep.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 1));
		querySep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite searchKeyComposite = new Composite(queryComposite, SWT.NONE);
		searchKeyComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		searchKeyComposite.setBackground(SWTResourceManager.getColor(255, 255, 255));
		searchKeyComposite.setLayout(new GridLayout(3, false));
		GridData gd_searchKeyComposite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_searchKeyComposite.widthHint = 300;
		searchKeyComposite.setLayoutData(gd_searchKeyComposite);
		
		CLabel searchImage = new CLabel(searchKeyComposite, SWT.NONE);
		searchImage.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/search.png"));
		searchImage.setText("");
		
		search_key_text = new Text(searchKeyComposite, SWT.NONE);
		search_key_text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		search_key_text.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		search_key_text.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		search_key_text.setTextLimit(50);
		
		CLabel label = new CLabel(searchKeyComposite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		label.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				search_key_text.setText("");
				search_key_text.setFocus();
			}
		});
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/clear.png"));
		label.setText("");
		
		Composite composite_5 = new Composite(queryComposite, SWT.NONE);
		GridData gd_composite_5 = new GridData(SWT.CENTER, SWT.CENTER, false, true, 1, 1);
		gd_composite_5.minimumWidth = 80;
		composite_5.setLayoutData(gd_composite_5);
		composite_5.setLayout(new GridLayout(1, false));
		
		search_btn = new CLabel(composite_5, SWT.NONE);
		search_btn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, true, 1, 1));
		search_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		search_btn.setLeftMargin(10);
		search_btn.setRightMargin(10);
		search_btn.setForeground(SWTResourceManager.getColor(255, 255, 255));
		search_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				searchTenderProject();
			}
		});
		search_btn.setText(Messages.TenderProjectListComposite_search);
		
		
		scrolledComposite = new ScrolledComposite(this, SWT.NONE | SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		contentComposite = new Composite(scrolledComposite, SWT.NONE);
		contentComposite.setBackground(SWTResourceManager.getColor(240, 240, 240));
		gl_contentComposite = new GridLayout(1, false);
		gl_contentComposite.marginWidth = 10;
		gl_contentComposite.marginHeight = 10;
		gl_contentComposite.verticalSpacing = 15;
		contentComposite.setLayout(gl_contentComposite);
		
		CLabel loading = new Loading(contentComposite, SWT.NONE);
		loading.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		
		scrolledComposite.setContent(contentComposite);
		scrolledComposite.setMinSize(contentComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		pageFoodComposite = new PageFoodComposite(this, SWT.NONE);
		pageFoodComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		init();

	}
	
	/**
	 * @Description: 界面数据初始化
	 * @author guoyr
	 */
	private void init() {
		tenderProjectService = new TenderProjectService();
		scrolledComposite.getVerticalBar().setIncrement(20);
		scrolledComposite.forceFocus();
		scrolledComposite.addListener(SWT.Activate, new Listener() {
	        public void handleEvent(Event e) {
	            scrolledComposite.setFocus();
	        }
	    });
		initListener();
		if(StringUtils.hasLength(searchKey)) {
			search_key_text.setText(searchKey);
			search_key_text.setSelection(0, search_key_text.getText().length());
		}
		getSelectTime(SELECT_TIME_TYPE);
		complateStatus = null;
		selectStatusLabel.setText(Messages.TenderProjectListComposite_allProject);
		queryProjectPage(CUR_PAGE_NO);
		
		pageFoodComposite.addPageListener(new PageListener(){
			public void changed(int pageNo, int pageSize) {
				queryProjectPage(pageNo);
			}
		});
		menuFunctionUtils.initFunctionAuthority(menu);
	}
	
	/**
	 * @Description: 根据条件查询投标项目信息列表
	 * @author guoyr
	 */
	private void searchTenderProject() {
		queryProjectPage(1);
	}

	/**
	 * @Description: 刷新投标项目列表
	 * @author guoyr
	 * @param pageNo
	 */
	private void queryProjectPage(int pageNo) {
		CUR_PAGE_NO = pageNo;
		searchKey = search_key_text.getText().trim();
		SyncThread syncThread = new SyncThread(new SyncThread.Runnable(){
			public void run() {
				computerPageSize();
				final Page<TenderProjectVo> projectPages = tenderProjectService.getEvaluationProjectPageList(Constants.USER.getId(), Constants.USER.getUserType(), complateStatus, searchKey, startTime, endTime, CUR_PAGE_NO, PAGE_SIZE);
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(contentComposite.isDisposed())return;
						for(Control control : contentComposite.getChildren()){
							control.dispose();
						}
						if(null != projectPages && null != projectPages.getRecords()){
							int index = 1;
							for(TenderProjectVo tenderProject : projectPages.getRecords()){
								TenderProjectItemComposite trComposite = new TenderProjectItemComposite(contentComposite, menuFunctionUtils, SWT.NONE);
								trComposite.addProjectOpListener(projectOpListener);
								trComposite.refresh(index ++, tenderProject);
								GridData gd_trComposite = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
								trComposite.setLayoutData(gd_trComposite);
							}
							pageFoodComposite.refreshPages(projectPages);
						}
						contentComposite.layout();
						scrolledComposite.setMinSize(contentComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
						scrolledComposite.forceFocus();
					}
				});	
			}
		});
		syncThread.start();
	}
	
	private void computerPageSize() {
		if(PAGE_SIZE == 0) {
			Display.getDefault().syncExec(new Runnable() {
				public void run() {
					if(!contentComposite.isDisposed()) {
						int contentHeight = contentComposite.getBounds().height;
						TenderProjectItemComposite trComposite = new TenderProjectItemComposite(contentComposite, menuFunctionUtils, SWT.NONE);
						int rowHeight = trComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT).y;
						contentHeight = contentHeight - gl_contentComposite.marginHeight * 2 - gl_contentComposite.verticalSpacing;
						PAGE_SIZE = contentHeight/(rowHeight + gl_contentComposite.verticalSpacing);
						PAGE_SIZE = Math.max(PAGE_SIZE, 5);
//						if(contentHeight % (rowHeight + gl_contentComposite.verticalSpacing) != 0) {
//							gl_contentComposite.verticalSpacing += (rowHeight/(PAGE_SIZE-1));
//						}
					}
				}
			});
		}
	}
	
	/**
	 * @Description: 
	 * @author guoyr 
	 */
	private void selectUseStatusAction(){
		EMenu eop = new EMenu(useTypeComposite);
		eop.addMenuItem(Messages.TenderProjectListComposite_allProject, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/project_parent.png"), true, new EMenu.ClickListener() {
			public void click() {
				complateStatus = null;
				selectStatusLabel.setText(Messages.TenderProjectListComposite_allProject);
				queryProjectPage(1);
			}
		});
		eop.addMenuItem(Messages.TenderProjectListComposite_unfinished, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/count_down.png"), true, new EMenu.ClickListener() {
			public void click() {
				complateStatus = CommonEnum.IN_PROGRESS;
				selectStatusLabel.setText(Messages.TenderProjectListComposite_unfinished);
				queryProjectPage(1);
			}
		});
		eop.addMenuItem(Messages.TenderProjectListComposite_finished, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/submit.png"), true, new EMenu.ClickListener() {
			public void click() {
				complateStatus = CommonEnum.COMPLETE;
				selectStatusLabel.setText(Messages.TenderProjectListComposite_finished);
				queryProjectPage(1);
			}
		});
		eop.open(useTypeComposite);
		Point point = eop.getLocation();
		point.x -= 1;
		point.y += 1;
		eop.setLocation(point);
	}
	/**
	 * @Description: 
	 * @author guoyr 
	 */
	private void selectTimeAction(){
		EMenu eop = new EMenu(timeComposite);
		eop.addMenuItem(Messages.Date_today, null, true, new EMenu.ClickListener() {
			public void click() {
				getSelectTime(Messages.Date_today);
				queryProjectPage(1);
			}
		});
		eop.addMenuItem(MessageFormat.format(Messages.Date_nearlyDays, 3), null, true, new EMenu.ClickListener() {
			public void click() {
				getSelectTime(MessageFormat.format(Messages.Date_nearlyDays, 3));
				queryProjectPage(1);
			}
		});
		eop.addMenuItem(Messages.Date_thisWeek, null, true, new EMenu.ClickListener() {
			public void click() {
				getSelectTime(Messages.Date_thisWeek);
				queryProjectPage(1);
			}
		});
		
		eop.addMenuItem(Messages.Date_thisMonth, null, true, new EMenu.ClickListener() {
			public void click() {
				getSelectTime(Messages.Date_thisMonth);
				queryProjectPage(1);
			}
		});
		eop.addSeparator();
		eop.addMenuItem(Messages.Date_lastWeek, null, true, new EMenu.ClickListener() {
			public void click() {
				getSelectTime(Messages.Date_lastWeek);
				queryProjectPage(1);
			}
		});
		eop.addMenuItem(Messages.Date_lastMonth, null, true, new EMenu.ClickListener() {
			public void click() {
				getSelectTime(Messages.Date_lastMonth);
				queryProjectPage(1);
			}
		});
		eop.addSeparator();
		eop.addMenuItem(Messages.Date_nextWeek, null, true, new EMenu.ClickListener() {
			public void click() {
				getSelectTime(Messages.Date_nextWeek);
				queryProjectPage(1);
			}
		});
		eop.addMenuItem(Messages.Date_nextMonth, null, true, new EMenu.ClickListener() {
			public void click() {
				getSelectTime(Messages.Date_nextMonth);
				queryProjectPage(1);
			}
		});
		eop.addSeparator();
		eop.addMenuItem(Messages.Date_all, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/items.png"), true, new EMenu.ClickListener() {
			public void click() {
				getSelectTime(Messages.Date_all);
				queryProjectPage(1);
			}
		});
		eop.open(timeComposite);
		Point point = eop.getLocation();
		point.x -= 1;
		point.y += 1;
		eop.setLocation(point);
	}
	
	
	private void getSelectTime(String selectTimeType) {
		SELECT_TIME_TYPE = selectTimeType;
		if(Messages.Date_today.equals(selectTimeType)) {
			startTime = DateUtils.getDayBegin();
			endTime = DateUtils.getDayEnd();
			selectTimeLabel.setText(Messages.Date_today);
		}else if(MessageFormat.format(Messages.Date_nearlyDays, 3).equals(selectTimeType)) {
			startTime = DateUtils.getDayBegin(-1);
			endTime = DateUtils.getDayEnd(1);
			selectTimeLabel.setText(MessageFormat.format(Messages.Date_nearlyDays, 3));
			selectTimeLabel.setText(MessageFormat.format(Messages.Date_nearlyDays, 3));
		}else if(Messages.Date_thisWeek.equals(selectTimeType)) {
			startTime = DateUtils.getBeginDayOfWeek();
			endTime = DateUtils.getEndDayOfWeek();
			selectTimeLabel.setText(Messages.Date_thisWeek);
		}else if(Messages.Date_lastWeek.equals(selectTimeType)) {
			startTime = DateUtils.getBeginDayOfWeek(-1);
			endTime = DateUtils.getEndDayOfWeek(-1);
			selectTimeLabel.setText(Messages.Date_lastWeek);
		}else if(Messages.Date_nextWeek.equals(selectTimeType)) {
			startTime = DateUtils.getBeginDayOfWeek(1);
			endTime = DateUtils.getEndDayOfWeek(1);
			selectTimeLabel.setText(Messages.Date_nextWeek);
		}else if(Messages.Date_thisMonth.equals(selectTimeType)) {
			startTime = DateUtils.getBeginDayOfMonth();
			endTime = DateUtils.getEndDayOfMonth();
			selectTimeLabel.setText(Messages.Date_thisMonth);
		}else if(Messages.Date_lastMonth.equals(selectTimeType)) {
			startTime = DateUtils.getBeginDayOfMonth(-1);
			endTime = DateUtils.getEndDayOfMonth(-1);
			selectTimeLabel.setText(Messages.Date_lastMonth);
		}else if(Messages.Date_nextMonth.equals(selectTimeType)) {
			startTime = DateUtils.getBeginDayOfMonth(1);
			endTime = DateUtils.getEndDayOfMonth(1);
			selectTimeLabel.setText(Messages.Date_nextMonth);
		}else{
			startTime = null;
			endTime = null;
			selectTimeLabel.setText(Messages.Date_all);
		}
	}
	
	/**
	 * @Description: 初始化监听
	 * @author guoyr
	 */
	private void initListener(){
		MouseListener selectStatusListener = new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				selectUseStatusAction();
			}
		};
		selectStatusLabel.addMouseListener(selectStatusListener);
		selectUseStatusIco.addMouseListener(selectStatusListener);
		
		MouseListener selectTimeListener = new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				selectTimeAction();
			}
		};
		selectTimeLabel.addMouseListener(selectTimeListener);
		selectTimeIco.addMouseListener(selectTimeListener);
		
		// 查询监听
		addSearchListener();
		// 进入项目的事件
		
		// 项目操作监听
		projectOpListener = new ProjectEvaluateListener(){

			public void configPageSize() {
			}

			public void enterProject(TenderProjectEntity tenderProject) {
//				enterProjectAction.run();
				ExpertEvaluationRoomListener evaluationRoomShell = null;
				if("01".equals(PropertiesUtils.getProperty(ConfigConstants.ROOM_USE_WIDEN_SCREEN_, "00"))){
					evaluationRoomShell = new EvaluationRoomWideShell(getShell());
				}else {
					evaluationRoomShell = new EvaluationRoomShell(getShell());
				}
				Composite parentComposite = evaluationRoomShell.getLoadParent();
				parentComposite.setData("tenderProjectEntity", tenderProject);
				parentComposite.setData("menu", menu);
				parentComposite.setData("meetingRoomListener", evaluationRoomShell);
				ExpertEvalautionRoomHomeComposite bidOpeningRemoteComposite = new ExpertEvalautionRoomHomeComposite(parentComposite, SWT.NONE);
				bidOpeningRemoteComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
				parentComposite.layout();
				evaluationRoomShell.open();
			}

			public void addChildProject(TenderProjectEntity tenderProject) {
			}
		};
	}
	
	/**
	 * @Description: 添加搜索框监听
	 * @author guoyr
	 */
	private void addSearchListener(){
		search_key_text.addPaintListener(new TextHintListener(searchTip));
		
		// 加入加回车事件
		new KeyEnterListener(search_key_text, new CallBack(){
			@Override
			public void callBack() {
				search_btn.notifyListeners(SWT.MouseUp, null);
			}
		});
	}
	
	public interface ProjectEvaluateListener{
		public void enterProject(TenderProjectEntity tenderProject);
		public void configPageSize();
		public void addChildProject(TenderProjectEntity tenderProject);
	}
	protected void checkSubclass() {
	}

	public void onLoad(Action action) {
		Control[] controls = topComposite.getChildren();
		for(Control control : controls){
			control.dispose();
		}
	}

	public void loadComposite(Action action, Composite composite) {
		topComposite.layout();
	}

	public Composite getParentComposite() {
		return topComposite;
	}
}
