package com.gx.obe.evaluation.dialog;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.file.upload.UploadFileUtil;
import com.gx.obe.common.file.upload.infer.UploadFileListener;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.components.core.Constants;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.utils.ScreenUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 屏幕录制
 * @author chenxw
 */
public class AdobeCaptivateDialog  {
	
//	private static VideoRecord videoRecord;
	static final String DEFAULT_FILE_PATH = System.getProperty("java.io.tmpdir");
//	static String  currentFilePath = DEFAULT_FILE_PATH + Constants.USER.getUserAccount() + "/" + "test";
	
	static String  currentFilePath = FileConstants.getInstallPath().concat("video").concat(File.separator).concat("desktop");
//	static String  currentFilePath = "D:\\test";
	static String currentFileName = "test";
	private ImageButton startRecordButton;
	
	private ImageButton stopRecordButton;
	
	private ImageButton uploadVideoButton;
	
	private ImageButton exportVideoButton;
	private CLabel title;
	
	public static AdobeCaptivateDialog dialog;
	private static Shell shell;
	private static String inprogressId;
	private static String videoId;
	private static double DPI_RATE = 1d;
	
	public static AdobeCaptivateDialog getInstance(double _DPI_RATE) {
		if(null == dialog || null == shell || shell.isDisposed()) {
			dialog =  new AdobeCaptivateDialog();
		}
		if(_DPI_RATE > 1) {
			DPI_RATE = _DPI_RATE;
		}
		return dialog; 
	}
	


	/**
	 * Open the window.
	 */
	public void open(String _videoId,String tenderName) {
		
		videoId = _videoId;
		if(null != shell && !shell.isDisposed()) {
			shell.setVisible(true);
			shell.setActive();
			return ;
		}
		SimpleDateFormat timeFormat = new SimpleDateFormat("yyyyMMddHHmmss");
		currentFileName = tenderName.concat("_").concat(Constants.USER.getUserName()).concat("_").concat(timeFormat.format(new Date())) ;
		Display display = Display.getDefault();
		shell = new Shell(SWT.NO_TRIM);
		shell.setText("桌面录屏系统");
		GridLayout gl_titleComposite = new GridLayout(1, false);
		gl_titleComposite.marginHeight = 0;
		gl_titleComposite.marginWidth = 0;
		gl_titleComposite.verticalSpacing = 0;
		shell.setLayout(gl_titleComposite);
		createDialogArea(shell);
		shell.pack();
		shell.open();
		SwtUtils.setCenter(shell);
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}
	/**
	 * @wbp.parser.entryPoint
	 */
	private void createDialogArea(Shell shell) {
		
		Composite container = new Composite(shell, SWT.NONE);
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.marginHeight = 0;
		gl_container.marginWidth = 0;
		container.setLayout(gl_container);
		
		Composite titleComposite = new Composite(container, SWT.NONE);
		titleComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		titleComposite.setBackground(ColorConstants.SKIN_BG);
		GridLayout gl_titleComposite = new GridLayout(3, false);
		gl_titleComposite.marginHeight = 0;
		gl_titleComposite.marginWidth = 0;
		gl_titleComposite.verticalSpacing = 0;
		titleComposite.setLayout(gl_titleComposite);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1, 1));

		title = new CLabel(titleComposite, SWT.NONE);
		title.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		title.setText("桌面录制");
		title.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		title.setForeground(ColorConstants.SKIN_FOREGROUND);
		
		ImageButton min_btn = new ImageButton(titleComposite, SWT.NONE | SWT.SELECTED);
		min_btn.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, true, false, 1, 1));
		min_btn.setBorderColor(ColorConstants.SKIN_ACTIVE_BG);
		min_btn.setBackground(ColorConstants.SKIN_ACTIVE_BG);
		min_btn.setActiveBackgroundColor(SWTResourceManager.getColor(SWT.COLOR_RED));
		min_btn.setMargins(10, 10, 5, 5);
		min_btn.setAlpha(200);
		min_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/min_size.png"));
		min_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				closeAction();
			}
		});
		
		ImageButton close_btn = new ImageButton(titleComposite, SWT.NONE | SWT.SELECTED);
		close_btn.setLayoutData(new GridData(SWT.FILL, SWT.TOP, false, false, 1, 1));
		close_btn.setBorderColor(ColorConstants.SKIN_ACTIVE_BG);
		close_btn.setBackground(ColorConstants.SKIN_ACTIVE_BG);
		close_btn.setActiveBackgroundColor(SWTResourceManager.getColor(SWT.COLOR_RED));
		close_btn.setMargins(10, 10, 5, 5);
		close_btn.setAlpha(200);
		close_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_close.png"));
		close_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				minAction();
			}
		});
		
		Composite composite = new Composite(container, SWT.NONE);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite.heightHint = 120;
		gd_composite.widthHint = 350;
		composite.setLayoutData(gd_composite);
		GridLayout gl_composite = new GridLayout(4, true);
		gl_composite.marginHeight = 20;
		gl_composite.marginWidth = 20;
		composite.setLayout(gl_composite);
		
		startRecordButton = addButton(composite, SWT.NONE);
		startRecordButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		startRecordButton.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				startRecordAction();
			}
		});
		startRecordButton.setText("启动录制");
		
		stopRecordButton = addButton(composite, SWT.NONE);
		stopRecordButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		stopRecordButton.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				stopRecordAction();
			}
		});
		stopRecordButton.setText("停止录制");
		
		exportVideoButton = addButton(composite, SWT.NONE);
		exportVideoButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		exportVideoButton.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				exportVideoAction();
			}
		});
		exportVideoButton.setText("打开目录");
		
		uploadVideoButton = addButton(composite, SWT.NONE);
		uploadVideoButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		uploadVideoButton.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				uploadVideoAction();
			}
		});
		uploadVideoButton.setText("上传视频");
		
		init();
		
	}
	
	
	private ImageButton addButton(Composite composite, int Style) {
		ImageButton startRecordButton = new ImageButton(composite, SWT.NONE);
		startRecordButton.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		startRecordButton.setBorderColor(ColorConstants.SKIN_BG);
		startRecordButton.setForeground(ColorConstants.FONT_BLACK_COLOR);
		startRecordButton.setActiveBorderColor(ColorConstants.SKIN_ACTIVE_BG);
		startRecordButton.setActiveBgColor(ColorConstants.SKIN_ACTIVE_BG);
		startRecordButton.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		startRecordButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		startRecordButton.setEnabled(false);
		return startRecordButton;
	}
	
	
	private void init() {
		SwtUtils.setMouseDragListener(title);
//		videoRecord = VideoRecord.getVideoRecord();
//		if (null != videoRecord) {
//			boolean isStart = videoRecord.isStart();
//			if (isStart) {
//				stopRecordButton.setEnabled(true);
//				return;
//			}
//		}
		startRecordButton.setEnabled(true);
	}
	
	/**
	 * @Description: 启动录制
	 * @author chenxw
	 */
	private void startRecordAction() {
		if (!startRecordButton.getEnabled()) {
			return;
		}
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(shell, false, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				if (!flag) {
					return;
				}
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
//						videoRecord.start();
						startRecordButton.setEnabled(false);
						stopRecordButton.setEnabled(true);
					}
				});
			}
		});
		new Thread(new Runnable() {
			public void run() {
				try {
					inprogressId = videoId;
					ScreenUtils screenUtils = new ScreenUtils();
					int wcreenWith = screenUtils.getScreenWight();
					int wcreenHeight = screenUtils.getScreenHight();
					if(DPI_RATE > 1) {
						wcreenWith = (int)(wcreenWith * DPI_RATE);
						wcreenHeight = (int)(wcreenHeight * DPI_RATE);
					}
//					videoRecord = VideoRecord.getInitVideoRecord(currentFilePath.concat(File.separator).concat(videoId),currentFileName, wcreenWith, wcreenHeight);
				} catch (java.lang.Exception e) {
					messageProgress.message("屏幕录制启动失败！", -1);
				}finally {
//					messageProgress.finish(null != videoRecord);
				}
			}
		}).start();
		messageProgress.setTitle("正在启动屏幕录制");
		messageProgress.open();
		
	}
	
	/**
	 * @Description: 停止录制
	 * @author chenxw
	 */
	private void stopRecordAction() {
		if (!stopRecordButton.getEnabled()) {
			return;
		}
//		if (null != videoRecord) {
//			videoRecord.stop();
//			stopRecordButton.setEnabled(false);
//			uploadVideoButton.setEnabled(true);
//			exportVideoButton.setEnabled(true);
//		}
	}
	
	/**
	 * @Description: 导出视频
	 * @author chenxw
	 */
	private void exportVideoAction() {
		if (!exportVideoButton.getEnabled()) {
			return;
		}
		RuntimeUtils.openDirector(currentFilePath.concat(File.separator).concat(videoId).concat(File.separator));
	}
	
	private void minAction() {
		shell.setMinimized(true);
	}
	private void closeAction() {
		shell.close();
	}
	/**
	 * @Description: 上传视频
	 * @author chenxw
	 */
	private void uploadVideoAction() {
		if (!uploadVideoButton.getEnabled()) {
			return;
		}
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(shell, false, 100, new LoadingAdatper() {
			public void finish(boolean flag) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						uploadVideoButton.setEnabled(true);
					}
				});
			}
			
		});
		messageProgress.setCountDownTime(3);	
		UploadFileUtil UploadFileUtil = new UploadFileUtil(currentFilePath.concat(File.separator).concat(videoId).concat(File.separator).concat(currentFileName).concat(".mp4"), videoId, Constants.USER.getUserAccount(), new UploadFileListener() {
			@Override
			public void computeherLoadProgress(int percent) {
				messageProgress.setProgress(percent);
			}
			
			@Override
			public void computeRemainingTimeCurrent(String time) {}
			
			@Override
			public void computeDownloadSpeed(String Speed) {
			}
			@Override
			public void MD5check(boolean isCheck) {}
			
			@Override
			public void Completed(boolean loginFlag) {
				messageProgress.finish(true);
			}
		} );
		UploadFileUtil.startUploadFileFile();
		uploadVideoButton.setEnabled(false);
		messageProgress.setTitle("正在上传视频请稍后...");
		messageProgress.open();
	}
}
