package com.gx.obe.evaluation.dialog;

import java.awt.Dimension;
import java.awt.Toolkit;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.action.bean.Action;
import com.gx.obe.common.composite.BrowseBidFileComposite;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;

/**
 * @Description:查看投标文件 
 * @author guoyr
 */
public class BrowseBidFileDialog extends EDialog {

	private TenderProjectEntity tenderProject;
	private Menu menu;

	{
		LogUtils.logClass(BrowseBidFileDialog.class);
	}

	/**
	 * @param parentShell
	 * @param tenderProjectEntity
	 */
	public BrowseBidFileDialog(Shell parentShell, Action action) {
		super(parentShell);
		this.tenderProject = action.getTenderProject();
		this.menu = action.getMenu();
		
	}

	/** 
	 * @Description: 
	 * @param parent
	 * @return
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		
		container.setData("tenderProjectEntity", tenderProject);
		container.setData("menu", menu);
		container.setLayout(new FillLayout(SWT.HORIZONTAL));
		new BrowseBidFileComposite(container, SWT.NONE);

		return container;
	}

	@Override
	protected Point getInitialSize() {
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); // 取得当前屏幕属性
		int w = d.width; // 获取屏幕宽度
		int h = d.height; // 获取屏幕高度
		return new Point(w * 80 / 100, h * 90 / 100);
	}
}
