package com.gx.obe.evaluation.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.file.composite.DownloadDecBidFileComposite;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 网络下载标书
 * @author guoyr 
 */
public class DownLoadBidFileOnLineWindow{
	protected Object result;
	private Composite menu_composite;
	private Composite top_composite;
	private Shell shell;
	private CLabel label;
	private TenderProjectEntity tenderProject;
	boolean showVideoLiving = false;
	
	boolean showDesktopLiving = false;
	
//	private String businessId;
//	private ScreenUtils  util = new ScreenUtils();
	
	private ELabel close_btn;

	public DownLoadBidFileOnLineWindow(TenderProjectEntity tenderProject){
		this.tenderProject = tenderProject;
	}
	
	public Shell getShell() {
		return shell;
	}
	public void setShell(Shell shell) {
		this.shell = shell;
	}
	
	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * @wbp.parser.entryPoint
	 */
	protected void createContents() {
		shell = new Shell(SWT.NO_TRIM);
		
		shell.setSize(800, 500);
		shell.setText("明文标书下载");
		GridLayout gl_shell = new GridLayout(1, false);
		gl_shell.horizontalSpacing = 0;
		gl_shell.verticalSpacing = 0;
		gl_shell.marginHeight = 1;
		gl_shell.marginWidth = 1;
		shell.setLayout(gl_shell);
		shell.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				disposedAction();
				
			}
		});
		shell.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/videoOpen.png"));
		
		top_composite = new Composite(shell, SWT.NONE);
		top_composite.setBackground(ColorConstants.SKIN_BG);
		top_composite.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_top_composite = new GridLayout(2, false);
		gl_top_composite.marginHeight = 0;
		gl_top_composite.marginWidth = 0;
		top_composite.setLayout(gl_top_composite);
		top_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		menu_composite = new Composite(top_composite, SWT.NONE);
		menu_composite.setLayout(new GridLayout(1, false));
		menu_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		label = new CLabel(menu_composite, SWT.NONE);
		label.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/voice_config.png"));
		label.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		label.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		label.setText("标书下载");
		
		
		Composite composite_2 = new Composite(top_composite, SWT.NONE | SWT.SELECTED);
		composite_2.setLayout(new GridLayout(2, false));
		
		ELabel min_size_btn = new ELabel(composite_2, SWT.NONE | SWT.SELECTED);
		min_size_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/min_size.png"));
		min_size_btn.setMargins(5, 5, 5, 5);
		min_size_btn.setActiveColor(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		min_size_btn.setAlpha(10);
		min_size_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				shell.setMinimized(true);
			}
		});
		close_btn = new ELabel(composite_2,SWT.NONE | SWT.SELECTED);
		close_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/close.png"));
		close_btn.setMargins(5, 5, 5, 5);
		close_btn.setActiveColor(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		close_btn.setAlpha(10);
		close_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				shell.close();
			}
		});
		SwtUtils.setMouseDragListener(label);
		SwtUtils.setCenter(shell);
		initDownLoadComposite();
		
	}
	/**
	 * @Description: 初始化下载界面
	 * @author guoyr 
	 */
	private void initDownLoadComposite(){
		DownloadDecBidFileComposite composite = new DownloadDecBidFileComposite(shell, tenderProject, false, SWT.NONE);
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.marginHeight = 5;
		gl_composite.marginWidth = 5;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
	}
	/**
	 * @Description: 注销事件
	 * @author guoyr 
	 */
	public void disposedAction(){
		if(null != shell && !shell.isDisposed()){
			shell.close();
		}
		
	}
}
