package com.gx.obe.evaluation.dialog;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.core.widgets.RectangleRadioButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.Worker;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.ImageRaido;
import com.gx.obe.common.widget.utils.ImageRaidoUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.components.core.enumeration.ExpertEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.CollectionUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.util.utils.UuidUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.evaluation.EvaluationGroup;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.WorkerService;
import com.gx.obe.web.service.evaluation.EvaluationGroupService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.service.expert.ExpertEvaluationStepService;
import com.gx.obe.web.service.expert.ExpertService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 
 * @author chenxw 
 */
public class EvaluationGroupDialog extends EDialog {
	
	private ExpertService expertService = new ExpertService();
	private WorkerService workerService = new WorkerService();
	private SupplierService supplierService = new SupplierService();
	private EvaluationStepService evaluationStepService = new EvaluationStepService();
	private ExpertEvaluationStepService expertEvaluationStepService = new ExpertEvaluationStepService();
	private EvaluationGroupService evaluationGroupService = new EvaluationGroupService();
	private final String TYPE_EXPERT = "01";
	private final String TYPE_WORKER = "02";
	private TenderProjectEntity tenderProject;
	private Composite evalBidTypeComposite;
	private Grid supplierGrid;
	private StackLayout stackLayout = new StackLayout();
	private Composite expertComposite;
	private Grid expertGrid;
	private Composite workerComposite;
	private Grid workerGrid;
	private Composite buttonComposite;
	private Composite userComposite;
	private ImageButton curButton;
	private CLabel thirdTip;
	private CLabel secondTip;
	private CLabel firstTip;
	private StyledText tipsSupplierLabel;
	private StyleRange tipsStyleRange;
	private String supplierName;
	private List<Expert> expertList;
	private List<Worker> workerList;
	private Map<String, Map<String, EvaluationGroup>> groupTypeMapSupplierMap;;
	private Map<String, String> userNameMap = new HashMap<String, String>();
	private List<EvaluationStep> preEvaluationStepList;
	
	/** 
	 * @author chenxw
	 * @param parentShell
	 * @param tenderProject 
	 */
	public EvaluationGroupDialog(Shell parentShell, TenderProjectEntity tenderProject) {
		super(parentShell);
		this.tenderProject = tenderProject;
		this.supplierName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType());
	}
	
	/** 
	 * @Description: 
	 * @author chenxw
	 * @param parent
	 * @return 
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite composite_5 = new Composite(container, SWT.NONE);
		composite_5.setLayout(new GridLayout(3, false));
		composite_5.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
//		
//		ESepator topSep = new ESepator(container, SWT.NONE);
//		topSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		topSep.setBackground(ColorConstants.SKIN_BG);
//		topSep.setLineStyle(SWT.LINE_DOT);
//		topSep.setLineWidth(3);
		
		Composite composite_2 = new Composite(container, SWT.NONE);
		composite_2.setBackground(ColorConstants.BORDER_LINE_COLOR);
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.verticalSpacing = 0;
		gl_composite_2.horizontalSpacing = 0;
		gl_composite_2.marginHeight = 1;
		gl_composite_2.marginWidth = 1;
		composite_2.setLayout(gl_composite_2);
		GridData gd_composite_2 = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite_2.heightHint = 200;
		composite_2.setLayoutData(gd_composite_2);
		
		Composite composite_8 = new Composite(composite_2, SWT.NONE);
		composite_8.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_8.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_composite_8 = new GridLayout(1, false);
		gl_composite_8.marginHeight = 0;
		gl_composite_8.marginWidth = 0;
		gl_composite_8.verticalSpacing = 0;
		composite_8.setLayout(gl_composite_8);
		composite_8.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite composite_7 = new Composite(composite_8, SWT.NONE);
		GridLayout gl_composite_7 = new GridLayout(5, false);
		gl_composite_7.marginHeight = 0;
		gl_composite_7.verticalSpacing = 0;
		gl_composite_7.horizontalSpacing = 0;
		composite_7.setLayout(gl_composite_7);
		composite_7.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		secondTip = new CLabel(composite_7, SWT.NONE);
		secondTip.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		secondTip.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		secondTip.setText("选择待评议的供应商");
		secondTip.setForeground(ColorConstants.FONT_BLUE_COLOR);
		secondTip.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/number_1.png"));
		
		ELink link = new ELink(composite_7, SWT.NONE);
		link.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectSupplierAction(true);
			}
		});
		link.setText(Messages.Button_selectAll);
		link.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		
		ELink link_1 = new ELink(composite_7, SWT.NONE);
		link_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectSupplierAction(false);
			}
		});
		link_1.setText(Messages.Button_selectInvert);
		link_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		
		ELink link_2 = new ELink(composite_7, SWT.NONE);
		link_2.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				GridUtils.checkAll(supplierGrid, 1, false);
			}
		});
		link_2.setText(Messages.Button_deselected);
		link_2.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/clear.png"));
		
		ESepator supplierSep = new ESepator(composite_8, SWT.NONE);
		supplierSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		supplierSep.setBackground(ColorConstants.BORDER_LINE_COLOR);
		
		supplierGrid = new Grid(composite_8, SWT.V_SCROLL);
		supplierGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		supplierGrid.setHeaderVisible(true);
		supplierGrid.setAutoHeight(true);
		supplierGrid.setAutoWidth(true);
		supplierGrid.setItemHeight(Constants.ROW_HIGHT);
		
		GridColumn indexColumn = new GridColumn(supplierGrid, SWT.CENTER);
		indexColumn.setText(Messages.Num);
		indexColumn.setWidth(50);
		indexColumn.setMaxmumWidth(50);
		
		GridColumn gridColumn = new GridColumn(supplierGrid, SWT.CHECK);
		gridColumn.setText(MessageFormat.format(Messages.NameFormat, supplierName));
		gridColumn.setWidth(300);
		gridColumn.setWordWrap(true);
		
		GridColumn gridColumn_1 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_1.setText(Messages.Business);
		gridColumn_1.setWidth(50);
		
		GridColumn gridColumn_2 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_2.setText(Messages.Technology);
		gridColumn_2.setWidth(50);
		
		GridColumn gridColumn_3 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_3.setText("经济");
		gridColumn_3.setWidth(50);
		
		Composite evalBidTypeParentComposite = new Composite(container, SWT.NONE);
		GridLayout gl_evalBidTypeParentComposite = new GridLayout(2, false);
		gl_evalBidTypeParentComposite.marginHeight = 0;
		evalBidTypeParentComposite.setLayout(gl_evalBidTypeParentComposite);
		evalBidTypeParentComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		firstTip = new CLabel(evalBidTypeParentComposite, SWT.NONE);
		firstTip.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		firstTip.setText("选择评议分类 ");
		firstTip.setForeground(ColorConstants.FONT_BLUE_COLOR);
		firstTip.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/number_2.png"));
		firstTip.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		evalBidTypeComposite = new Composite(evalBidTypeParentComposite, SWT.NONE);
		GridLayout gl_evalBidTypeComposite = new GridLayout(3, false);
		gl_evalBidTypeComposite.marginHeight = 0;
		evalBidTypeComposite.setLayout(gl_evalBidTypeComposite);
		evalBidTypeComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Composite composite_3 = new Composite(container, SWT.NONE);
		composite_3.setBackground(ColorConstants.BORDER_LINE_COLOR);
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 0;
		gl_composite_3.marginHeight = 1;
		gl_composite_3.marginWidth = 1;
		composite_3.setLayout(gl_composite_3);
		GridData gd_composite_3 = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite_3.heightHint = 150;
		composite_3.setLayoutData(gd_composite_3);
		
		buttonComposite = new Composite(composite_3, SWT.NONE);
		buttonComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_buttonComposite = new GridLayout(3, false);
		gl_buttonComposite.marginHeight = 0;
		buttonComposite.setLayout(gl_buttonComposite);
		buttonComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		thirdTip = new CLabel(buttonComposite, SWT.NONE);
		thirdTip.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		thirdTip.setText("选择评议的工作人员");
		thirdTip.setForeground(ColorConstants.FONT_BLUE_COLOR);
		thirdTip.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/number_3.png"));
		thirdTip.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		ESepator workerSep = new ESepator(composite_3, SWT.NONE);
		workerSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		workerSep.setBackground(ColorConstants.BORDER_LINE_COLOR);
		
		userComposite = new Composite(composite_3, SWT.NONE);
		userComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		userComposite.setLayout(stackLayout);
		userComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		expertComposite = new Composite(userComposite, SWT.NONE);
		GridLayout gl_expertComposite = new GridLayout(1, false);
		gl_expertComposite.marginWidth = 0;
		gl_expertComposite.marginHeight = 0;
		expertComposite.setLayout(gl_expertComposite);
		
		expertGrid = new Grid(expertComposite, SWT.V_SCROLL);
		expertGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		expertGrid.setHeaderVisible(true);
		expertGrid.setAutoHeight(true);
		expertGrid.setAutoWidth(true);
		expertGrid.setItemHeight(Constants.ROW_HIGHT);
		
		GridColumn expertIndexColumn = new GridColumn(expertGrid, SWT.CENTER);
		expertIndexColumn.setText(Messages.Num);
		expertIndexColumn.setWidth(50);
		
		GridColumn gridColumn_4 = new GridColumn(expertGrid, SWT.CENTER);
		gridColumn_4.setText(Messages.FullName);
		gridColumn_4.setWidth(150);
		
		GridColumn gridColumn_5 = new GridColumn(expertGrid, SWT.CENTER);
		gridColumn_5.setText("专家类型");
		gridColumn_5.setWidth(200);
		
		GridColumn gridColumn_7 = new GridColumn(expertGrid, SWT.NONE);
		gridColumn_7.setWidth(500);
		
		workerComposite = new Composite(userComposite, SWT.NONE);
		GridLayout gl_workerComposite = new GridLayout(1, false);
		gl_workerComposite.marginHeight = 0;
		gl_workerComposite.marginWidth = 0;
		workerComposite.setLayout(gl_workerComposite);
		
		workerGrid = new Grid(workerComposite, SWT.V_SCROLL);
		workerGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		workerGrid.setHeaderVisible(true);
		workerGrid.setAutoHeight(true);
		workerGrid.setAutoWidth(true);
		workerGrid.setItemHeight(Constants.ROW_HIGHT);
		
		GridColumn workerIndexColumn = new GridColumn(workerGrid, SWT.CENTER);
		workerIndexColumn.setText(Messages.Num);
		workerIndexColumn.setWidth(50);
		
		GridColumn gridColumn_6 = new GridColumn(workerGrid, SWT.CENTER);
		gridColumn_6.setText(Messages.FullName);
		gridColumn_6.setWidth(150);
		
		GridColumn gridColumn_8 = new GridColumn(workerGrid, SWT.NONE);
		gridColumn_8.setWidth(500);
		
		Composite composite_4 = new Composite(container, SWT.NONE);
		composite_4.setLayout(new GridLayout(5, false));
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		tipsSupplierLabel = new StyledText(composite_4, SWT.READ_ONLY);
		tipsSupplierLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		tipsSupplierLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		tipsSupplierLabel.setText("");
		
		ELink button_3 = new ELink(composite_4, SWT.NONE | EButton.CSS_BLUE);
		button_3.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				confirmAction();
			}
		});
		button_3.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		button_3.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		button_3.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		button_3.setForeground(ColorConstants.FONT_BLUE_COLOR);
		button_3.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
		button_3.setText("确认任务分配");
		
		EButton button_save = new EButton(composite_4, SWT.NONE | EButton.CSS_BLUE);
		button_save.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				saveAction();
			}
		});
		button_save.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		GridData gd_button_close = new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1);
		gd_button_close.heightHint = 30;
		gd_button_close.widthHint = 90;
		button_save.setLayoutData(gd_button_close);
		button_save.setText(Messages.Button_save);
		
		init();
		return container;
	}
	
	/**
	 * @Description: 初始化
	 * @author chenxw
	 */
	private void init() {
		secondTip.setText("选择待分配的" + com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType()));
		firstTip.setText("选择分类");
		thirdTip.setText("选择任务人员");
		
		for (Control control : evalBidTypeComposite.getChildren()) {
			control.dispose();
		}
		createBidTypeBtn(EvaluationFactorEnum.EVAL_BID_BUS, Messages.Business).setSelection(true);
		createBidTypeBtn(EvaluationFactorEnum.EVAL_BID_TEC, Messages.Technology);
		createBidTypeBtn(EvaluationFactorEnum.EVAL_BID_PRICE, "经济");
		
		preEvaluationStepList = evaluationStepService.getEvaluationStepListByType(tenderProject.getId(), com.gx.obe.components.core.enumeration.EvaluationStepEnum.PRE_EVALUATION);
		groupTypeMapSupplierMap = evaluationGroupService.getGroupTypeMapSupplierMap(tenderProject.getId());
		
		initEvaluationGroupGrid();
		refreshEvaluationGroupGrid();
		
		curButton = createImageButton(Messages.Expert, TYPE_EXPERT, expertComposite);
		createImageButton(Messages.Worker, TYPE_WORKER, workerComposite);
		
//		supplierGrid.addListener(SWT.Selection, new GridCheckedListener(1,true));
		supplierGrid.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				// 选中了复选框事件
				if (event.detail == SWT.CHECK) {} else {
					GridItem item = (GridItem) event.item;
					item.setChecked(1, !item.getChecked(1));
				}
				showTips();
			}
			
		});
		expertGrid.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				showTips();
			}
			
		});
		workerGrid.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				showTips();
			}
			
		});
		
		refreshExpertGrid();
		refreshWorkerGrid();
		
		curButton.notifyListeners(SWT.MouseUp, null);
	}
	
	/**
	 * @Description: 
	 * @author chenxw
	 * @param evalBidType
	 * @param evlBidTypeName
	 * @return 
	 */
	private ImageButton createBidTypeBtn(final String evalBidType, String evlBidTypeName) {
		final ImageRaido imageButton = new ImageRaido(evalBidTypeComposite, SWT.NONE);
		imageButton.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		imageButton.setImageSize(24);
		imageButton.setData("evalBidType", evalBidType);
		imageButton.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		imageButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (!imageButton.getEnabled()) return;
				imageButton.setSelection(true);
				boolean isPrice = evalBidType.equals(EvaluationFactorEnum.EVAL_BID_PRICE);
				for (GridItem gridItem : supplierGrid.getItems()) {
					if (isPrice) {
						gridItem.setChecked(1, true);
						gridItem.setCheckable(1, false);
					} else {
						gridItem.setCheckable(1, true);
					}
				}
				showTips();
			}
		});
		imageButton.setText(evlBidTypeName);
		return imageButton;
	}
	
	/**
	 * @Description: 初始化用户名称
	 * @author chenxw
	 */
	private void initUserNameMap() {
		userNameMap.clear();
		expertList = expertService.getExpertList(tenderProject.getId(), ExpertEnum.ALL);
		if (CollectionUtils.isNotNull(expertList)) {
			for (Expert expert : expertList) {
				userNameMap.put(expert.getUserId(), expert.getUser().getUserName());
			}
		}
		workerList = workerService.getWorkerList(false,tenderProject.getId(), ExpertEnum.WORKER);
		if (CollectionUtils.isNotNull(workerList)) {
			for (Worker worker : workerList) {
				userNameMap.put(worker.getUserId(), worker.getUser().getUserName());
			}
		}
	}
	
	/**
	 * @Description: 刷新专家列表
	 * @author chenxw
	 */
	private void refreshExpertGrid() {
		if (CollectionUtils.isNull(expertList)) {
			return;
		}
		int index = 1;
		for (Expert expert : expertList) {
			GridItem gridItem = new GridItem(expertGrid, SWT.NONE);
			gridItem.setText(0, (index++) + "");
			gridItem.setText(1, expert.getUser().getUserName());
			gridItem.setText(2, expert.getExpertTypeCN());
			gridItem.setData("userId", expert.getUser().getId());
		}
	}
	
	/**
	 * @Description: 刷新工作人员列表
	 * @author chenxw
	 */
	private void refreshWorkerGrid() {
		if (CollectionUtils.isNull(workerList)) {
			return;
		}
		int index = 1;
		for (Worker worker : workerList) {
			GridItem gridItem = new GridItem(workerGrid, SWT.NONE);
			gridItem.setText(0, (index++) + "");
			gridItem.setText(1, worker.getUser().getUserName());
			gridItem.setData("userId", worker.getUser().getId());
		}
	}
	
	/**
	 * @Description: 确认事件
	 * @author chenxw
	 */
	private void confirmAction() {
		List<String> supplierIdList = GridUtils.getCheckedValues(supplierGrid, 1, "supplierId");
		if (null == supplierIdList || supplierIdList.size() == 0) {
			MessageDialog.openShortMessage("请" + secondTip.getText() + "！");
			return;
		}
		ImageRaido radioImage = ImageRaidoUtils.getSelectionRadio(evalBidTypeComposite);
		String evalBidType = (String) radioImage.getData("evalBidType");
		
		Grid grid = null;
		if (TYPE_EXPERT.equals(curButton.getData())) {
			grid = expertGrid;
		} else if (TYPE_WORKER.equals(curButton.getData())) {
			grid = workerGrid;
		}
		
		String userId = null;
		String userName = null;
		if (null != grid && grid.getSelectionCount() > 0) {
			userId = (String) grid.getSelection()[0].getData("userId");
			userName = grid.getSelection()[0].getText(1);
		}
		if (null == userId) {
			MessageDialog.openShortMessage("请" + thirdTip.getText() + "！");
			return;
		}
		putAllGroupTypeMapSupplierMap(supplierIdList, evalBidType, userId);
		refreshEvaluationGroupGrid();
		StringBuilder message = new StringBuilder();
		message.append("已为[").append(userName).append("]分配");
		message.append(supplierIdList.size()).append(Messages.SupplierCouns).append(com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType())).append("的");
		message.append(radioImage.getText()).append(PropertiesUtils.getEnum(I18NEnum.PRE_EVAL_OPINION, "评议")).append("任务！");
		MessageDialog.openShortMessage(message.toString());
	}
	
	/**
	 * @Description: 添加评审分组
	 * @author chenxw
	 * @param supplierIdList
	 * @param evalBidType
	 * @param userId
	 */
	public void putAllGroupTypeMapSupplierMap(List<String> supplierIdList, String evalBidType, String userId) {
		if (CollectionUtils.isNull(supplierIdList) || StringUtils.isEmpty(evalBidType)) {
			return;
		}
		for (String supplierId : supplierIdList) {
			if (groupTypeMapSupplierMap.containsKey(supplierId)) {
				Map<String, EvaluationGroup> groupTypeMap = groupTypeMapSupplierMap.get(supplierId);
				if (groupTypeMap.containsKey(evalBidType)) {
					groupTypeMap.get(evalBidType).setUserId(userId);
				} else {
					groupTypeMap.put(evalBidType, getEvaluationGroup(supplierId, evalBidType, userId));
				}
			} else {
				Map<String, EvaluationGroup> groupTypeMap = new HashMap<String, EvaluationGroup>();
				groupTypeMap.put(evalBidType, getEvaluationGroup(supplierId, evalBidType, userId));
				groupTypeMapSupplierMap.put(supplierId, groupTypeMap);
			}
		}
	}
	
	/**
	 * @Description: 获取评审分组
	 * @author chenxw
	 * @param supplierId
	 * @param evalBidType
	 * @param userId
	 * @return
	 */
	private EvaluationGroup getEvaluationGroup(String supplierId, String evalBidType, String userId) {
		EvaluationGroup evaluationGroup = new EvaluationGroup();
		evaluationGroup.setTenderId(tenderProject.getId());
		evaluationGroup.setSupplierId(supplierId);
		evaluationGroup.setEvalBidType(evalBidType);
		evaluationGroup.setStepId(getEvaluationStepId(evalBidType));
		evaluationGroup.setUserId(userId);
		return evaluationGroup;
	}
	
	/**
	 * @Description: 根据评审类型获取步骤id
	 * @author chenxw
	 * @param type
	 * @return 
	 */
	private String getEvaluationStepId(String type) {
		for (EvaluationStep preEvaluationStep : preEvaluationStepList) {
			String evalBidType = preEvaluationStep.getEvalBidType();
			if (EvaluationFactorEnum.EVAL_BID_DETAIL.equals(evalBidType)) {
				if (type.equals(EvaluationFactorEnum.EVAL_BID_BUS) || type.equals(EvaluationFactorEnum.EVAL_BID_TEC)) {
					return preEvaluationStep.getId();
				}
			} else if (type.equals(evalBidType)) {
				return preEvaluationStep.getId();
			}
		}
		return null;
	}

	
	
	/**
	 * @Description: 初始化评审分组表格
	 * @author chenxw
	 */
	public void initEvaluationGroupGrid() {
		supplierGrid.removeAll();
		initUserNameMap();
		List<Supplier> supplierList = supplierService.getOpenBidSuccessSupplier(tenderProject.getId());
		if (CollectionUtils.isNull(supplierList)) {
			return;
		}
		int index = 1;
		for (Supplier supplier : supplierList) {
			GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
			gridItem.setText(0, index + "");
			gridItem.setText(1, supplier.getSupplierName());
			gridItem.setData("supplierId", supplier.getId());
			index++;
		}
	}
	
	/**
	 * @Description: 刷新
	 * @author chenxw
	 */
	public void refreshEvaluationGroupGrid() {
		for (GridItem gridItem : supplierGrid.getItems()) {
			String supplierId = (String) gridItem.getData("supplierId");
			if (StringUtils.isEmpty(supplierId)) {
				continue;
			}
			Map<String, EvaluationGroup> groupTypeMap = groupTypeMapSupplierMap.get(supplierId);
			if (null == groupTypeMap || groupTypeMap.isEmpty()) {
				continue;
			}
			
			EvaluationGroup busGroup = groupTypeMap.get(EvaluationFactorEnum.EVAL_BID_BUS);
			if (null != busGroup) {
				gridItem.setText(2, ObjectUtils.getObjString(userNameMap.get(busGroup.getUserId())));
			}
			EvaluationGroup tecGroup = groupTypeMap.get(EvaluationFactorEnum.EVAL_BID_TEC);
			if (null != tecGroup) {
				gridItem.setText(3, ObjectUtils.getObjString(userNameMap.get(tecGroup.getUserId())));
			}
			EvaluationGroup priceGroup = groupTypeMap.get(EvaluationFactorEnum.EVAL_BID_PRICE);
			if (null != priceGroup) {
				gridItem.setText(4, ObjectUtils.getObjString(userNameMap.get(priceGroup.getUserId())));
			}
		}
	}
	
	/**
	 * @Description: 获得按钮
	 * @author chenxw
	 * @param string
	 * @param composite
	 * @return
	 */
	private ImageButton createImageButton(String name, String data, final Composite composite) {
		final RectangleRadioButton button = new RectangleRadioButton(buttonComposite, SWT.NONE);
		button.setText(name);
		button.setData(data);
		button.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				curButton.setSelection(false);
				curButton = button;
				curButton.setSelection(true);
				stackLayout.topControl = composite;
				userComposite.layout();
				showTips();
			}
		});
		return button;
	}
	
	/**
	 * @Description: 全选、反选
	 * @author chenxw
	 * @param isSelect
	 */
	private void selectSupplierAction(boolean isSelect) {
		if (isSelect) {
			GridUtils.checkAll(supplierGrid, 1, true);
		} else {
			GridUtils.checkAllBack(supplierGrid, 1);
		}
		showTips();
	}
	
	private void showTips() {
		
		List<String> supplierIdList = GridUtils.getCheckedValues(supplierGrid, 1, "supplierId");
		
		if (null == tipsStyleRange) {
			tipsStyleRange = new StyleRange();
//			tipsStyleRange.foreground = SWTResourceManager.getColor(77, 163, 19); 
			tipsStyleRange.foreground = ColorConstants.FONT_BLUE_COLOR;
			tipsStyleRange.fontStyle = SWT.BOLD;
			tipsStyleRange.font = SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD);
		}
		
		ImageRaido radioImage = ImageRaidoUtils.getSelectionRadio(evalBidTypeComposite);
		thirdTip.setText("选择" + PropertiesUtils.getEnum(I18NEnum.PRE_EVAL_OPINION, "评议") + "人员");
		StringBuilder tips = new StringBuilder();
		tips.append("将已选中的");
		int firstStart = tips.length();
		if (null == supplierIdList || supplierIdList.size() == 0) {
			tips.append("[    ]");
		} else {
			tips.append("[ " + supplierIdList.size() + " ]");
		}
		int firstEnd = tips.length();
		tips.append(Messages.SupplierCouns);
		tips.append(com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType()));
		tips.append("的");
		int secondStart = tips.length();
		tips.append("[ ");
		tips.append(radioImage.getText());
		tips.append(" ]");
		int secondEnd = tips.length();
		tips.append(PropertiesUtils.getEnum(I18NEnum.PRE_EVAL_OPINION, "评议"));
		tips.append("任务");
		tips.append("分配给");
		
		Grid grid = null;
		if (TYPE_EXPERT.equals(curButton.getData())) {
			grid = expertGrid;
			
		} else if (TYPE_WORKER.equals(curButton.getData())) {
			grid = workerGrid;
		}
		
		int thirdStart = tips.length();
		String userName = null;
		tips.append("[ ");
		if (null != grid && grid.getSelectionCount() > 0) {
			userName = grid.getSelection()[0].getText(1);
			tips.append(userName);
		} else {
			tips.append("         ");
			
		}
		tips.append(" ]");
		int thirdEnd = tips.length();
		tips.append("！");
		tipsSupplierLabel.setText(tips.toString());
		tipsStyleRange.start = firstStart;
		tipsStyleRange.length = firstEnd - firstStart;
		tipsSupplierLabel.setStyleRange(tipsStyleRange);
		tipsStyleRange.start = secondStart;
		tipsStyleRange.length = secondEnd - secondStart;
		tipsSupplierLabel.setStyleRange(tipsStyleRange);
		tipsStyleRange.start = thirdStart;
		tipsStyleRange.length = thirdEnd - thirdStart;
		tipsSupplierLabel.setStyleRange(tipsStyleRange);
		tipsSupplierLabel.getParent().layout();
	}
	
	/**
	 * @Description: 保存
	 * @author chenxw 
	 */
	private void saveAction() {
		if (isEvalStepInProgress()) {
			MessageDialog.openWarning(getShell(), "清标相关步骤以进入评标环节，不得分配清标人员！");
			return;
		}
		evaluationGroupService.deleteByTenderId(tenderProject.getId());
		expertEvaluationStepService.deleteExpertEvaluationStepByStepType(tenderProject.getId(), com.gx.obe.components.core.enumeration.EvaluationStepEnum.PRE_EVALUATION);
		if (evaluationGroupService.batchSave(getEvaluationGroupList()) > 0) {
			MessageDialog.openShortMessage(Messages.Tips_saveSuccess);
		} else {
			MessageDialog.openError(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveFail);
		}
	}
	
	/**
	 * @Description: 是否进入评审阶段
	 * @author chenxw
	 * @return 
	 */
	private boolean isEvalStepInProgress() {
		for (EvaluationStep preEvaluationStep : preEvaluationStepList) {
			if (CommonEnum.IN_PROGRESS.equals(preEvaluationStep.getStepStatus()) || CommonEnum.COMPLETE.equals(preEvaluationStep.getStepStatus())) {
				return true;
			}
		}
		return false;
	}
	
	private List<EvaluationGroup> getEvaluationGroupList() {
		List<EvaluationGroup> evaluationGroupList = new ArrayList<EvaluationGroup>();
		for (Map<String, EvaluationGroup> groupTypeMap : groupTypeMapSupplierMap.values()) {
			for (String type : groupTypeMap.keySet()) {
				EvaluationGroup group = groupTypeMap.get(type);
				if(null == group.getId()){
					group.setId(UuidUtils.getUUID());
				}
				evaluationGroupList.add(group);
			}
		}
		return evaluationGroupList;
	}
	
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		ScreenUtils util = new ScreenUtils();
		return new Point((int) (util.getScreenWight() * 0.6), (int) (util.getScreenHight() * 0.8));
	}
}
