package com.gx.obe.evaluation.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.common.composite.MyAuditComposite;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.tender.TenderProjectEntity;

public class MyAuditDialog extends EDialog {
	
	private final TenderProjectEntity curTender;
	private final String stepStatus;

	/**
	 * Create the dialog.
	 * 
	 * @param parentShell
	 */
	public MyAuditDialog(Shell parentShell, TenderProjectEntity curTender, String stepStatus) {
		super(parentShell);
		this.setOperator(SWT.MAX);
		this.curTender = curTender;
		this.stepStatus = stepStatus;
		setTitle(Messages.Button_myReview);
	}
	
	/**
	 * Create contents of the dialog.
	 * 
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		
		MyAuditComposite auditComposite = new MyAuditComposite(container, SWT.NONE);
		auditComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		auditComposite.refresh(curTender, stepStatus);
		
		return container;
	}
	
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(800, 500);
	}
	
}
