package com.gx.obe.evaluation.dialog;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.text.MessageFormat;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.VerifyCardIdListener;
import org.eclipse.swt.core.listener.VerifyEnNameListener;
import org.eclipse.swt.core.listener.VerifyPasswordListener;
import org.eclipse.swt.core.listener.VerifyPhoneListener;
import org.eclipse.swt.core.listener.VerifyRequiredListener;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.utils.ValidateUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.enumeration.UserEnum;
import com.gx.obe.common.dialog.SelectUserCommonDialog;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.Tips;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.http.util.Base64;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.CollectionUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.MD5Utils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.SpellHelper;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.service.UserService;
import com.gx.obe.web.service.expert.ExpertService;
import com.gx.obe.config.utils.InputStreamUtil;
import com.swtdesigner.ResourceManager;

/**
 * @Description: 临时用户修改界面
 * @author chenxw
 */
public class TempUserModifyDialog extends EDialog {
	
	private boolean changeAvatorImage = false;
	
	private boolean saveStatus = false;
	
	private final ImageResolver imageResolver = new ImageResolver();
	private final UserService userService = new UserService();
	private final ExpertService expertService = new ExpertService();
	
	private Composite compContent;
	private Text userNameText;
	private ImageButton userAvatorLabel;
	private Text passwordText;
	private Text passwordAgainText;
	private Composite genderComposite;
	private Text IDCardText;
	private Text phoneText;
	private Text professionalTitleText;
	private Text specialtyText;
	private Text companyText;
	private ELink link;
	private ELink createAccountLink;
	private AuthUser tempUser;
	private Text userAccountText;
	{
		LogUtils.logClass(TempUserModifyDialog.class);
	}
	
	/**
	 * @author chenxw
	 * @param parentShell
	 * @param tempUser
	 */
	public TempUserModifyDialog(Shell parentShell, AuthUser tempUser) {
		super(parentShell);
		this.setTitle("修改用户信息");
		this.tempUser = tempUser;
	}
	
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite content = (Composite) super.createDialogArea(parent);
		content.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				imageResolver.disposite();
			}
		});
		GridLayout gl_content = new GridLayout(1, false);
		gl_content.verticalSpacing = 0;
		gl_content.horizontalSpacing = 0;
		gl_content.marginHeight = 0;
		gl_content.marginWidth = 0;
		content.setLayout(gl_content);
		content.setBackgroundMode(SWT.INHERIT_FORCE);
		
		Composite composite_2 = new Composite(content, SWT.NONE);
		composite_2.setLayout(new GridLayout(1, false));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		Tips label_2 = new Tips(composite_2, SWT.NONE);
		label_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label_2.setText("当前账号为临时账号，请您重新设置账号及用户信息！");
		
		compContent = new Composite(content, SWT.NONE);
		GridLayout gl_compContent = new GridLayout(3, false);
		compContent.setLayout(gl_compContent);
		compContent.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		CLabel userNameLabel = new CLabel(compContent, SWT.NONE);
		userNameLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		userNameLabel.setText(Messages.FullName + "：");
		
		Composite userNameComposite = new Composite(compContent, SWT.NONE);
		userNameComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_userNameComposite = new GridLayout(2, false);
		gl_userNameComposite.horizontalSpacing = 0;
		gl_userNameComposite.verticalSpacing = 0;
		gl_userNameComposite.marginWidth = 0;
		gl_userNameComposite.marginHeight = 0;
		userNameComposite.setLayout(gl_userNameComposite);
		
		userNameText = new Text(userNameComposite, SWT.BORDER | SWT.DRAW_TAB);
		userNameText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		userNameText.setTextLimit(20);
		userNameText.addVerifyListener(new VerifyRequiredListener(userNameText, "姓名不能为空！"));
		
		link = new ELink(userNameComposite, SWT.NONE);
		link.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				queryUserAction();
			}
		});
		link.setText("检测");
		link.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/query.png"));
		
		Composite composite_1 = new Composite(compContent, SWT.NONE);
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 0;
		composite_1.setLayout(gl_composite_1);
		GridData gd_composite_1 = new GridData(SWT.FILL, SWT.TOP, false, true, 1, 6);
		gd_composite_1.widthHint = 150;
		gd_composite_1.heightHint = 180;
		composite_1.setLayoutData(gd_composite_1);
		
		userAvatorLabel = new ImageButton(composite_1, SWT.BORDER | SWT.BOTTOM);
		userAvatorLabel.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		userAvatorLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/male_96.png"));
		userAvatorLabel.setBorderColor(ColorConstants.BORDER_LINE_COLOR);
		
		EButton button_2 = new EButton(composite_1, SWT.NONE);
		button_2.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				uploadUserAvatarAction();
			}
		});
		button_2.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/upload.png"));
		button_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		button_2.setText(Messages.UploadPicture);
		
		CLabel usLoginAccountLabel = new CLabel(compContent, SWT.NONE);
		usLoginAccountLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		usLoginAccountLabel.setText(Messages.Account + "：");
		
		Composite composite = new Composite(compContent, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginWidth = 0;
		gl_composite.marginHeight = 0;
		gl_composite.horizontalSpacing = 0;
		gl_composite.verticalSpacing = 0;
		composite.setLayout(gl_composite);
		
		userAccountText = new Text(composite, SWT.BORDER);
		userAccountText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		userAccountText.setTextLimit(20);
		userAccountText.addVerifyListener(new VerifyEnNameListener());
		userAccountText.addVerifyListener(new VerifyRequiredListener(userAccountText, "账号不能为空！"));
		
		createAccountLink = new ELink(composite, SWT.NONE);
		createAccountLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				createAccountAction();
			}
		});
		createAccountLink.setText("生成账号");
		createAccountLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/pen.png"));
		
		CLabel passwordLabel = new CLabel(compContent, SWT.NONE);
		passwordLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		passwordLabel.setText(Messages.Password + "：");
		
		Composite passwordCmposite = new Composite(compContent, SWT.NONE);
		GridLayout gl_passwordCmposite = new GridLayout(1, false);
		gl_passwordCmposite.horizontalSpacing = 0;
		gl_passwordCmposite.marginHeight = 0;
		gl_passwordCmposite.marginWidth = 0;
		passwordCmposite.setLayout(gl_passwordCmposite);
		passwordCmposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		
		passwordText = new Text(passwordCmposite, SWT.BORDER | SWT.PASSWORD | SWT.DRAW_TAB);
		passwordText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		passwordText.setTextLimit(32);
		passwordText.addVerifyListener(new VerifyRequiredListener(passwordText, MessageFormat.format(Messages.Tips_required, Messages.Password)));
		passwordText.addVerifyListener(new VerifyPasswordListener());		

		Label passwordTips = new Label(passwordCmposite, SWT.WRAP);
		GridData gd_passwordTips = new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1);
		gd_passwordTips.widthHint = 300;
		passwordTips.setLayoutData(gd_passwordTips);
		passwordTips.setText(VerifyPasswordListener.PASSWOR_TIPS);
		passwordTips.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		CLabel passwordAgainLabel = new CLabel(compContent, SWT.NONE);
		passwordAgainLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		passwordAgainLabel.setText(Messages.PasswordConfirm + "：");
		

		passwordAgainText = new Text(compContent, SWT.BORDER | SWT.PASSWORD | SWT.DRAW_TAB);
		passwordAgainText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		passwordAgainText.addVerifyListener(new VerifyRequiredListener(passwordAgainText, "确认密码不能为空！"));
		passwordAgainText.setTextLimit(32);
		
		
		CLabel label = new CLabel(compContent, SWT.NONE);
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label.setText(Messages.Gender + "：");
		
		genderComposite = new Composite(compContent, SWT.NONE);
		genderComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		GridLayout gl_genderComposite = new GridLayout(2, false);
		gl_genderComposite.marginHeight = 0;
		genderComposite.setLayout(gl_genderComposite);
		
		Button button = new Button(genderComposite, SWT.RADIO);
		button.setSelection(true);
		button.setData(UserEnum.MALE);
		button.setText(Messages.Male);
		
		Button button_1 = new Button(genderComposite, SWT.RADIO);
		button_1.setData(UserEnum.FEMALE);
		button_1.setText(Messages.Female);
		
		CLabel IDCardLabel = new CLabel(compContent, SWT.NONE);
		IDCardLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		IDCardLabel.setText(Messages.IDCard + "：");
		
		IDCardText = new Text(compContent, SWT.BORDER | SWT.DRAW_TAB);
		IDCardText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		IDCardText.setTextLimit(18);
		IDCardText.addVerifyListener(new VerifyRequiredListener(IDCardText, MessageFormat.format(Messages.Tips_required, Messages.IDCard)));
		IDCardText.addVerifyListener(new VerifyCardIdListener(MessageFormat.format(Messages.Tips_pleaseEnterTheCorrect, Messages.IDCard)));
		
		CLabel label_5 = new CLabel(compContent, SWT.NONE);
		label_5.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_5.setText(Messages.LinkerTel + "：");
		
		phoneText = new Text(compContent, SWT.BORDER | SWT.DRAW_TAB);
		phoneText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		phoneText.setTextLimit(20);
//		phoneText.addVerifyListener(new VerifyRequiredListener(phoneText,"联系电话不能为空！"));
		phoneText.addVerifyListener(new VerifyPhoneListener(MessageFormat.format(Messages.Tips_pleaseEnterTheValid, Messages.LinkerTel)));
		new Label(compContent, SWT.NONE);
		
		CLabel label_1 = new CLabel(compContent, SWT.NONE);
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_1.setText(Messages.ProfessionalTitle);
		
		professionalTitleText = new Text(compContent, SWT.BORDER | SWT.DRAW_TAB);
		GridData gd_professionalTitleText = new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1);
		gd_professionalTitleText.widthHint = 200;
		professionalTitleText.setLayoutData(gd_professionalTitleText);
//		professionalTitleText.addVerifyListener(new VerifyRequiredListener(professionalTitleText,"等级/职称不能为空！"));
		professionalTitleText.setTextLimit(50);
		
		CLabel label_3 = new CLabel(compContent, SWT.NONE);
		label_3.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_3.setText(Messages.Specialty + "：");
		
		specialtyText = new Text(compContent, SWT.BORDER | SWT.DRAW_TAB);
		specialtyText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		specialtyText.setTextLimit(100);
		
		CLabel label_4 = new CLabel(compContent, SWT.NONE);
		label_4.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_4.setText(Messages.WorkCompany + "：");
		
		companyText = new Text(compContent, SWT.BORDER | SWT.WRAP | SWT.V_SCROLL | SWT.MULTI);
		companyText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));
		companyText.setTextLimit(100);
		
		ESepator sepLabel = new ESepator(content, SWT.SEPARATOR | SWT.HORIZONTAL);
		sepLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		sepLabel.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite operateComposite = new Composite(content, SWT.NONE);
		operateComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		operateComposite.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/fill_bg.png"));
		operateComposite.setLayout(new GridLayout(2, false));
		operateComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		EButton save_user_btn = new EButton(operateComposite, SWT.NONE);
		save_user_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				saveUserAction();
			}
		});
		GridData gd_saveUserBtn = new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1);
		gd_saveUserBtn.widthHint = 90;
		save_user_btn.setLayoutData(gd_saveUserBtn);
		save_user_btn.setText(Messages.Button_save);
		save_user_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/save.png"));
		
		EButton cancel_btn = new EButton(operateComposite, SWT.NONE);
		cancel_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				cancelAction();
			}
		});
		GridData gd_cancelBtn = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_cancelBtn.widthHint = 90;
		cancel_btn.setLayoutData(gd_cancelBtn);
		cancel_btn.setText(Messages.Button_close);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		
		init();
		
		return content;
	}
	
	/**
	 * @Description: 初始化界面
	 */
	private void init() {
		link.setEnabled(false);
		userAccountText.setEnabled(false);
		createAccountLink.setEnabled(false);
		userNameText.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				link.setEnabled(userNameText.getText().length() > 1);
				userAccountText.setEnabled(userNameText.getText().length() > 1);
				createAccountLink.setEnabled(userNameText.getText().length() > 1);
			}
		});
		getShell().pack();
		SwtUtils.setCenter(getShell());
	}
	
	
	/**
	 * @Description: 产生账号
	 * @author guoyr
	 */
	private void createAccountAction() {
		if (createAccountLink.getEnabled() && userNameText.getText().trim().length() > 1) {
			userAccountText.setText(ObjectUtils.getObjString(SpellHelper.getEname(userNameText.getText().trim())));
		}
	}
	
	/**
	 * @Description: 产生账号并进行用户验证
	 * @author chenxw 
	 */
	private void queryUserAction() {
		String userName = userNameText.getText().trim();
		if (StringUtils.isEmpty(userName)) {
			return;
		}
		
//		accountText.setText(SpellHelper.getEname(userNameText.getText().trim()));
		
		List<AuthUser> userList = userService.getUserListByUserName(null, userName);
		if (CollectionUtils.isNull(userList)) {
			return;
		}
		SelectUserCommonDialog selectUserDialog = new SelectUserCommonDialog(getShell(), null, userList);
		selectUserDialog.open();
		AuthUser selectUser = selectUserDialog.getSelectUser();
		if (selectUser == null) {
			return;
		}
		if (expertService.isTenderExpertContain(selectUser.getId(), tempUser.getId())) {
			MessageDialog.openError(getShell(), "项目下已存在账号为[" + selectUser.getUserAccount() + "]的专家，请您直接使用该账号登录，或重新设置其它账号！");
			return;
		}
		
		UserVerificationDialog dialog = new UserVerificationDialog(getShell(), selectUser);
		dialog.open();
		if (!dialog.isVerification()) {
			return;
		}
		
		if(!expertService.updateTempExpertMessgae(selectUser.getId(), tempUser.getId())){
			MessageDialog.openWarning(getShell(), Messages.Tips_saveFail);
			return;
		}
		tempUser = selectUser;
		saveStatus = true;
		getShell().close();
	}
	
	/**
	 * @Description: 上传头像
	 * @author guoyr
	 */
	private void uploadUserAvatarAction() {
		String imagePath = FileDialogUtils.getFileNames(SWT.SINGLE, "选择头像", new String[] { "*.png;*.jpg", "*.png", "*.jpg" });
		if (StringUtils.isEmpty(imagePath)) {
			return;
		}
		File imageFile = new File(imagePath);
		if(imageFile.length() > 1024000*1) {
			MessageDialog.openWarning(getShell(), "请上传1M以内的头像！");
			return;
		}
		Image menuImage = imageResolver.loadImage(imageFile, 102, 126);
		if (null == menuImage) {
			return;
		}
		FileInputStream in = null;
		try {
			in = new FileInputStream(imageFile);
			userAvatorLabel.setImage(menuImage, 102, 126);
			tempUser.setAvatar(Base64.encode(InputStreamUtil.inputStreamTOByte(in)));
			changeAvatorImage = true;
		} catch (FileNotFoundException e) {} finally {
			if (in != null) {
				try {
					in.close();
				} catch (IOException e) {}
			}
		}
	}
	
	/**
	 * @Description: 保存用户事件
	 * @author chenxw 
	 */
	private void saveUserAction() {
		if (!ValidateUtils.checkInput(compContent)) {
			return;
		}
		
		String password = passwordText.getText().trim();
		String account = userAccountText.getText().trim();

		if (!passwordAgainText.getText().trim().equals(password)) {
			MessageDialog.openWarning(getShell(), Messages.Tips_matchPassword);
			passwordAgainText.setFocus();
			return;
		}
		if (password.equals(account)) {
			MessageDialog.openWarning(getShell(), "账号和密码不能相同，请重新输入！");
			return;
		}
		
		if (userService.valAccountAndIdCard(account, tempUser.getId(), null) > 0) {
			MessageDialog.openWarning(getShell(), account + Messages.Tips_AlreadyExistsPleaseRetype);
			userAccountText.setFocus();
			userAccountText.setSelection(0,userAccountText.getText().length());
			return;
		}
		
		String IDCard = IDCardText.getText().trim();
		
		if (userService.valAccountAndIdCard(null, tempUser.getId(), IDCard) > 0) {
			MessageDialog.openWarning(getShell(), IDCard + "已经存在，每个身份证号只能对应一个账号！");
			IDCardText.setFocus();
			return;
		}
		
		tempUser.setUserName(userNameText.getText().trim());
		tempUser.setUserAccount(account);
		tempUser.setUserPassword(MD5Utils.getMD5String(password));
		tempUser.setGender(ObjectUtils.getObjString(WidgetUtils.getRadioVal(genderComposite)));
		tempUser.setUserIdcard(IDCard);
		tempUser.setPhone(phoneText.getText().trim());
		tempUser.setProfessionalTitle(professionalTitleText.getText().trim());
		tempUser.setSpecialty(specialtyText.getText().trim());
		tempUser.setCompany(companyText.getText().trim());
		tempUser.setUseStatus(CommonEnum.REAL_STATUS);
		
		String[] updateProperties = null;
		// 如果修改了头像才去修改头像，减少修改属性，因为头像是直接保存在数据库中的
		if (changeAvatorImage) {
			updateProperties = new String[] { "userName", "userAccount", "userPassword", "gender", "userIdcard", "phone", "professionalTitle", "specialty", "areaCode", "useStatus", "company", "avatar" };
		} else {
			updateProperties = new String[] { "userName", "userAccount", "userPassword", "gender", "userIdcard", "phone", "professionalTitle", "specialty", "areaCode", "useStatus", "company" };
		}
		if (!userService.updateAssignProperty(tempUser, updateProperties)) {
			MessageDialog.openError(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveFail);
		}
		saveStatus = true;
		getShell().close();
	}
	
	/**
	 * @Description: 取消
	 */
	private void cancelAction() {
		getShell().close();
	}
	
	/**
	 * @Description: 是否保存
	 * @author chenxw
	 * @return 
	 */
	public boolean isSaveStatus() {
		return saveStatus;
	}
	
	/**
	 * @Description: 获取用户
	 * @author chenxw
	 * @return 
	 */
	public AuthUser getUser() {
		return tempUser;
	}
	
	@Override
	protected Point getInitialSize() {
		return new Point(550, 455);
	}
	
}
