package com.gx.obe.evaluation.dialog;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridCheckedListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.TorrentFile;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.utils.InputStreamUtil;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.TorrentFileService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 种子文件管理界面
 * *@author guoyr
 */
public class TorrentFileManageDialog extends EDialog {
	
//	private CLabel titleNameLabel;
	private Composite composite_3;
	private TorrentFileService torrentFileService ;
	private Grid file_grid;
	private EButton download_btn;
	private TenderProjectService tenderProjectService ;
	private Image phaseTypeImage;
	private ImageResolver imageResolver = new ImageResolver();
	private Image noExistImage;
	{
		
		LogUtils.logClass(TorrentFileManageDialog.class);
	}
	
	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public TorrentFileManageDialog(Shell parentShell) {
		super(parentShell);
	}
	
	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	
	protected Control createDialogArea(Composite parent) {
		
		Composite container = (Composite) super.createDialogArea(parent);
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.marginHeight = 0;
		gl_container.horizontalSpacing = 0;
		gl_container.verticalSpacing = 0;
		gl_container.marginWidth = 0;
		container.setLayout(gl_container);
		
		Composite composite = new Composite(container, SWT.NONE);
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.horizontalSpacing = 0;
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite titleComposite = new Composite(composite, SWT.NONE);
		titleComposite.setLayout(new GridLayout(2, false));
		titleComposite.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		
		ELink selectAll_button = new ELink(titleComposite, SWT.NONE);
		selectAll_button.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(1);
			}
		});
		selectAll_button.setText(Messages.Button_selectAll);
		ELink selectionInvertBtn = new ELink(titleComposite, SWT.NONE);
		selectionInvertBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(-1);
			}
		});
		selectionInvertBtn.setText(Messages.Button_selectInvert);		
		ESepator answerSep = new ESepator(composite, SWT.NONE);
		answerSep.setLineWidth(2);
		answerSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		answerSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		composite_3 = new Composite(composite, SWT.NONE);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.horizontalSpacing = 0;
		gl_composite_3.verticalSpacing = 0;
		gl_composite_3.marginHeight = 0;
		gl_composite_3.marginWidth = 0;
		composite_3.setLayout(gl_composite_3);
		
		file_grid = new Grid(composite_3, SWT.H_SCROLL | SWT.V_SCROLL | SWT.CHECK);
		file_grid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		file_grid.setItemHeaderWidth(30);
		file_grid.setHeaderVisible(true);
		file_grid.setItemHeight(35);
		file_grid.setAutoWidth(true);
		
		GridColumn gridColumn_num = new GridColumn(file_grid, SWT.CHECK);
		gridColumn_num.setTree(true);
		gridColumn_num.setText("编号");
		gridColumn_num.setWidth(80);
		gridColumn_num.setMaxmumWidth(200);
		gridColumn_num.setWordWrap(true);
		GridColumn gridColumn_9 = new GridColumn(file_grid, SWT.WRAP);
		gridColumn_9.setText(Messages.ProjectName);
		gridColumn_9.setWidth(200);
		gridColumn_9.setWordWrap(true);
		
		GridColumn gridColumn_10 = new GridColumn(file_grid, SWT.CENTER);
		gridColumn_10.setText("是否可下载");
		gridColumn_10.setWidth(120);
		gridColumn_10.setMaxmumWidth(120);
		ESepator downLabel = new ESepator(composite, SWT.NONE);
		downLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		downLabel.setBackground(ColorConstants.SEP_LIGHT_COLOR);

		
		Composite composite_1 = new Composite(composite, SWT.NONE);
		composite_1.setLayout(new GridLayout(2, false));
		composite_1.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		
		download_btn = new EButton(composite_1, SWT.NONE);
		download_btn.setBackground(ColorConstants.SKIN_BG);
		download_btn.setForeground(ColorConstants.SKIN_FOREGROUND);
		download_btn.setActiveBorderColor(ColorConstants.SKIN_ACTIVE_BG);
		download_btn.setActiveBgColor(ColorConstants.SKIN_ACTIVE_BG);
		download_btn.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		download_btn.setArcWidth(6);
		download_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/download.png"));
		download_btn.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, false, false, 1, 1));
		download_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				slectOkAction();
			}
		});
		download_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		GridData gd_savebutton_1 = new GridData(SWT.RIGHT, SWT.FILL, true, false, 1, 1);
		gd_savebutton_1.heightHint = 35;
		gd_savebutton_1.widthHint = 200;
		download_btn.setLayoutData(gd_savebutton_1);
		download_btn.setText(Messages.Button_download);
		file_grid.addListener(SWT.Selection, new GridCheckedListener(false));
		file_grid.setItemHeight(Constants.ROW_HIGHT); 
		file_grid.setAutoHeight(true);
		tenderProjectService = new TenderProjectService();
		init();
		return container;
	}
	
	private void init(){
		torrentFileService =new TorrentFileService();
		noExistImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/about.png"); 
		setTitle("标书下载");
		List<TenderProjectEntity> tenderProjectList = tenderProjectService.getExpertTenderProjectList(Constants.USER.getId(), null, null);
		List<TenderProjectEntity> parentList = new ArrayList<TenderProjectEntity>();
		Map<String, TorrentFile> torrentFileMap = new HashMap<String, TorrentFile>();
		for(TenderProjectEntity tenderProjectEntity : tenderProjectList){
			if(null == tenderProjectEntity.getParentId() || tenderProjectEntity.getParentId().trim().length() == 0){
				parentList.add(tenderProjectEntity);
			}
		}
		for(TenderProjectEntity tenderProjectEntity : parentList){
			for(TenderProjectEntity childTenderProject : tenderProjectList){
				if(null != childTenderProject.getParentId() && childTenderProject.getParentId().trim().length() > 0 && tenderProjectEntity.getId().equals(childTenderProject.getParentId())){
					tenderProjectEntity.addChild(childTenderProject);
				}
			}
		}
		List<TorrentFile> uTorrentFileList = torrentFileService.getTorrentFileAllOrderByFileName();
		if(null == uTorrentFileList || uTorrentFileList.size() <= 0){
			download_btn.setEnabled(false);
			return;
		}else{
			for(TorrentFile torrentFile : uTorrentFileList){
				torrentFileMap.put(torrentFile.getTenderId(), torrentFile);
			}
		}
		refreshTenderProjectTree(parentList, torrentFileMap);
		composite_3.layout();
	}
	
	
	/**
	 * @Description: 刷新项目树
	 * @author guoyr
	 */
	private void refreshTenderProjectTree(List<TenderProjectEntity> parentList, Map<String, TorrentFile> torrentFileMap){
		if(null != file_grid && !file_grid.isDisposed()){
			file_grid.removeAll();					
			if(null != parentList && parentList.size() > 0){
				for(TenderProjectEntity tenderProjectEntity : parentList){
					GridItem gridItem = new GridItem(file_grid, SWT.NONE);
					setGridItemInfo(null, tenderProjectEntity, gridItem, torrentFileMap);
					int noFileCount = 0;
					if(tenderProjectEntity.getChildList().size() > 0){
						gridItem.setExpanded(true);
						for(TenderProjectEntity childProject : tenderProjectEntity.getChildList()){
							GridItem childItem = new GridItem(gridItem, SWT.WRAP);
							childProject.setParentProjectEntity(tenderProjectEntity);
							noFileCount += setGridItemInfo(tenderProjectEntity, childProject, childItem, torrentFileMap);
						}
					}
					if(noFileCount == tenderProjectEntity.getChildList().size()){
						gridItem.setCheckVisible(0, false);
						gridItem.setImage(noExistImage);
					}
				}
			}
		}
	}
	/**
	 * @Description: 设置显示信息
	 * @author guoyr
	 * @param tenderProjectEntity
	 * @param childProject
	 * @param gridItem
	 */
	private int setGridItemInfo(TenderProjectEntity parentProject, TenderProjectEntity tenderProjectEntity, GridItem gridItem, Map<String, TorrentFile> torrentFileMap){
		int noFileCount = 0;
		gridItem.setText(0, tenderProjectEntity.getTenderNo());
		gridItem.setText(1, tenderProjectEntity.getTenderName());
		tenderProjectEntity.setParentProjectEntity(parentProject);
		if(null != tenderProjectEntity.getPhaseType() && tenderProjectEntity.getPhaseType().equals(TenderProjectEnum.PHASE_TYPE_PRE)){
			if(null == phaseTypeImage){
				phaseTypeImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/phase_type.png");
			}
			gridItem.setImage(1, phaseTypeImage);
		}
		gridItem.setData("tenderProjectEntity", tenderProjectEntity);
		if(null != torrentFileMap.get(tenderProjectEntity.getId())){
			gridItem.setText(2, "是");
			gridItem.setData("torrentFile", torrentFileMap.get(tenderProjectEntity.getId()));
		}else{
			if((null == parentProject && tenderProjectEntity.getChildList().size() == 0) || (null != parentProject)){
				gridItem.setCheckVisible(0, false);
				gridItem.setImage(noExistImage);
				gridItem.setText(2, "否");
				noFileCount ++;
			}
		}
		return noFileCount;
	}
	/**
	 * @Description: 确认下载
	 * @author guoyr 
	 */
	private void slectOkAction(){
		if(!download_btn.getEnabled())return;
		List<GridItem> gridItems = GridUtils.getCheckedItems(file_grid, 0, true);
		if(null == gridItems || gridItems.size() == 0){
			MessageDialog.openShortMessage("请选择要下的项目或包件！");
			return ;
		}
		for(GridItem gridItem : gridItems){
			TorrentFile torrentFile = (TorrentFile)gridItem.getData("torrentFile");
			if(null != torrentFile && null != torrentFile.getId()){
				String tempFilePath = FileConstants.TEMP_FOLDER + "torrent" + File.separator + torrentFile.getTenderId() + File.separator + torrentFile.getFileName();
				InputStreamUtil.writeFile(torrentFile.getFileBite(), tempFilePath);
				File templateFile = new File(tempFilePath);
				if(templateFile.exists()){
					RuntimeUtils.openFIle(templateFile, FileConstants.getUtorrentRoot());		
				}
			}
		}
	}
	/**
	 * Return the initial size of the dialog.
	 */
	
	protected Point getInitialSize() {
		return new Point(857, 547);
	}
	/**
	 * @Description: 全选、反选和取消选择
	 * @author guoyr
	 * @param selectionType 
	 */
	private void selectionAction(int selectionType){
		if(selectionType == 1){
			GridUtils.checkAll(file_grid, 0, true);
		}else if(selectionType == -1){
			GridUtils.checkAllBack(file_grid, 0);
		}else {
			GridUtils.checkAll(file_grid, 0, false);
		}
	}
}
