package com.gx.obe.evaluation.dialog;

import java.util.List;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.Platform;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.evaluation.thread.FtpBidFileDownloadThread;
import com.gx.obe.evaluation.thread.FtpBidFileDownloadThread.FTPCallBack;
import com.gx.obe.listener.UpdateListener;
import com.gx.obe.thread.FTPUpdateThread;
import com.gx.obe.web.entity.RemoteFile;
import com.swtdesigner.ResourceManager;

/**
 * @Description: 
 * @author guoyr
 */
public class UpdateByFtpDialog extends EDialog {
	private Composite itemComposite;
	private Text updateLogText;
//	private EButton updateNowBtn;
	private ImageResolver imageResolver = new ImageResolver();
	private Composite container;
	private int updateType = 0;
	public static final int UPDATE_EXIT = 1;
	public static final int UPDATE_RESTART = 2;
	private Logger LOG = Logger.getLogger(UpdateByFtpDialog.class);
	private ProgressBar progressBar;
	private String INSTRALL_PATH;
	private String versionMessage = null;
	private List<RemoteFile> downLoadFTPFiles;
	private long totalSize;
	private FtpBidFileDownloadThread thread;
	private Composite composite_1;
	private ESepator label_w;
	
	

	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public UpdateByFtpDialog(Shell parentShell, List<RemoteFile> fileList, long totalSize) {
		super(parentShell);
		this.setTitle("系统升级");
		this.totalSize = totalSize;
		this.downLoadFTPFiles = fileList;
		this.setTitleImage(imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/white/update.png"));
		if(null != parentShell.getData("version")){
			versionMessage = (String)parentShell.getData("version");
		}
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	protected Control createDialogArea(Composite parent) {
		container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		
		itemComposite = new Composite(container, SWT.NONE);
		itemComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		itemComposite.setLayout(new GridLayout(1, false));
		
		Composite composite_4 = new Composite(itemComposite, SWT.NONE);
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		composite_4.setLayout(new GridLayout(1, false));
		
		CLabel label_4 = new CLabel(composite_4, SWT.NONE);
		label_4.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/tips.png"));
		label_4.setText("版本日志");
		
		ESepator label_7 = new ESepator(itemComposite, SWT.SEPARATOR | SWT.HORIZONTAL);
		label_7.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label_7.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_3 = new Composite(itemComposite, SWT.NONE);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		FillLayout fl_composite_3 = new FillLayout(SWT.HORIZONTAL);
		fl_composite_3.marginHeight = 5;
		fl_composite_3.marginWidth = 5;
		composite_3.setLayout(fl_composite_3);
		
		updateLogText = new Text(composite_3, SWT.READ_ONLY | SWT.WRAP | SWT.V_SCROLL);
		
		label_w = new ESepator(itemComposite, SWT.SEPARATOR | SWT.HORIZONTAL);
		label_w.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label_w.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		composite_1 = new Composite(itemComposite, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setLayout(new GridLayout(1, false));
		
		progressBar = new ProgressBar(composite_1,  SWT.NONE);
		GridData gd_progressBar = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_progressBar.widthHint = 200;
		progressBar.setLayoutData(gd_progressBar);
//		progressBar.setVisible(false);
		
		init();
		return container;
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init(){
		INSTRALL_PATH = Platform.getInstallLocation().getURL().getPath();
		progressBar.setMaximum(110);
		LOG.debug("系统插件包路径:"+ INSTRALL_PATH);
		LOG.debug("产品安装路径:"+ FileConstants.PRODUCT_ROOT);
		LOG.debug("系统用户路径:"+ FileConstants.SYS_USER_ROOT);
		String versionMessage = PropertiesUtils.getProperty(ConfigConstants.VERSION, "V4.0");
		showUpdateMessage("当前系统版本为：" + versionMessage);
		RemoteFile removeFile = downLoadFTPFiles.get(0);
		String fileName = removeFile.getName();
		String managerVersionMessage = fileName.substring(fileName.indexOf("_")+1);
		String newVersion = managerVersionMessage.substring(0, managerVersionMessage.lastIndexOf("."));
		showUpdateMessage("当前项目经理主机版本为：" + newVersion );
//		showUpdateMessage("正在通过ftp更新版本，请稍后......" );
       thread = new FtpBidFileDownloadThread(downLoadFTPFiles , new FTPCallBack() {
			public void startUpdate(String updateFilePath) {
				new FTPUpdateThread(updateFilePath, new UpdateListener(){
					public void showMessage(String message) {
						showUpdateMessage(message);
					}
					public void update(final boolean updateFlag) {
							updateType = UPDATE_RESTART;
							Display.getDefault().syncExec(new Runnable(){
								public void run(){
									if(!progressBar.isDisposed()){
										progressBar.setVisible(false);
										((GridData)composite_1.getLayoutData()).exclude = true;
										((GridData)label_w.getLayoutData()).exclude = true;
										composite_1.getParent().layout();
										if(updateFlag){
											MessageDialog.openInformation(getShell(), "升级成功，重启后生效！");
											close();
										}
									}
								}
							});
					}
					public void downLoadThreadMessage(String message) {
					}
					public void selectProgressBar(final int value) {
						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								if(!progressBar.isDisposed()){
									progressBar.setSelection(value);
								}
							}
						});
					}
				}).start();
			}
			
			public void callBackString(String returnMessage) {
				showUpdateMessage(returnMessage);
				
			}
			public void callBackConnectOut(String message) {
			}
			public void bidFile(long totalSize, List<RemoteFile> downLoadFTPFiles) {
			}

			public void selectProgressBar(final int value) {
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!progressBar.isDisposed()){
							progressBar.setSelection(value);
						}
					}
				});
			}
		});
		thread.start();
	}
	
	private void showUpdateMessage(final String msg){
		Display.getDefault().syncExec(new Runnable(){
			public void run(){
				if(!updateLogText.isDisposed()){
					updateLogText.append(msg);
					updateLogText.append("\r\n");
					updateLogText.setSelection(updateLogText.getText().length());
				}
			}
		});
	}
	@Override
	public boolean close() {
		imageResolver.disposite();
		return super.close();
	}

	public int getUpdateType() {
		return updateType;
	}

	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(538, 358);
	}
	

	
	
}


