package com.gx.obe.evaluation.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.KeyEnterListener;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.util.utils.MD5Utils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.service.UserService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description:
 * @author guoyr
 */
public class UserVerificationDialog extends EDialog {
	
	private ImageButton confirmBtn;
	private Text account_text;
	private Text pwd_text;
	private Composite password_form;
	private Composite account_form;
	private Image loginBgImage;
	private Composite composite;
	private AuthUser user;
	private boolean verification = false;//用户名密码验证标识
	private UserService userService = new UserService();
	
	/** 
	 * @author chenxw
	 * @param parentShell
	 * @param user 
	 */
	public UserVerificationDialog(Shell parentShell, AuthUser user) {
		super(parentShell);
		this.user = user;
		setTitle("验证身份");
	}
	
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.marginHeight = 10;
		gl_container.marginWidth = 10;
		container.setLayout(gl_container);
		
		composite = new Composite(container, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		GridLayout gl_composite = new GridLayout(1, false);
		composite.setLayout(gl_composite);
		
		account_form = new Composite(composite, SWT.NONE);
		account_form.setBackgroundMode(SWT.INHERIT_FORCE);
		GridData gd_composite_username = new GridData(SWT.CENTER, SWT.CENTER, false, true, 1, 1);
		gd_composite_username.heightHint = 40;
		gd_composite_username.widthHint = 279;
		account_form.setLayoutData(gd_composite_username);
		GridLayout gl_composite_username = new GridLayout(2, false);
		gl_composite_username.horizontalSpacing = 8;
		account_form.setLayout(gl_composite_username);
		
		CLabel lblNewLabel_1 = new CLabel(account_form, SWT.NONE);
		lblNewLabel_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/login/user.png"));
		lblNewLabel_1.setText("");
		
		account_text = new Text(account_form, SWT.NO_BACKGROUND | SWT.DRAW_TAB);
		account_text.setEnabled(false);
		account_text.setEditable(false);
		account_text.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		account_text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		account_text.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		
		password_form = new Composite(composite, SWT.NONE);
		GridData gd_composite_password = new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1);
		gd_composite_password.heightHint = 40;
		gd_composite_password.widthHint = 279;
		password_form.setLayoutData(gd_composite_password);
		GridLayout gl_composite_5 = new GridLayout(2, false);
		gl_composite_5.horizontalSpacing = 8;
		password_form.setLayout(gl_composite_5);
		
		CLabel label_9 = new CLabel(password_form, SWT.VERTICAL);
		label_9.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/login/password.png"));
		label_9.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, false, true, 1, 1));
		
		pwd_text = new Text(password_form, SWT.PASSWORD | SWT.DRAW_TAB);
		pwd_text.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		pwd_text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		pwd_text.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		pwd_text.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent e) {
				if (pwd_text.getText().trim().length() == 0) {
					e.gc.drawText("请输入密码", 1, 0, true);
				}
			}
		});
		
		Composite composite_1 = new Composite(container, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		
		confirmBtn = new ImageButton(composite_1, SWT.NONE);
		confirmBtn.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		confirmBtn.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		GridData gd_confirmBtn = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_confirmBtn.widthHint = 279;
		gd_confirmBtn.heightHint = 40;
		confirmBtn.setLayoutData(gd_confirmBtn);
		confirmBtn.setText("登     录");
		confirmBtn.setBackground(ColorConstants.SKIN_BG);
		confirmBtn.setActiveBgColor(ColorConstants.SKIN_ACTIVE_BG);
//		confirmBtn.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/login/button.png"));
//		confirmBtn.setActiveBgImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/login/buttonhover.png"));
		confirmBtn.setActiveForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		confirmBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				confirmAction();
			}
		});
//		confirmBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/user.png"));
		confirmBtn.setText("验证身份");
		
		init();
		return container;
	}
	
	/**
	 * @Description:
	 * @author guoyr
	 */
	private void init() {
		account_text.setText(user.getUserAccount());
		pwd_text.forceFocus();
		// 加入加回车事件
		new KeyEnterListener(getShell(), new CallBack() {
			@Override
			public void callBack() {
				confirmAction();
			}
		});
		
		composite.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				composite.removePaintListener(this);
				fillBgImage();
			}
		});
	}
	
	/**
	 * @Description: 绘制登录界面的透明背景样式
	 * @author guoyr
	 */
	private void fillBgImage() {
		
		if (null != loginBgImage && !loginBgImage.isDisposed()) {
			loginBgImage.dispose();
		}
		loginBgImage = new Image(null, composite.getBounds().width, composite.getBounds().height);//imageResolver.getImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID,"icons/login/bg.jpg"), shell.getBounds().width, shell.getBounds().height);
		Point accountFormPoint = Display.getDefault().map(account_form, composite, 0, 0);
		Point passwordFormPoint = Display.getDefault().map(password_form, composite, 0, 0);
		
		GC gc = new GC(loginBgImage);
		gc.setForeground(SWTResourceManager.getColor(60, 138, 226));
		gc.setForeground(ColorConstants.SKIN_BG);
		gc.setBackground(ColorConstants.SKIN_BG);
		gc.drawRoundRectangle(accountFormPoint.x, accountFormPoint.y, account_form.getBounds().width, account_form.getBounds().height - 1, 0, 0);
		gc.fillRoundRectangle(accountFormPoint.x, accountFormPoint.y, 40, account_form.getBounds().height, 0, 0);
		gc.drawRoundRectangle(passwordFormPoint.x, passwordFormPoint.y, password_form.getBounds().width, password_form.getBounds().height - 1, 0, 0);
		gc.fillRoundRectangle(passwordFormPoint.x, passwordFormPoint.y, 40, password_form.getBounds().height, 0, 0);
		composite.setBackgroundImage(loginBgImage);
		gc.dispose();
	}
	
	/**
	 * @Description: 验证用户名密码
	 * @author guoyr
	 */
	private void confirmAction() {
		String passWordString = pwd_text.getText().trim();
		if (StringUtils.isEmpty(passWordString)) {
			MessageDialog.openError(getShell(), "请输入密码！");
			pwd_text.setFocus();
			return;
		}
		String password = MD5Utils.getMD5String(passWordString);
		AuthUser tempUser = userService.valLoginNameAndPwd(user.getUserAccount(), password);
		if (null != tempUser) {
			verification = true;
			close();
		} else {
			MessageDialog.openError(getShell(), "您输入的密码错误！");
			pwd_text.setText("");
			pwd_text.setFocus();
			return;
		}
	}
	
	/**
	 * 返回验证结果
	 * 
	 * @return
	 */
	public boolean isVerification() {
		return verification;
	}
	
	public boolean close() {
		if (null != loginBgImage && !loginBgImage.isDisposed()) {
			loginBgImage.dispose();
			loginBgImage = null;
		}
		return super.close();
	}
	
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(450, 203);
	}
	
}
