package com.gx.obe.evaluation.electionExpertLeader;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.RoundBorderLineListener;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.enumeration.ExpertEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.expert.ExpertService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description:
 * @author chenxw
 */
public class ExpertVoteComposite extends Composite {
	
	private ImageResolver imageResolver = new ImageResolver();
	private Image defaultAvatarImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/male_96.png");
	private Image voteImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/flag_red.png");
	private ImageButton avatorLabel;
	private ELink voteLink;
	private Label expert_name;
	private Label professional_title;
	private Label specialty;
	private Label expertType;
	private Composite votes_composite;
	private TenderProjectEntity tenderProject;
	private ExpertService expertService = new ExpertService();
	private int votes;
	private ExpertVoteListener listener;
	private Expert targetExpert;// 要投标的专家
	private Expert curExpert;// 当前专家
	private boolean canRefresh = true;
	
	/**
	 * @author chenxw
	 * @param parent
	 * @param style
	 * @param callBack 
	 */
	public ExpertVoteComposite(Composite parent, int style) {
		super(parent, style);
		
		this.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				imageResolver.disposite();
			}
		});
		this.addPaintListener(new RoundBorderLineListener(6));
		this.setLayout(new GridLayout(2, false));
		
		Composite composite_4 = new Composite(this, SWT.NONE);
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite_4 = new GridLayout(1, false);
		gl_composite_4.horizontalSpacing = 0;
		gl_composite_4.marginHeight = 0;
		gl_composite_4.marginWidth = 0;
		gl_composite_4.verticalSpacing = 0;
		composite_4.setLayout(gl_composite_4);
		
		avatorLabel = new ImageButton(composite_4, SWT.NONE);
		avatorLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		avatorLabel.setImage(defaultAvatarImage);
		
		voteLink = new ELink(composite_4, SWT.NONE);
		voteLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				voteAction();
			}
		});
		voteLink.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		voteLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/hand_point.png"));
		voteLink.setText(Messages.Button_vote);
		
		Composite composite_1 = new Composite(this, SWT.NONE);
		GridData gd_composite_1 = new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1);
		gd_composite_1.widthHint = 200;
		gd_composite_1.minimumHeight = 80;
		composite_1.setLayoutData(gd_composite_1);
		GridLayout gl_composite_1 = new GridLayout(2, false);
		gl_composite_1.horizontalSpacing = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		
		Label label_1 = new Label(composite_1, SWT.NONE);
		label_1.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, true, 1, 1));
		label_1.setText(Messages.FullName + "：");
		label_1.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		expert_name = new Label(composite_1, SWT.NONE);
		GridData gd_nameLabel = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_nameLabel.widthHint = 100;
		expert_name.setLayoutData(gd_nameLabel);
		expert_name.setText("郭永荣");
		
		Label label_2 = new Label(composite_1, SWT.NONE);
		label_2.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
		label_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, true, 1, 1));
		label_2.setText(Messages.ProfessionalTitle+"：");
		label_2.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		professional_title = new Label(composite_1, SWT.NONE);
		professional_title.setText("高级工程师");
		
		Label label_3 = new Label(composite_1, SWT.NONE);
		label_3.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
		label_3.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, true, 1, 1));
		label_3.setText(Messages.Specialty+"：");
		label_3.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		specialty = new Label(composite_1, SWT.WRAP);
		specialty.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		specialty.setText("计算机专业");
		
		Label label_type = new Label(composite_1, SWT.NONE);
		label_type.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
		label_type.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, true, 1, 1));
		label_type.setText(Messages.ExpertType+"：");
		label_type.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		expertType = new Label(composite_1, SWT.WRAP);
		expertType.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		expertType.setText("专家");
		
		Composite composite_2 = new Composite(this, SWT.NONE);
		composite_2.setBackgroundMode(SWT.INHERIT_FORCE);
//		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 2, 1));
		GridLayout gl_composite_2 = new GridLayout(2, false);
		gl_composite_2.marginWidth = 0;
		gl_composite_2.marginHeight = 0;
		composite_2.setLayout(gl_composite_2);
		
		CLabel label = new CLabel(composite_2, SWT.NONE);
		label.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label.setText(Messages.Button_votes+"：");
		
		votes_composite = new Composite(composite_2, SWT.NONE);
		RowLayout rl_votes_composite = new RowLayout(SWT.HORIZONTAL);
		rl_votes_composite.marginBottom = 1;
		rl_votes_composite.marginTop = 1;
		votes_composite.setLayout(rl_votes_composite);
		GridData gd_votes_composite = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_votes_composite.heightHint = 20;
		votes_composite.setLayoutData(gd_votes_composite);
		
	}
	
	
	/**
	 * @Description: 初始化数据
	 * @author chenxw
	 * @param targetExpert
	 * @param curExpert
	 */
	public void initDate(TenderProjectEntity tenderProject, Expert targetExpert, Expert curExpert) {
		this.tenderProject = tenderProject;
		this.targetExpert = targetExpert;
		this.curExpert = curExpert;
		initExpertInfo();
	}
	
	
	/**
	 * @Description: 初始化专家信息
	 * @author chenxw
	 */
	private void initExpertInfo() {
		AuthUser user = targetExpert.getUser();
		if (user == null) user = new AuthUser();
		
		if (null != user.getAvatar()) {
			Image image = imageResolver.getImage(user.getAvatar().getBytes());
			if (null != image) {
				avatorLabel.setImage(image, defaultAvatarImage.getBounds().width, defaultAvatarImage.getBounds().height);
			}
		}
		
		expert_name.setText(ObjectUtils.getObjString(user.getUserName()));
		professional_title.setText(ObjectUtils.getObjString(user.getProfessionalTitle()));
		specialty.setText(ObjectUtils.getObjString(user.getSpecialty()));
		expertType.setText(ObjectUtils.getObjString(targetExpert.getExpertTypeAndRole()));
	}
	
	

	/**
	 * @Description: 投票
	 * @author chenxw
	 */
	private void voteAction() {
		if (!voteLink.getEnabled()) {
			return;
		}
		canRefresh = false;
		voteLink.setEnabled(false);
		redraw();
		if (TenderProjectEnum.GKZB.equals(tenderProject.getTenderMethod()) || TenderProjectEnum.YQZB.equals(tenderProject.getTenderMethod())) {
			if (ExpertEnum.BIDDING.equals(targetExpert.getExpertType())) {
				MessageDialog.openWarning(getShell(), "当前专家为招标代表，不可以推荐为专家组长！");
				return;
			}
		}
		voteLink.setText("正在投票中...");
		voteLink.getParent().layout();
		new Thread(new Runnable(){
			public void run(){
				final boolean voteFlag = expertService.votesExpertLeader(curExpert.getId(), targetExpert.getId());
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!voteLink.isDisposed()){
							voteLink.setText(Messages.Button_vote);
//							voteLink.getParent().layout();
							if (voteFlag) {
								refreshVote(votes++);
								listener.expertVote();
							}else {
								MessageDialog.openInformation(getShell(), Messages.Tips_operateFail);
								voteLink.setEnabled(true);
							}
							redraw();
						}
					}
				});
				canRefresh = true;
			}
		}).start();
		
		
	}
	
	/**
	 * @Description: 刷新得票数
	 * @author chenxw
	 * @param votes
	 */
	public void refreshVote(int votes) {
		if(votes_composite.isDisposed())return;
		this.votes = votes;
		for (Control control : votes_composite.getChildren()) {
			control.dispose();
		}
		// 如果投票数多于5个，则用数字表示
		if (votes > 5) {
			CLabel label = new CLabel(votes_composite, SWT.NONE);
			label.setImage(voteImage);
			label.setFont(SWTResourceManager.getFont("宋体", 12, SWT.BOLD));
			label.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
			label.setText(" * " + votes);
		}else {
			for (int i = 0; i < votes; i++) {
				CLabel label = new CLabel(votes_composite, SWT.NONE);
				label.setImage(voteImage);
			}
		}
		votes_composite.layout();
	}
	
	/**
	 * @Description: 设置是否可投票
	 * @author guoyr
	 * @param canVote
	 */
	public void setVoteEnable(boolean canVote) {
		if(canRefresh) {
			this.voteLink.setEnabled(canVote);
		}
	}
	
	public void redraw() {
		this.voteLink.redraw();
	}
	
	public void addExpertVoteListener(ExpertVoteListener listener) {
		this.listener = listener;
	}
	
	interface ExpertVoteListener {
		void expertVote();
	}
	
	
	protected void checkSubclass() {}
	
}
