package com.gx.obe.evaluation.electionExpertLeader;

import java.util.List;
import java.util.Map;

import com.gx.obe.components.core.enumeration.ExpertEnum;
import com.gx.obe.util.utils.CollectionUtils;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.expert.ExpertService;

/**
 * @Description:刷新专家统计线程
 * @author guoyr
 */
public class RefreshVotesThread implements Runnable {
	
	private ExpertService expertService = new ExpertService();
	
	public Thread thread = null;
	
	private final TenderProjectEntity tenderProject;
	private final RefreshVotesListener listener;


	
	public RefreshVotesThread(TenderProjectEntity tenderProject, RefreshVotesListener listener) {
		this.tenderProject = tenderProject;
		this.listener = listener;
	}
	
	public void run() {
		RefreshVotes refreshVotes = new RefreshVotes();
		
		while (thread != null) {
			List<Expert> expertList = expertService.getExpertByTenderId(tenderProject.getId());
			if (CollectionUtils.isNull(expertList)) {
				continue;
			}
			
			refreshVotes.refreshData(expertList);
			
			listener.refreshExpertVotes(refreshVotes.isCanVote, refreshVotes.votesMap, refreshVotes.turnCount, refreshVotes.noVoteCount);
			
			if (expertService.isExistExpertLeader(tenderProject.getId())) {
				listener.existExpert(expertService.getExpertLeader(tenderProject.getId()).getUser().getUserName());
				break;
			}
			if (refreshVotes.isGenerateLeader()) {
				for (Expert expert : expertList) {
					if(expert.getVotes() == refreshVotes.maxVateCount){
						expert.setIsLeader(ExpertEnum.LEADER_YES);
						expertService.updateAssignProperty(expert, new String[] { "isLeader" });
					}
				}
				listener.existExpert(expertService.getExpertLeader(tenderProject.getId()).getUser().getUserName());
				break;
			}
			try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {}
		}
	}
	
	
	public void start() {
		thread = new Thread(this);
		thread.setName("统计专家投票线程");
		thread.start();
	}
	
	public void stop() {
		thread = null;
	}
	
	interface RefreshVotesListener {
		
		void existExpert(String leaderName);
		
		void refreshExpertVotes(boolean isCanVote, Map<String, Integer> votesMap, int turnCount, int noVoteCount);
		
	}
	
}