package com.gx.obe.evaluation.shell;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.tools.ftp.FtpDownLoadListener;
import com.gx.tools.ftp.FtpDownLoadThread;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 下载投标文件
 * @author guoyr
 */
public class DownloadBidFileShell extends Shell {

	private Label speedLabel;
	private Label messageLabel;
	private ProgressBar progressBar;
	private TenderProjectEntity tenderProjectEntity;
	private String hostname = "127.0.0.1";
	private String username = "anonymous";
	private String password = null;
	private int port = 21; 
	private String downLoadPath;
	private Composite composite_2;
	private CLabel titleLabel;
	private FtpDownLoadThread ftpDownLoadThread;

	/**
	 * @param shell
	 * @param tenderProjectEntity
	 * @param hostname
	 * @param username
	 * @param password
	 * @param port
	 * @param downLoadPath
	 */
	public DownloadBidFileShell(Shell shell, TenderProjectEntity tenderProjectEntity, String hostname, String username, String password, int port, String downLoadPath) {
		super(shell, SWT.NO_TRIM | SWT.ON_TOP);
		this.tenderProjectEntity = tenderProjectEntity;
		this.hostname = hostname;
		this.username = username;
		this.password = password;
		this.port = port;
		this.downLoadPath = downLoadPath;
		setBackground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
		setBackgroundMode(SWT.INHERIT_FORCE);
		setAlpha(230);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 1;
		gridLayout.horizontalSpacing = 1;
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		
		Composite composite_1 = new Composite(this, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 3, 1));
		GridLayout gl_composite_1 = new GridLayout(2, false);
		gl_composite_1.marginWidth = 1;
		gl_composite_1.marginHeight = 1;
		composite_1.setLayout(gl_composite_1);
		
		titleLabel = new CLabel(composite_1, SWT.NONE);
		titleLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		titleLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		titleLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		titleLabel.setText(Messages.Button_downloadBidFile);
		ELabel label = new ELabel(composite_1, SWT.NONE | SWT.SELECTED);
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				close();
			}
		});
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/close.png"));
		label.setText("");
		
		composite_2 = new Composite(this, SWT.NONE);
		composite_2.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.TOP, false, false, 3, 1));
		GridLayout gl_composite_2 = new GridLayout(2, false);
		gl_composite_2.verticalSpacing = 0;
		gl_composite_2.horizontalSpacing = 0;
		gl_composite_2.marginWidth = 0;
		gl_composite_2.marginHeight = 0;
		composite_2.setLayout(gl_composite_2);
		
		CLabel label_2 = new CLabel(composite_2, SWT.NONE);
		label_2.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 1, 1));
		label_2.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/075.png"));
		label_2.setText("");
		
		Composite composite = new Composite(composite_2, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.horizontalSpacing = 0;
		composite.setLayout(gl_composite);
		
		progressBar = new ProgressBar(composite, SWT.NONE);
		GridData gd_progressBar = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_progressBar.widthHint = 205;
		progressBar.setLayoutData(gd_progressBar);
		
		speedLabel = new Label(composite, SWT.WRAP);
		GridData gd_speedLabel = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_speedLabel.widthHint = 91;
		speedLabel.setLayoutData(gd_speedLabel);
		speedLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		speedLabel.setText("0.00B/S");
		
		messageLabel = new Label(composite, SWT.WRAP);
		messageLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		GridData gd_messageLabel = new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1);
		gd_messageLabel.widthHint = 250;
		messageLabel.setLayoutData(gd_messageLabel);
		
		init();
		createContents();
	}
	private void init(){
		SwtUtils.setMouseDragListener(titleLabel);
		SwtUtils.setMouseDragListener(composite_2, true);
		SwtUtils.setMouseDragListener(progressBar.getParent(), true);
		final String remotedir = tenderProjectEntity.getId();
		final FtpDownLoadListener ftpDownLoadListener = new FtpDownLoadListener(){
			
			@Override
			public void info(final String info) {
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!messageLabel.isDisposed()){
							messageLabel.setText(info);
						}
					}
				});
			}

			@Override
			public void error(final String error) {
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!messageLabel.isDisposed()){
							messageLabel.setText(error);
						}
					}
				});
			}

		};
		
		new Thread(new Runnable(){
			public void run(){
				Runnable infoRunnable = new Runnable(){
					public void run(){
						if(!progressBar.isDisposed()){
							speedLabel.setText(ftpDownLoadListener.getSpeed());
							progressBar.setSelection((int)ftpDownLoadListener.getProgress());
						}
					}
				};
				while(true){
					Display.getDefault().syncExec(infoRunnable);
					if(ftpDownLoadListener.isFinish()){
						break;
					}
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
					}
				}
				try {
					Thread.sleep(3000);
				} catch (InterruptedException e) {
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!DownloadBidFileShell.this.isDisposed()){
							close();
						}
					}
				});
			}
		}).start();
		ftpDownLoadThread = new FtpDownLoadThread(hostname, port, username, password, remotedir, downLoadPath, ftpDownLoadListener);
		ftpDownLoadThread.start();
	}

	@Override
	public void close() {
		if(null != ftpDownLoadThread){
			ftpDownLoadThread.stop();
		}
		super.close();
	}

	/**
	 * @Description: 设置面板属性
	 * @author guoyr
	 */
	protected void createContents() {
		setText("");
		setSize(406, 118);
		this.pack();
		SwtUtils.setCenter(this);
		Point location = this.getLocation();
		location.y = 30;
		this.setLocation(location);
		
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
