package com.gx.obe.evaluation.shell;

import java.awt.Dimension;
import java.awt.Toolkit;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.action.utils.ActionUtil;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.evaluation.action.EvaluationViewAction;
import com.gx.obe.evaluation.step.listener.ExpertEvaluationListener;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.listener.WebEntityListener;
import com.gx.obe.web.service.TenderProjectService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;


public class MeetingRoomOpenShell extends Shell implements ActionListener{


	private ImageResolver imageResolver = new ImageResolver();
	private Label tenderNoLabel;
	private Label tenderNameLabel;
	private TenderProjectEntity tenderProject;
	private Composite load_content_composite;
	private Label packageNameLabel;
	private boolean isClose = false;
	private Composite projectComposite;
	private TenderProjectService tenderProjectService ;
	private EvaluationStep evaluationStep;
	private Expert expert;
	private ExpertEvaluationListener expertEvaluationListener;
	private ScreenUtils  util = new ScreenUtils();
	private ImageButton evaluationView_btn;
	{
		LogUtils.logClass(MeetingRoomOpenShell.class);
	}
	
	/**
	 * Create the shell.
	 * @param display
	 */
	public MeetingRoomOpenShell(Shell parentShell, TenderProjectEntity tenderProject, boolean showEvaluationView) {
		super(parentShell, SWT.NO_TRIM);
//		this.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		this.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/about-bg.png"));
		this.setBackground(ColorConstants.SKIN_BG);
		this.setBackgroundMode(SWT.INHERIT_FORCE);
		this.tenderProject = tenderProject;
		this.evaluationStep = (EvaluationStep) parentShell.getData("evaluationStep");
		this.expert = (Expert) parentShell.getData("expert");
		this.expertEvaluationListener = (ExpertEvaluationListener) parentShell.getData("expertEvaluationListener");
		
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				imageResolver.disposite();
			}
		});
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginWidth = 0;
		gridLayout.marginHeight = 0;
		gridLayout.verticalSpacing = 0;
		setLayout(gridLayout);
		
		Composite topComposite = new Composite(this, SWT.NONE);
		topComposite.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_title_bg.png"));
		topComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		
		GridData gd_topComposite = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_topComposite.heightHint = 52;
		topComposite.setLayoutData(gd_topComposite);
		GridLayout gl_topComposite = new GridLayout(4, false);
		gl_topComposite.marginHeight = 0;
		gl_topComposite.marginWidth = 5;
		gl_topComposite.verticalSpacing = 0;
		topComposite.setLayout(gl_topComposite);
		
		projectComposite = new Composite(topComposite, SWT.NONE);
		RowLayout rl_projectComposite = new RowLayout(SWT.HORIZONTAL);
		rl_projectComposite.marginBottom = 0;
		rl_projectComposite.marginTop = 0;
		rl_projectComposite.fill = true;
		projectComposite.setLayout(rl_projectComposite);
		projectComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 2, 1));
		
		Composite composite = new Composite(projectComposite, SWT.NONE);
		RowLayout rl_composite = new RowLayout(SWT.HORIZONTAL);
		rl_composite.fill = true;
		rl_composite.marginBottom = 0;
		rl_composite.marginTop = 0;
		composite.setLayout(rl_composite);
		
		tenderNoLabel = new Label(composite, SWT.NONE);
		tenderNoLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		tenderNoLabel.setForeground(ColorConstants.SKIN_FOREGROUND);
		tenderNoLabel.setText("[ZFCG2014Z0021]");
		
		tenderNameLabel = new Label(composite, SWT.WRAP);
		tenderNameLabel.setForeground(ColorConstants.SKIN_FOREGROUND);
		tenderNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		tenderNameLabel.setText("");
		
		packageNameLabel = new Label(projectComposite, SWT.WRAP);
		packageNameLabel.setForeground(ColorConstants.SKIN_FOREGROUND);
		packageNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		packageNameLabel.setText("");
		
		evaluationView_btn = new ImageButton(topComposite, SWT.NONE);
		evaluationView_btn.setLeftMargin(10);
		evaluationView_btn.setRightMargin(10);
		evaluationView_btn.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		evaluationView_btn.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		evaluationView_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_home.png"));
		evaluationView_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				evaluationViewAction();
			}
		});
		evaluationView_btn.setActiveForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		evaluationView_btn.setLeftOffset(20);
		evaluationView_btn.setRightOffset(20);
		evaluationView_btn.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_mydesk.png"));
		evaluationView_btn.setActiveBgImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_mydesk_on.png"));
		evaluationView_btn.setText("评审视图");
//		evaluationView_btn.setVisible(false);
//		evaluationView_btn.setVisible(null != evaluationStep 
//				&& (evaluationStep.getStepType().equals(EvaluationStepEnum.COMPLIANCE) || evaluationStep.getStepType().equals(EvaluationStepEnum.DETAIL)));
		evaluationView_btn.setVisible(showEvaluationView);
		
		ImageButton backBtn = new ImageButton(topComposite, SWT.NONE);
		backBtn.setLeftMargin(10);
		backBtn.setRightMargin(10);
		backBtn.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		backBtn.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		backBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_home.png"));
		backBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				isClose = true;
				close();
			}
		});
		backBtn.setActiveForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		backBtn.setLeftOffset(20);
		backBtn.setRightOffset(20);
		backBtn.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_mydesk.png"));
		backBtn.setActiveBgImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_mydesk_on.png"));
		backBtn.setText(Messages.Button_backEvalHall);
		
		
		ESepator label = new ESepator(this, SWT.NONE);
		label.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		load_content_composite = new Composite(this, SWT.NONE);
		load_content_composite.setLayout(new FillLayout(SWT.HORIZONTAL));
		load_content_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		load_content_composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		load_content_composite.setBackgroundMode(SWT.INHERIT_FORCE);
		tenderProjectService = new TenderProjectService();
		init();
		createContents();
	}

	/**
	 * @Description: 切换评审视图
	 * @author chenxw 
	 */
	private void evaluationViewAction() {
		Action action = ActionUtil.getAction(EvaluationViewAction.class.getName());
		action.addActionListener(this);
		action.run();
	}

	/**
	 * @Description: 初始化
	 * @author chenxw 
	 */
	private void init() {
		WidgetUtils.setControlVisible(evaluationView_btn, false);
		if (null == tenderProject.getParentId() || tenderProject.getParentId().isEmpty()) {
			tenderNoLabel.setText("[" + tenderProject.getTenderNo() + "]");
			tenderNameLabel.setText(tenderProject.getTenderName());
			packageNameLabel.setText("");
		} else {
			InitThread initThread = new InitThread(tenderProject.getParentId(), new WebEntityListener<TenderProjectEntity>() {
				@Override
				public void run(final TenderProjectEntity parentTender) {
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
						    if (projectComposite.isDisposed()) {
                                return;
                            }
				 			tenderNoLabel.setText("[" + parentTender.getTenderNo() + "]");
							tenderNameLabel.setText(parentTender.getTenderName());
							packageNameLabel.setText(tenderProject.getTenderName());
							projectComposite.layout();
						} 
					});
				}
			});
			initThread.start();
		}
	}

	class InitThread extends MyRunnable{
		private WebEntityListener<TenderProjectEntity> listener;
		private String id;
 		public InitThread(String id ,WebEntityListener<TenderProjectEntity> listener){
			this.listener = listener;	
 			this.id = id;
		}
		@Override
		public void run() {
			TenderProjectEntity curTenderPack = tenderProjectService.getById(id);  
 			listener.run(curTenderPack);
		}
	}
	
	
	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText("["+tenderProject.getTenderNo() + "]"+ tenderProject.getTenderName());
		if(PropertiesUtils.getProperty(ConfigConstants.EVAL_FULL_SCREEN, "00").equals(CommonEnum.YES)) {
			Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); // 取得当前屏幕属性
			int w = d.width; // 获取屏幕宽度
			int h = d.height; // 获取屏幕高度
			setSize(w,h);
		}else {
			setSize(util.getScreenWight(),util.getScreenHight() -util.getTaskBarHight());
		}
		setLocation(0, 0);
	}


	protected void checkSubclass() {
	}
	
	public void onLoad(Action action) {
		for(Control control : load_content_composite.getChildren()){
			control.dispose();
		}
		this.layout();
		
		action.setData("tenderProjectEntity", tenderProject);
		action.setData("evaluationStep", evaluationStep);
		action.setData("expert", expert);
		action.setData("expertEvaluationListener", expertEvaluationListener);
		
	}
	public void loadComposite(Action action, Composite content) {
		
		load_content_composite.layout();
	}
	public Composite getParentComposite() {
		return load_content_composite;
	}

	@Override
	public void close() {
		if(!isClose){
//			if(!load_content_composite.isDisposed()){
//				if(!MessageDialog.openConfirm(getShell(), "确认要返回评标室吗")){
//					return;
//				}
//			}
		}
		super.close();
	}
}
