package com.gx.obe.evaluation.shell;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.ScreenUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class ShowCompareEvaluationShell extends Shell {

	private CLabel label;
	private Browser browser;
	private ScreenUtils util = new ScreenUtils();

	/**
	 * Create the shell.
	 * @param display
	 * @param html 
	 */
	public ShowCompareEvaluationShell(Shell shell) {
		super(shell, SWT.NO_TRIM | SWT.ON_TOP);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		
		Composite composite_2 = new Composite(this, SWT.NONE);
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.verticalSpacing = 0;
		gl_composite_2.horizontalSpacing = 0;
		gl_composite_2.marginHeight = 0;
		gl_composite_2.marginWidth = 0;
		composite_2.setLayout(gl_composite_2);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite_2.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_2.setBackground(ColorConstants.SKIN_BG);
		
		Composite composite = new Composite(composite_2, SWT.NONE);
		composite.setBackground(ColorConstants.SKIN_BG);
		GridLayout gl_composite = new GridLayout(3, false);
		gl_composite.marginHeight = 0;
		gl_composite.verticalSpacing = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		label = new CLabel(composite, SWT.NONE);
		label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/enlarge.png"));
		label.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		label.setText("评审点内容对比");
		
		ELabel close_btn = new ELabel(composite, SWT.NONE | SWT.SELECTED);
		close_btn.setForeground(ColorConstants.FONT_BLACK_COLOR);
		close_btn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		close_btn.setText(Messages.Button_close);
		close_btn.setActiveColor(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		close_btn.setAlpha(10);
		close_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				close();
			}
		});
		
		Composite composite_1 = new Composite(composite_2, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.verticalSpacing = 0;
		gl_composite_1.horizontalSpacing = 0;
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		browser = new Browser(composite_1, SWT.NONE);
		browser.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		init();
		
		createContents();
	}

	private void init() {
		SwtUtils.setMouseDragListener(label);
	}
	
	public void refresh(String html) {
		browser.setText(html);
	}
	
	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText("评审点对比");
		setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/evaluation-ico.png"));
	}

	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	
	public static void main(String[] args) {
		String platform = SWT.getPlatform();
		System.out.println(platform);
	}

	public void refreshLocationAndSize() {
		setSize(1240, 800);
		setLocation(util.getScreenWight() / 2 - 620, util.getScreenHight() / 2 - 400);
	}
	
}
