package com.gx.obe.evaluation.shell;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.file.entity.BidFile;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.tools.ca.CaInfo;
import com.gx.tools.ole.DocumentFactory;
import com.gx.tools.ole.DocumentLoader;
import com.gx.tools.utils.CaInfoUtil;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 显示投标人评审点
 * @author guoyr
 */
public class ShowCompareSupplierBidFileShell extends Shell {
	
	private Composite composite;
	private Composite supplierListComposite;
	private List<Supplier> compareSupplierList = new ArrayList<Supplier>();
	private Composite topComposite;
	private ScreenUtils  util = new ScreenUtils();
	private int screenHight;
	private TenderProjectEntity tenderProjectEntity;
	private Composite show_bidFile_composite;
	private Map<String, BidFile> map;
	private ELink label_2;
	private Shell shell;
	/**
	 * @param shell
	 * @param evalPointListener
	 */
	public ShowCompareSupplierBidFileShell(Shell shell, TenderProjectEntity tenderProjectEntity) {
		super(shell, SWT.NO_TRIM);
		this.shell = shell;
		setBackgroundMode(SWT.INHERIT_FORCE);
		setBackground(ColorConstants.BORDER_LINE_COLOR);
		this.tenderProjectEntity = tenderProjectEntity;
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		topComposite = new Composite(this, SWT.NONE);
		topComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		topComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_topComposite = new GridLayout(1, false);
		gl_topComposite.verticalSpacing = 0;
		gl_topComposite.horizontalSpacing = 0;
		gl_topComposite.marginWidth = 0;
		gl_topComposite.marginHeight = 0;
		topComposite.setLayout(gl_topComposite);
		topComposite.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_title_bg.png"));
		topComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		
		composite = new Composite(topComposite, SWT.NONE);
		GridLayout gl_composite = new GridLayout(3, false);
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label messageLiabel = new Label(composite, SWT.NONE);
		messageLiabel.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		messageLiabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		messageLiabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		messageLiabel.setText("标书对比");
		
		label_2 = new ELink(composite, SWT.NONE);
		label_2.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				getShell().setMinimized(true);
			}
		});
		label_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_2.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/min_size.png"));
		ELink cancelLink = new ELink(composite, SWT.NONE);
		cancelLink.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		cancelLink.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		cancelLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/close.png"));
		cancelLink.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		cancelLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				cancelAction();
			}
		});
		cancelLink.setText("");
		
		
		
		show_bidFile_composite = new Composite(this, SWT.NONE);
		show_bidFile_composite.setLayout(new GridLayout(1, false));
		show_bidFile_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		init();
		createContents();
	}

	/**
	 * @Description: 初始化界面
	 * @author guoyr
	 */
	private void init(){
		// 设置拖拽
		SwtUtils.setMouseDragListener(composite);
		
	}
	/**
	 * @Description: 关闭
	 * @author guoyr
	 */
	public void cancelAction() {
		
		getShell().close();
	}
	
	protected void createContents() {
		setText("");
		
		if(PropertiesUtils.getProperty(ConfigConstants.EVAL_FULL_SCREEN, "00").equals(CommonEnum.YES)) {
			screenHight = util.getScreenHight();
		}else {
			screenHight = util.getScreenHight() -util.getTaskBarHight();
		}
//		shell.getDisplay().getSystemTray().
		
		setSize(util.getScreenWight(),screenHight);
		setLocation(0, 0);
	}
	/**
	 * @Description: 刷新列表
	 * @author guoyr
	 * @param compareSupplierList_temp 
	 */
	public void reflashSupplierList(List<Supplier> compareSupplierList_temp, Map<String, BidFile> map_temp){
		compareSupplierList.addAll(compareSupplierList_temp);
		this.map = map_temp;
		for(Control control : show_bidFile_composite.getChildren()){
			control.dispose();
		}
		if(null != compareSupplierList && compareSupplierList.size() > 0){
			
			supplierListComposite = new Composite(show_bidFile_composite, SWT.NONE);
			GridLayout gl_supplierListComposite = new GridLayout(compareSupplierList.size(), false);
			gl_supplierListComposite.horizontalSpacing = 10;
			supplierListComposite.setLayout(gl_supplierListComposite);
			supplierListComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			for(final Supplier supplier : compareSupplierList){
				
				final Composite parentComposite = new Composite(supplierListComposite, SWT.NONE);
				GridLayout gl_parentComposite = new GridLayout(1, false);
				gl_parentComposite.verticalSpacing = 0;
				gl_parentComposite.horizontalSpacing = 0;
				gl_parentComposite.marginHeight = 1;
				gl_parentComposite.marginWidth = 1;
				parentComposite.setLayout(gl_parentComposite);
				parentComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
				parentComposite.setBackground(ColorConstants.ENENT_LINE_COLOR);
				
				Composite composite_1 = new Composite(parentComposite, SWT.NONE);
				GridLayout gl_composite_1 = new GridLayout(1, false);
				gl_composite_1.verticalSpacing = 0;
				gl_composite_1.horizontalSpacing = 0;
				gl_composite_1.marginHeight = 0;
				gl_composite_1.marginWidth = 0;
				composite_1.setLayout(gl_composite_1);
				composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
				composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
				
				Composite messageShowComposite = new Composite(composite_1, SWT.NONE);
				messageShowComposite.setLayout(new GridLayout(2, false));
				messageShowComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
				
				Label label = new Label(messageShowComposite, SWT.WRAP);
				label.setFont(SWTResourceManager.getFont("微软雅" +
						"黑", 12, SWT.NORMAL));
				label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
				label.setText(supplier.getSupplierName());
				
				ELink label_1 = new ELink(messageShowComposite, SWT.NONE);
				label_1.addMouseListener(new MouseAdapter() {
					@Override
					public void mouseUp(MouseEvent e) {
						deleteComposite(parentComposite, supplier);
					}
				});
				label_1.setText(Messages.Button_delete);
				label_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"));
				ESepator sepator = new ESepator(composite_1, SWT.NONE);
				sepator.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
				sepator.setBackground(ColorConstants.SEP_LIGHT_COLOR);
				sepator.setLineWidth(2);
				Composite composite_4 = new Composite(composite_1, SWT.NONE);
				composite_4.setLayout(new FillLayout(SWT.HORIZONTAL));
				composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
				
				
				BidFile bidFile = map.get(supplier.getId());
				if(null != bidFile){
					openAndLocationBidFile(supplier.getId(), bidFile, "", 0, composite_4);
					composite_4.layout();
				}
			}
		}
		show_bidFile_composite.layout();
	}
	
	
	
	/**
	 * @Description: 
	 * @author guoyr
	 * @param composite
	 * @param supplier 
	 */
	private void deleteComposite(Composite composite, Supplier supplier){
		composite.dispose();
		compareSupplierList.remove(supplier);
		if(compareSupplierList.size() < 1){
			shell.close();
		}else{
			supplierListComposite.layout();
		}
		
	}
	/**
	 * @Description: 打开并定位投标文件
	 * @author guoyr
	 * @param ID
	 * @param bidFile
	 * @param bookmark
	 * @param pageNumber
	 * @return 
	 */
	private DocumentLoader openAndLocationBidFile(String ID, File bidFile, String bookmark, int pageNumber, Composite composite){
		CaInfo caInfo = CaInfoUtil.getCaType(tenderProjectEntity.getId(), ID);
		String pdfType = caInfo.getPdfType();
		DocumentLoader documentLoader = null;
		documentLoader = DocumentFactory.getDocumentLoader(bidFile.getAbsolutePath(), pdfType);
		documentLoader.openDocument(composite, true);
		return documentLoader;
	}
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
